C       main test program
        implicit none
	include 'model.inc'
C	integer grid,grid_map,grid_size,grid_pts
C	real*8 grid_rot,E,E_b,E_c
C	real*4 b_occup,c_occup,anisot,angle
C Array sizes and initialization values for above in 'model.inc'
	integer i,j,k,l,m,n_of_temp,ll,n_steps,K_accpt,KMAX
	integer move_list(800),n_move,N_TYPE(800)
	real*8  alpha,beta,gamma,temperature,ddelta/0.0/,t_check,t_check2,
	2	ddelta_2/0.0/
C	character*30 dname, sname
	character*30 new_name,node*4
	INTEGER SEED,n_temps,n_up_succ,n_up_fail
	INTEGER Nequ, Nave, site, io_driver, kstep, cycle
	integer n_fail,n_succ,move,n_fold,filling,n_move_old
	real*4 b_occup_frac,c_occup_frac,accpt,accpt_in,T
	real*8 AVE_E, AVE_E2, DELTA_E, theta_new ,d_energy
        real*8 theta_max,theta_final,theta0,theta_step,theta_factor
        real*8 e_new,e_old,t_energy,energy,t_e_old,Del_E, Del_E_sum
	real*4 xy_max(2),xy_final(2),xy_factor,radmin_in,radmax_in,
	2 rad0,rad1
	logical*1 input_flag,hardcopy,graphics,stop_flag,
	2 save_data_flag,reset_flag,screen_flag,dopant_flag
	logical*1 x_move_flag,y_move_flag,rotate_flag,flag,distort_flag
	logical*1 rotate_init_flag,distort_init_flag,dopant_init_flag
	logical*1 sf_flag,batch,check_flag/.false./

        real*8 PI, twopi  !pi, 2*pi    

        real*8 order1, order2, order3   !order parameters              
        real*8 order_1, order_2,order_3          !order parameters              
        real*8 order, Ave_Order        !order parameters              
        real*8 Ave_order1, Ave_Order2,Ave_order3 !order parameters 
        real*8 rot1, rot2, rot3        !angle of rotors in three sublattice
        real*8 ord1, ord2, ord3, ord4  !order parameters  
        real*8 ord1_c, ord2_c, ord3_c  !cos term of order par
        real*8 ord1_s, ord2_s, ord3_s  !sin term of order par
        real*8 Sum_ord1,Sum_ord2,Sum_ord3,Sum_ord4  !square of order par     
        real*8 Ave_ord1,Ave_ord2,Ave_ord3,Ave_ord4  !Ave of order par
        real*8 Sqr_ord1,Sqr_ord2,Sqr_ord3,Sqr_ord4  !square of order par     
        real*8 Rms_ord1,Rms_ord2,Rms_ord3,Rms_ord4  !Ave of order par
        real*8 Sus_ord1,Sus_ord2,Sus_ord3,Sus_ord4  !susceptibilities
        real*8 Rms_E, C                !C: heat capacity
        real*8 sf, tot_sf, ave_sf        !C: heat capacity
        integer X, Y, Z, L1, L2, L3

	parameter(PI=3.141592653589793238)
        twopi=2.0d0*pi

	radmin_in=0.7
	radmax_in=1.3
	xy_max(1)=.1
	xy_max(2)=.1
C
C ************************************************************
C
C	Initial Conditions
C
C **********************************************************
C
	call get_mc_parameters(input_flag,stop_flag,
	2 alpha,beta,gamma,ddelta,ddelta_2,io_driver,seed,temperature,
	2 b_occup_frac,c_occup_frac,graphics,hardcopy,Nequ,Nave,
	2 save_data_flag,reset_flag,screen_flag,rotate_flag,
	2 dopant_flag,n_fold,filling,batch,
	2 x_move_flag,y_move_flag,distort_flag,rotate_init_flag,
	2 dopant_init_flag,distort_init_flag,sf_flag,rad0,rad1,node)
	 if (input_flag.eq..false.) then
 	 write(5,*)
 	 write(5,*) 'Hamiltonian parameters: alpha, beta, gamma'
 	 read(5,*) alpha,beta,gamma
C
	 WRITE(5,*) 'Enter the occuppied B and C site fractions:'
	 READ(5,*) b_occup_frac,c_occup_frac
         
	 write(5,*) 'Enter structure factor template 1(tp), 2(mjw):'
	 read(5,*) io_driver
	 new_name='sf_mc'

 	 WRITE(5,*) 'Enter the seed number:'
 	 READ(5,*) SEED
C     
	 WRITE(5,*) 'Enter the temperature:'
	 READ(5,*) temperature
C
C
	 WRITE (5,*) 'Enter the number of equilibration cycles:'
	 READ(5,*) Nequ
C
	 WRITE(5,*) 'Enter the number of averaging cycles'
	 READ(5,*) Nave
	 end if
C
	CALL set_up_norm_grid
	CALL set_up_nnn_grid
	CALL set_up_nnnn_grid
        CALL set_up_rot

	if (filling.ge.0) 
	2 call MC_INITIALIZE(seed,b_occup_frac,c_occup_frac,filling)
	n_steps=0

	  if (screen_flag.eq. .true.) THEN
	  write( 5,'(1x,A48)')
	2 '------------------------------------------------'
	  write( 5,'(4x,A48)') 
	2 '  alpha      beta     gamma    delta (1 and 2)  '
	  write( 5,'(1x,4F10.3)')  alpha,beta,gamma,ddelta,ddelta_2
	  write( 5,'(4x,A30)') 'b_occup    c_occup            '
	  write( 5,'(1x,2F10.3)') b_occup_frac,c_occup_frac
	  write( 5,'(4x,A30)') 'anisotropy    angle           '
	  write( 5,'(1x,2F10.3)') anisot,angle
	  write( 5,'(1x,'' Temperature='',F10.3)') temperature
	  write( 5,'(1x,'' Nave='',I6,'' Nequ='',I6)') Nave,Nequ
	  type *, ' I/O_driver=',io_driver
	  end if
C
C----------------------------------------------------------------------
C	This is the main loop that cycles through the
C	different temperatures or coefficient values
C----------------------------------------------------------------------
C
	  call set_up_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1
	2 ,t_energy,n_fold)
	  call set_up_io_page(new_name,IO_DRIVER,n_fold)

  	    if (graphics .eq. .true.) then
		if (batch .eq. .true. .and. node .eq. 'comb') then
		continue
		else
		call mc_grid_plot(batch)
		call PLOT_N_FOLD(n_fold)
		call plot_dopant
		call plot_mc_info(alpha,beta,gamma,ave_e,delta_e,
	2	n_steps,temperature,ddelta,ddelta_2,rad0,rad1)
		end if
 	      end if


	  DO WHILE (stop_flag.eq..false.)
	  cycle=cycle+1

	if (filling.ge.0) 
	2 call MC_INITIALIZE(seed,b_occup_frac,c_occup_frac,filling)

	  if (screen_flag.eq..true.) type *, 'Cycle =:',cycle

	    if (reset_flag .eq. .true.)  then
	  call set_up_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1
	2 ,t_energy,n_fold)
	      end if
	    if (save_data_flag.eq..true.) THEN
C                         123456789012345678901234567890
	    write(16,'(1x,A48)') 
	2	'------------------------------------------------'
	    write(16,'(4x,A48)') 
	2 	'  alpha      beta     gamma    delta (1 and 2)  '
	    write(16,'(1x,4F10.3)')  alpha,beta,gamma,ddelta,ddelta_2
	    write(16,'(4x,A30)') 'b_occup    c_occup            '
	    write(16,'(1x,2F10.3)') b_occup_frac,c_occup_frac
	    write(16,'(1x,'' Temperature='',F10.3)') temperature
	    write(16,'(1x,'' Nave='',I6,'' Nequ='',I6)') Nave,Nequ
	    end if

	  t_energy=0.d0
	    do site=1,grid_pts
	    t_energy=t_energy+e(site)
	    end do
	  t_E_old=t_energy
	  Del_E_sum=0.d0

	  if (screen_flag.eq..true.) then
	  write(5,*) 'Initial per site Energy = ', t_energy/dble(grid_pts)
          end if

	    KSTEP=4
C ************************************************************
C	This section of code finds theta_max so that the (number
C	of successful uphill moves)/(number of tries uphill)=1/2.
C ************************************************************

 	  if (rotate_init_flag.eq. .true.) then
	    if (screen_flag) type *, 'Rotation initialization'
	    theta_max =PI
	    theta_final=0.0d0
	    accpt_in=0.5
	    K_accpt=40

C 	      t_e_old=t_energy+del_e_sum
C 		 t_check2=0.d0
C 		 DO LL=1,grid_pts
C 		 t_check2=t_check2+e(ll)
C 		 end do
C  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
C  	type *, t_E_old, t_check, t_check2


	    CALL INITIALIZE_METROP(t_E_old,accpt_in,graphics,
	2   screen_flag,KSTEP,K_accpt,theta_max,alpha,beta,gamma,
	2   seed,temperature,theta_final,save_data_flag,Del_E_sum,
	2   ddelta,ddelta_2,rad0,rad1,n_fold,batch,node)

	if (check_flag.eq. .true.) then
 	      t_e_old=t_energy+del_e_sum
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
  	type *, t_E_old, t_check, t_check2
	end if

	    rotate_init_flag=.false.
	    END if

C ************************************************************
C	This section of code finds xy_max so that the (number
C	of successful uphill moves)/(number of tries uphill)=1/2.
C ************************************************************
	  if (distort_init_flag.eq. .true.) then
	  if (screen_flag) type *, 'Distortion initialization'

	if (check_flag.eq. .true.) then
 	      t_e_old=t_energy+del_e_sum
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
  	type *, t_E_old, t_check, t_check2
	end if

	    do J=1,2
	    xy_factor=0.5
	    if (J.eq.1) flag=x_move_flag
	    if (J.eq.2) flag=y_move_flag
	    move=J
	    xy_final(J)=0.
 	      if (flag .eq. .true.) then
	      KSTEP=4
	      KMAX=10
	        DO K=1,8

	if (check_flag.eq. .true.) then
 	      t_e_old=t_energy+del_e_sum
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
  	type *, t_E_old, t_check, t_check2
	end if

	        n_succ=0
	        n_fail=0

	          DO I=1,KMAX  ! Was 20
	            DO L=1,grid_pts
	            site=L
		Call METROP_XY(alpha,beta,gamma,xy_max(J),Del_E,site,
	2       temperature,seed,n_succ,n_fail,move,radmin_in,
	2       radmax_in,ddelta,ddelta_2,n_fold,0,t_energy+del_E_sum,
	2	rad1,rad0,.false.)
	            Del_E_sum=Del_E_sum+Del_E
	            end do
	          end do
	        ACCPT=dble(n_succ)/dble(n_succ+n_fail)
	        IF (ACCPT .LT. 0.5) THEN
	          xy_max(J)=xy_max(J)*xy_factor
	          ELSE
	          xy_factor=0.9
	          xy_max(J)=xy_max(J)*1.1
	          ENDIF
	        if (xy_max(J) .GT. 0.3) xy_max(J)=0.3
	          if ((K/KSTEP)*KSTEP .eq. K ) then
 	            if (graphics.eq. .true.) then 
			if (batch.eq. .true. .and. node .eq. 'comb') then
			continue
			else
c	      	        call disable_graphics
	                call PLOT_N_FOLD(n_fold)
	                call plot_dopant
c	      	        call enable_graphics
			end if
 	            end if

	          IF (screen_flag.eq..true.) 
	2         type *, 'xy_max=',xy_max(J), 'acceptance=', accpt, 
	2	  'E=',t_E_old
			if (check_flag.eq. .true.) then
			t_e_old=t_energy+del_e_sum
			t_check2=0.d0
 		 	  DO LL=1,grid_pts
			  t_check2=t_check2+e(ll)
			  end do
		call total_energy(alpha,beta,gamma,ddelta,ddelta_2,
	2		rad0,rad1,t_check)
			type *, t_E_old, t_check, t_check2
			end if
	          IF (save_data_flag.eq..true.) write(16,*)
	2         'theta_max=',xy_max(J), 'acceptance=', accpt
	          end if
	        IF (K .GT. KMAX-5) xy_final(J)=xy_final(J)+xy_max(J)
	        end do	
	      end if
C Average together the last 15 trials to get a mean
	    IF (xy_final(J).ne.0) xy_max(J)=xy_final(J)/5.
	    IF (screen_flag.eq..true.) 
	2   type *, 'xy_max(',J,')=',xy_max(J), 'acceptance=', accpt
	    IF (save_data_flag.eq..true.) write(16,*)
	2           'xy_max(',J,')=',xy_max(J), 'acceptance=', accpt
	    end do
	  distort_init_flag=.false.
C
C Get proper B and C sublattice sites (unoccuppied sites are not
C	updated but all are called)
            do I=1,grid_pts
	    site=I
	    call B_site_position(site)
	    call C_site_position(site)
	    end do
	  end if


	  if (dopant_init_flag.eq. .true.) then


			if (check_flag.eq. .true.) then
			t_e_old=t_energy+del_e_sum
			t_check2=0.d0
 		 	  DO LL=1,grid_pts
			  t_check2=t_check2+e(ll)
			  end do
		call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,
	2		t_check)
			type *, t_E_old, t_check, t_check2
			end if

	    if (screen_flag) then
		type *, 'Dopant initialization'
	    end if

	      t_E_old=t_energy+Del_E_sum

	    do j=1,5
	      do K= 1,grid_pts
	      site=K
	     Call METROP_D(alpha,beta,gamma,Del_E,site,temperature,seed,
	2    move_list,n_move,n_type,rad0,rad1,ddelta,ddelta_2,theta_max,
	2 distort_flag,x_move_flag,y_move_flag,radmin_in,radmax_in,
	2 t_E_old,rotate_flag,xy_max(1),xy_max(2))
	      Del_E_sum=Del_E_sum+Del_E
	      t_E_old=t_energy+Del_E_sum
	      end do


	      if ((J/kstep)*kstep .eq. J) then
 	        if (graphics.eq. .true.) then
c	        call disable_graphics
		  if (batch.eq. .true. .and. node .eq. 'comb') then
		  n_move_old=n_move
		  n_move=0
		  else
	          call plot_dopant
	          call plot_moves(move_list,n_move,n_type)
 	          call PLOT_N_FOLD(n_fold)
	          n_move=0
		  end if
c	        call enable_graphics
 	        end if
	      IF (screen_flag.eq..true.)
	2     type *, 'Energy ave: ', t_E_old/dble(grid_pts)
	      IF (save_data_flag.eq..true.) write(16,*)
	2      	'Energy ave: ', t_E_old/dble(grid_pts)

	if (check_flag.eq. .true.) then
 	      t_e_old=t_energy+del_e_sum
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
  	type *, t_E_old, t_check, t_check2
	end if

	      end if
            end do

C
C Get proper B and C sublattice sites (unoccuppied sites are not
C	updated but all are called)
            do I=1,grid_pts
	    site=I
	    call B_site_position(site)
	    call C_site_position(site)
	    end do

	  dopant_init_flag=.false.
	  end if
	
	
C ************************************************************
C
C	This section of code will give the array time to equilibrate
C	This is done by the Metropolis rule for Nequ cycles through
C	the array without taking averages of any parameters.
C
C ************************************************************
C
C
	kstep=Nequ/10
	if (kstep.eq.0) kstep=Nequ
	if (kstep.eq.0) kstep=1

	    DO J=1,Nequ

	if (check_flag.eq. .true.) then
 	      t_e_old=t_energy+del_e_sum
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
  	type *, t_E_old, t_check, t_check2
	end if

	    n_steps=n_steps+1
	    n_up_succ=0
	    n_up_fail=0
	    n_succ=0
	    n_fail=0

	      if (rotate_flag.eq..true.) then
	      if (screen_flag .eq. .true. .and. J .eq. 1) 
	2		type *, 'Rotation'
	        DO K=1,grid_pts
	        site=K
	        call METROP(alpha,beta,gamma,theta_max,Del_E,site,
	2       temperature,seed,n_up_succ,n_up_fail,0)
	        Del_E_sum=Del_E_sum+Del_E
	        t_E_old=t_energy+Del_E_sum
C	        t_E_old=t_E_old+Del_E ! no double counting requirements
                end do
	      end if
C
	      if (dopant_flag.eq..true.) then
	      if (screen_flag.eq..true. .and. J .eq. 1) 
	2 		type *, 'Dopant motion'
	      d_energy=t_energy+del_e_sum
	        DO K= 1,grid_pts
	        site=K
	        Call METROP_D(alpha,beta,gamma,Del_E,site,temperature,seed,
	2 	move_list,n_move,n_type,rad0,rad1,ddelta,ddelta_2,theta_max,
	2 distort_flag,x_move_flag,y_move_flag,radmin_in,radmax_in,
	2 d_energy,rotate_flag,xy_max(1),xy_max(2))
	        Del_E_sum=Del_E_sum+Del_E
	        t_E_old=t_energy+Del_E_sum
	        end do
	      end if

	      if (distort_flag.eq. .true.) then
	      if (screen_flag .eq. .true. .and. J .eq. 1) 
	2 		type *, 'Lattice distortion '
		  DO L=1,grid_pts
		  site=L
		    if (x_move_flag.eq..true.) then
		    move=1
		  Call METROP_XY(alpha,beta,gamma,xy_max(1),Del_E,site,
	2         temperature,seed,n_succ,n_fail,move,radmin_in,
	2         radmax_in, ddelta,ddelta_2,n_fold,0,t_E_old,
	2	  rad1,rad0,.false.)
	            Del_E_sum=Del_E_sum+Del_E
	            t_E_old=t_energy+Del_E_sum
                    end if

		    if (y_move_flag.eq..true.) then
		    move=2
		  Call METROP_XY(alpha,beta,gamma,xy_max(2),Del_E,site,
	2         temperature,seed,n_succ,n_fail,move,radmin_in,
	2         radmax_in, ddelta,ddelta_2,n_fold,0,t_E_old,
	2	  rad1,rad0,.false.)
	            Del_E_sum=Del_E_sum+Del_E
	            t_E_old=t_energy+Del_E_sum
		    end if
	          end do
C
C Get proper B and C sublattice sites (unoccuppied sites must
C	be updated)
                do I=1,grid_pts
	        site=I
	        if (b_occup(i).eq.0.) call B_site_position(site)
	        if (c_occup(i).eq.0.) call C_site_position(site)
	        end do

	      end if

	      if ((J/kstep)*kstep .eq. J) then
 	        if (graphics .eq. .true.) then
c	        call disable_graphics
		  if (batch .eq. .true. .and. node .eq. 'comb') then
		  n_move_old=n_move
		  n_move=0
		  else
		  if (dopant_flag .eq. .true. .or. 
	2	    distort_flag .eq. .true.) then
		    call plot_dopant
		    end if
		  if (dopant_flag .eq. .true.) then
		    call plot_moves(move_list,n_move,n_type)
	      	    n_move=0
		    end if
		  if (rotate_flag .eq. .true. .or. distort_flag .eq.
	2	    .true. .or. dopant_flag .eq. .true.) then
		    call PLOT_N_FOLD(n_fold)
		    end if
c	        call enable_graphics
		end if
 		end if
	        IF (screen_flag.eq..true.)
	2       type *, 'Energy ave: ', t_E_old/dble(grid_pts)
	        IF (save_data_flag.eq..true.) write(16,*)
	2       	'Energy ave: ', t_E_old/dble(grid_pts)
	      end if



	    end do


	        IF (screen_flag.eq..true.)
	2       type *, 'Equilibration over '
	        IF (save_data_flag.eq..true.) write(16,*)
	2       'Equilibration over '
C
C ************************************************************
C
C	This section of code will average properties of the array
C	This is done by the Metropolis rule for Nave cycles through
C	the array taking averages of any parameters.
C
C ************************************************************
C
C          TPIT = 2.0d0*PI/dble(n_fold)

	  AVE_E =0.0d0
	  AVE_E2 =0.0d0

          Ave_ord1=0.0d0
          Ave_ord2=0.0d0
          Ave_ord3=0.0d0
          Ave_ord4=0.0d0

          Sqr_ord1=0.0d0
          Sqr_ord2=0.0d0
          Sqr_ord3=0.0d0
          Sqr_ord4=0.0d0

c         Ave_Order=0.0d0
c         Ave_Order1=0.0d0
c         Ave_Order2=0.0d0
c         Ave_Order3=0.0d0

          tot_sf=0.0d0

	  kstep=Nave/10
	  if (kstep.eq.0) kstep=Nave
	  if (kstep.eq.0) kstep=1
          Write(19,*) '  '
          Write(19,191) temperature
191       FORMAT('Temperature=',F7.3)	    

	    DO j=1,Nave
                ord1_c = 0.0d0
                ord1_s = 0.0d0
                ord2_c = 0.0d0
                ord2_s = 0.0d0
                ord3_c = 0.0d0
                ord3_s = 0.0d0
	      n_steps=n_steps+1
	      if (rotate_flag.eq..true.) then
	        DO L=1,grid_pts
	        site=L
	        call METROP(alpha,beta,gamma,theta_max,Del_E,site,
	2       temperature,seed,n_up_succ,n_up_fail,0)
	        Del_E_sum=Del_E_sum+Del_E
	        t_E_old=t_energy+Del_E_sum
                end do
	      end if

c             order_1=0.0d0
c             order_2=0.0d0
c             order_3=0.0d0
c             DO L=1,144
c               Call Model_Ord(L,Order1,Order2,order3)
c               order_1=order_1+order1
c               order_2=order_2+order2
c               order_3=order_3+order3
c             END DO

              DO L=1,141,3
                z=(L/12)
                if(z.eq.0.or.z.eq.3.or.z.eq.6.or.z.eq.9)then 
                  rot1=grid_rot(L)   
                  rot2=grid_rot(L+1)   
                  rot3=grid_rot(L+2)   
                else if(z.eq.1.or.z.eq.4.or.z.eq.7.or.z.eq.10)then 
                  rot1=grid_rot(L+2)   
                  rot2=grid_rot(L)   
                  rot3=grid_rot(L+1)   
                else if(z.eq.2.or.z.eq.5.or.z.eq.8.or.z.eq.11)then 
                  rot1=grid_rot(L+1)   
                  rot2=grid_rot(L+2) 
                  rot3=grid_rot(L)   
                end if

                rot1=dmod(rot1,twopi)
                rot2=dmod(rot2,twopi)
                rot3=dmod(rot3,twopi)

                ord1_c=ord1_c +dcos(3.0d0*rot1)
                ord1_s=ord1_s +dsin(3.0d0*rot1)

                ord2_c=ord2_c +dcos(3.0d0*rot2)
                ord2_s=ord2_s +dsin(3.0d0*rot2)

                ord3_c=ord3_c +dcos(3.0d0*rot3)
                ord3_s=ord3_s +dsin(3.0d0*rot3)
              
                 IF(j .eq. Nave) THEN
                   CALL NORM_ANG_ROT(rot1)
                   CALL NORM_ANG_ROT(rot2)
                   CALL NORM_ANG_ROT(rot3)
                   rot1=rot1*180.0d0/pi
                   rot2=rot2*180.0d0/pi
                   rot3=rot3*180.0d0/pi
                   write(19,1234) L,rot1,rot2,rot3
1234               format(I4,3F11.3)
                 END IF 
               END DO

c              CALL model_sf(sf)
c              tot_sf=tot_sf+sf

	      if (dopant_flag.eq..true.) then
	      d_energy=t_energy+del_e_sum
	        do L= 1,grid_pts
	        site=L
	        Call METROP_D(alpha,beta,gamma,Del_E,site,temperature,seed,
	2 	move_list,n_move,n_type,rad0,rad1,ddelta,ddelta_2,theta_max,
	2 distort_flag,x_move_flag,y_move_flag,radmin_in,radmax_in,
	2 d_energy,rotate_flag,xy_max(1),xy_max(2))

	        Del_E_sum=Del_E_sum+Del_E
	        t_E_old=t_energy+Del_E_sum
	        end do
	      end if

	      if (distort_flag.eq. .true.) then

		DO L=1,grid_pts
		site=L
		  if (x_move_flag.eq..true.) then
		  move=1
		Call METROP_XY(alpha,beta,gamma,xy_max(1),Del_E,site,
	2       temperature,seed,n_succ,n_fail,move,radmin_in,
	2       radmax_in, ddelta,ddelta_2,n_fold,0,t_E_old,
	2	rad1,rad0,.false.)
	          Del_E_sum=Del_E_sum+Del_E
	          t_E_old=t_energy+Del_E_sum
		  end if

		  if (x_move_flag.eq..true.) then
 		  move=2
		Call METROP_XY(alpha,beta,gamma,xy_max(2),Del_E,site,
	2       temperature,seed,n_succ,n_fail,move,radmin_in,
	2       radmax_in, ddelta,ddelta_2,n_fold,0,t_E_old,
	2	rad1,rad0,.false.)
	          Del_E_sum=Del_E_sum+Del_E
	          t_E_old=t_energy+Del_E_sum
		  end if

	        end do
C
C Get proper B and C sublattice sites (unoccuppied sites must
C	be updated)
                do I=1,grid_pts
	        site=I
	        if (b_occup(i).eq.0.) call B_site_position(site)
	        if (c_occup(i).eq.0.) call C_site_position(site)
	        end do
	      end if
  
            ave_E =ave_E+t_E_old              
            ave_E2=ave_E2+t_E_old*t_E_old
	    DELTA_E=AVE_E2/dble(j)-AVE_E*AVE_E/(dble(j)*dble(j))

c           ave_sf=tot_sf/dble(Nave)

c           Ave_Order1=Ave_order1+dabs(Order_1)
c           Ave_Order2=Ave_order2+dabs(Order_2)
c           Ave_Order3=Ave_order3+dabs(Order_3)
c           Ave_Order=ave_order+dabs(Order_1)+dabs(order_2) 
c           Ave_Order=ave_order+dabs(Order_3)                

            Sum_ord1=ord1_c*ord1_c+ord1_s*ord1_s
            Sum_ord2=ord2_c*ord2_c+ord2_s*ord2_s
            Sum_ord3=ord3_c*ord3_c+ord3_s*ord3_s
            Sum_ord4=Sum_ord1+Sum_ord2+Sum_ord3

            Ave_ord1=Ave_ord1+(Sum_ord1)           
            Ave_ord2=Ave_ord2+(Sum_ord2)           
            Ave_ord3=Ave_ord3+(Sum_ord3)           
            Ave_ord4=Ave_ord4+(Sum_ord4)           
 
            Sqr_ord1=Sqr_ord1+Sum_ord1*Sum_ord1                            
            Sqr_ord2=Sqr_ord2+Sum_ord2*Sum_ord2                            
            Sqr_ord3=Sqr_ord3+Sum_ord3*Sum_ord3                            
            Sqr_ord4=Sqr_ord4+Sum_ord4*Sum_ord4                   
 
	      if ((J/kstep)*kstep .eq. J) then
 	        if (graphics .eq. .true.) then 
		if (batch .eq. .true. .and. node .eq. 'comb') then
		  n_move_old=n_move
		  n_move=0
		else
c	        call disable_graphics
		  if (dopant_flag .eq. .true. .or. distort_flag .eq.
	2	  .true.) then
		    call plot_dopant
		    end if
		  if (dopant_flag .eq. .true.) then
		    call plot_moves(move_list,n_move,n_type)
		    n_move=0
		    end if
		  if (rotate_flag .eq. .true. .or. distort_flag .eq.
	2	.true. .or. dopant_flag .eq. .true.) then
		    call PLOT_N_FOLD(n_fold)
	      call plot_mc_info(alpha,beta,gamma,
	2     ave_e/dble(J),delta_e,
	2     n_steps,temperature,ddelta,ddelta_2,rad0,rad1)
		    end if
c	        call enable_graphics
		end if
 		end if
	      IF (screen_flag.eq..true.) THEN
 	       type *,'Energy ave: ',ave_e/dble(J)/dble(grid_pts)
              END IF

 	      IF (save_data_flag.eq..true.) write(16,*)
	2        'Energy ave: ', ave_e/dble(J)/dble(grid_pts)
	      end if


	    END DO

	 Ave_E = Ave_E/dble(2*Nave)
	 Rms_E = Ave_E2/dble(4*Nave)-AVE_E*AVE_E
	
         Ave_E = Ave_E/dble(grid_pts)
         Rms_E = Rms_E/dble(grid_pts)
         C     = Rms_E/Temperature/temperature  !heat capacity

         Ave_ord1=Ave_ord1/dble(Nave)
         Ave_ord2=Ave_ord2/dble(Nave)
         Ave_ord3=Ave_ord3/dble(Nave)
         Ave_ord4=Ave_ord4/dble(Nave)

c        Ave_Order1=Ave_order1/dble(Nave)/288.0d0  
c        Ave_Order2=Ave_order2/dble(Nave)/288.0d0  
c        Ave_Order3=Ave_order3/dble(Nave)/288.0d0  
c        Ave_Order=Ave_order/dble(Nave)/864.0d0  
    
         Rms_ord1= Sqr_ord1/dble(Nave) - Ave_ord1*Ave_ord1
         Rms_ord2= Sqr_ord2/dble(Nave) - Ave_ord2*Ave_ord2
         Rms_ord3= Sqr_ord3/dble(Nave) - Ave_ord3*Ave_ord3
         Rms_ord4= Sqr_ord4/dble(Nave) - Ave_ord4*Ave_ord4

         Ave_ord1=(Ave_ord1/2304.0d0)        
         Ave_ord2=(Ave_ord2/2304.0d0)          
         Ave_ord3=(Ave_ord3/2304.0d0)        
         Ave_ord4=(Ave_ord4/6912.0d0)       
                                   
         RMs_ord1=Rms_ord1/110592.0d0                    
         RMs_ord2=Rms_ord2/110592.0d0                    
         RMs_ord3=Rms_ord3/110592.0d0                    
         RMs_ord4=Rms_ord4/331776.0d0                   
  
         Sus_ord1= Rms_ord1/temperature                     
         Sus_ord2= Rms_ord2/temperature                     
         Sus_ord3= Rms_ord3/temperature                     
         Sus_ord4= Rms_ord4/temperature                     
 

 	       type *, 	'Nave= ',Nave
	      IF (screen_flag.eq..true.) then
		write(6,*) '***************************************'
		write(6,*) 'Temp     E_Ave       E_Rms        C    '
                Write(6,101) Temperature, Ave_E, abs(Rms_E)**0.5, C 
101             Format(F6.2,3E14.5)
		write(6,*) '***************************************'

c		write(6,*) '***************************************'
c		write(6,*) 'Ave_ord1= ', Ave_ord1
c 		write(6,*) 'Ave_ord2= ', Ave_ord2
c 		write(6,*) 'Ave_ord3= ', Ave_ord3
c		write(6,*) '***************************************'

c		write(6,*) '***************************************'
c		write(6,*) 'Rms_ord1= ', Rms_ord1
c		write(6,*) 'Rms_ord2= ', Rms_ord2
c		write(6,*) 'Rms_ord3= ', Rms_ord3
c		write(6,*) '***************************************'

	      end if

 	      IF (save_data_flag .eq..true.) then
 		write(16,*) '***************************************'
 		write(16,*) 'T= ', 1.*temperature,' : E = ', 
 	2 	ave_e, ' : E(rms)= ', abs(Rms_E)**0.5
 		write(16,*) '***************************************'
  	      end if

 	      IF (save_data_flag .eq..true.) then
                 WRITE(30,111) temperature, Ave_E, Rms_E, C         
                 WRITE(31,111) temperature,ave_ord1,rms_ord1,sus_ord1
                 WRITE(32,111) temperature,ave_ord2,rms_ord2,sus_ord2
                 WRITE(33,111) temperature,ave_ord3,rms_ord3,sus_ord3
                 WRITE(34,111) temperature,ave_ord4,rms_ord4,sus_ord4
C           WRITE(35,111) temperature,ave_order,ave_order1,ave_order2 
                 WRITE(6,111) temperature,ave_sf,ave_ord4,sus_ord4
c           WRITE(6,111) temperature,Ave_order1,ave_order2,ave_order3
111              Format(F7.3,3E14.5)
 	      end if
 
 	    IF (SF_FLAG .EQ. .TRUE.)
 	2   CALL OUTPUT_IO_PAGE(NEW_NAME,IO_DRIVER)
 	      if (graphics.eq. .true.)    then
	        if (batch .eq. .true. .and. node .eq. 'comb') then
	        continue
	        else
	        call plot_mc_info(alpha,beta,gamma,Ave_E,Rms_E,n_steps,
	2       temperature,ddelta,ddelta_2,rad0,rad1)
	        end if
	      end if
	   
	     if (hardcopy .eq. .true.) then
	        if (batch .eq. .true. .and. node .eq. 'comb') then
		call DATA_TO_DISK(n_FOLD,batch,move_list,n_move_old,
	2	N_type,alpha,beta,gamma,Ave_E,Rms_E,n_steps,
	2       temperature,ddelta,ddelta_2,rad0,rad1)
		else
	     	call PLOT_HC_MODEL(0)
		end if
	     end if

	    call new_mc_parameters(input_flag,stop_flag,
	2   alpha,beta,gamma,ddelta,ddelta_2,io_driver,seed,temperature,
	2   b_occup_frac,c_occup_frac,graphics,hardcopy,Nequ,Nave,
	2   save_data_flag,reset_flag,screen_flag,rotate_flag,
	2   dopant_flag,n_fold,filling,batch,
	2   x_move_flag,y_move_flag,distort_flag,rotate_init_flag,
	2   dopant_init_flag,distort_init_flag,sf_flag,rad0,rad1,node)
	    END DO	! Next temperature if it exists
	close(unit=15)
	close(unit=16)

	    if (graphics.eq. .true.)  then 
	      if (batch .eq. .true. .and. node .eq. 'comb') then
              continue
	      else
	      call plot_mc_info(
	2     alpha,beta,gamma,ave_e,delta_e,n_steps,
	2     temperature,ddelta,ddelta_2,rad0,rad1)
	      n_move=0
	      call plot_moves(move_list,n_move,n_type)
	      end if
	    end if

	     if (hardcopy .eq. .true.) then
	        if (batch .eq. .true. .and. node .eq. 'comb') then
		call DATA_TO_DISK(N_fold,batch,move_list,n_move,N_type,
	2	alpha,beta,gamma,ave_e,delta_e,n_steps,
	2       temperature,ddelta,ddelta_2,rad0,rad1)
		else
	     	call PLOT_HC_MODEL(0)
		end if
	     end if

	if (screen_flag.eq..true.) pause
        stop 'Normal program exit'
	end	

c********************************************************************/
c* This program sets up a triangular grid with a hexagonal border   */
c* so that the boundaries have six-fold symmetry                    */
c*	                                                            */
c********************************************************************/

	SUBROUTINE SET_UP_HEX_GRID
	include 'model.inc'
C	integer grid,grid_map,grid_size,grid_pts
C	real*8 grid_rot,E,E_b,E_c
C	real*4 b_occup,c_occup
C Array sizes and initialization values for above in 'model.inc'
	integer i,j,is,ij,i_t(3),j_t(3),i_translate,number
	logical*1 exit_loop,translate
	real*4 xmax,xmin,ymax,ymin,a1x,a1y,a2x,a2y,r3_2,inv_r3,x,y
	parameter(r3_2=0.8660254,inv_r3=0.5773503)
	parameter(a1x=1.0,a1y=0.,a2x=-0.5,a2y=0.8660254) 
	data i_t,j_t/-1,0,-1,0,-1,-1/
	xmax= float(grid_size)*0.5-.001	
	xmin=-float(grid_size)*0.5-.001	
	ymax= float(grid_size)*1.0*inv_r3-.001   
	ymin=-float(grid_size)*1.0*inv_r3-.001   
	number=0
	  do i=0,grid_size-1
	    do j=0,grid_size-1
	     is=i
	     js=j
	     exit_loop=.false.
	     i_translate=0
	      do while (.not.exit_loop)
	      x=float(is)-0.5*float(js)
	      y=r3_2*float(js)
	      translate=.false.
		if (x.ge.0.0 .and. y.ge.0.0) then
		  if (x.lt.xmax .and. y .lt. -inv_r3*x+ymax ) then
		  exit_loop=.true.
		  else
		  translate=.true.
		  end if
		else if (x.le.0 .and. y.ge.0.0) then
		  if (x.gt.xmin .and. y .lt.  inv_r3*x+ymax ) then
		  exit_loop=.true.
		  else
		  translate=.true.
		  end if
		else if (x.gt.0 .and. y.lt.0.0) then
		  if (x.lt.xmax .and. y .gt.  inv_r3*x+ymin ) then
		  exit_loop=.true.
		  else
		  translate=.true.
		  end if
		else if (x.lt.0 .and. y.lt.0.0) then
		  if (x.gt.xmin .and. y .gt. -inv_r3*x+ymin ) then
		  exit_loop=.true.
		  else
		  translate=.true.
		  end if
		else
	        exit_loop=.true.
		end if

		if (translate.eq..true.) then
		i_translate=i_translate+1
		if (i_translate.ge.4) stop 'logic error'
	        is=i+i_t(i_translate)*grid_size
	        js=j+j_t(i_translate)*grid_size
		end if
	      end do
	     
	      number=number+1
	      grid(i,j)=number
	      grid_map(1,number)=is
	      grid_map(2,number)=js
c	      type *, number, i, j, is, js
	    end do
	  end do
	return
	end
		
		
	SUBROUTINE SET_UP_NORM_GRID
	include 'model.inc'
C	integer grid,grid_map,grid_size,grid_pts
C	real*8 grid_rot,E,E_b,E_c
C	real*4 b_occup,c_occup
C Array sizes and initialization values for above in 'model.inc'
	integer i,j,is,ij,i_t(8),j_t(8),number
	logical*1 f_use
	data i_t/-1, 0,-1, 1, 0, 1, 1,-1/
	data j_t/ 0,-1,-1, 0, 1, 1,-1, 1/
	number=0
	  do i=0,grid_size-1
	    do j=0,grid_size-1
	     number=number+1
	     grid(i,j)=number
	     grid_map(1,number)=i
 	     grid_map(2,number)=j
C	     type *, number, i, j
	      if (i.eq. 0 .or. j.eq.0 .or. 
	2 	i .eq. grid_size-1 .or. j .eq. grid_size-1) then
	      	do k=1,8
	         f_use=.false.
		 is=i+grid_size*i_t(k)
		 js=j+grid_size*j_t(k)
		  if (is.eq.-1) then
		    if (js.ge.-1 .and. js.le.grid_size) f_use=.true.
 		  else if (js.eq.-1) then
		    if (is.ge.-1 .and. is.le.grid_size) f_use=.true.
		  else if (is.eq.grid_size) then
		    if (js.ge.-1 .and. js.le.grid_size) f_use=.true.
		  else if (js.eq.grid_size) then
		    if (is.ge.-1 .and. is.le.grid_size) f_use=.true.
		  end if
		  if (f_use.eq..true.) then
		  grid(is,js)=number
C	          type *, number, i, j, is, js,grid(is,js)
		  end if 
		end do
	      end if   
	    end do
	  end do
	return

	end

	SUBROUTINE SET_UP_NNN_GRID           
        integer site,i_s(6),i_t(6)
	include 'model.inc'
	do i=0,grid_size-1
	  do j=0,grid_size-1
	  site=grid(i,j)	

	  i_s(1)=i+2
	  i_t(1)=j+1

	  i_s(2)=i+1
	  i_t(2)=j+2

	  i_s(3)=i-1
	  i_t(3)=j+1

	  i_s(4)=i-2
	  i_t(4)=j-1

	  i_s(5)=i-1
	  i_t(5)=j-2

	  i_s(6)=i+1
	  i_t(6)=j-1 

	    do k=1,6
	    if (i_s(k).lt.0          ) i_s(k)=i_s(k)+grid_size
	    if (i_s(k).gt.grid_size-1) i_s(k)=i_s(k)-grid_size
	    if (i_t(k).lt.0          ) i_t(k)=i_t(k)+grid_size
	    if (i_t(k).gt.grid_size-1) i_t(k)=i_t(k)-grid_size
	    nnn_grid(k,site)=grid(i_s(k),i_t(k))
	    end do
	  end do
	end do
        RETURN
        END

	SUBROUTINE SET_UP_NNNN_GRID           
        integer site,i_s(6),i_t(6)
	include 'model.inc'
	do i=0,grid_size-1
	  do j=0,grid_size-1
	  site=grid(i,j)	

	  i_s(1)=i+2
	  i_t(1)=j+0

	  i_s(2)=i+2
	  i_t(2)=j+2

	  i_s(3)=i+0
	  i_t(3)=j+2

	  i_s(4)=i-2
	  i_t(4)=j-0

	  i_s(5)=i-2
	  i_t(5)=j-2

	  i_s(6)=i-0
	  i_t(6)=j-2 

	    do k=1,6
	    if (i_s(k).lt.0          ) i_s(k)=i_s(k)+grid_size
	    if (i_s(k).gt.grid_size-1) i_s(k)=i_s(k)-grid_size
	    if (i_t(k).lt.0          ) i_t(k)=i_t(k)+grid_size
	    if (i_t(k).gt.grid_size-1) i_t(k)=i_t(k)-grid_size
	    nnnn_grid(k,site)=grid(i_s(k),i_t(k))
	    end do
	  end do
	end do
        RETURN
        END


	SUBROUTINE MC_INITIALIZE(seed,b_occup_frac,c_occup_frac,filling)
C------------------------------------------------------------------------
C Initialize the system to random values
C------------------------------------------------------------------------
	include 'model.inc'
C	integer grid,grid_map,grid_size,grid_pts
C	real*8 grid_rot,E,E_b,E_c
C	real*4 b_occup,c_occup
C Array sizes and initialization values for above in 'model.inc'
	real*8 PI/3.141592653589793238/
	real*4 b_occup_frac,c_occup_frac
	integer seed,filling,i_site,i_loc,n_b,n_c,i,j,k
	2 n_b_left,n_c_left,n_step,i_a1,i_a2,nn1,nn2,nn3,nn4
	logical*1 mc_flag/.false./

	IF (mc_flag.eq. .false.)  THEN
	  if (filling.lt. 10) then
	    DO I=1,grid_pts   ! Random rotation of three fold channels
	    grid_rot(I)=(2.0d0*dble(RAN(SEED))-1.0d0)*PI
	    end do
	  else if (filling.eq. 10) then
	  type *, 'Enter Odd, Even grid rotations and style (1/2):'
	  read(5,*) odd_rot,even_rot,i_style
	    if (i_style.eq.1) then
	      DO I=1,grid_pts,2 
	      grid_rot(I  )= odd_rot*PI/180.
	      grid_rot(I+1)=even_rot*PI/180.
	      end do
	      else if (i_style.eq.2) then
	        DO I=1,grid_size,2
	          DO J=1,grid_size
		  I_site=(I-1)*grid_size+J
		  grid_rot(I_site  )= odd_rot*PI/180.
	          grid_rot(I_site+grid_size)=even_rot*PI/180.
	        end do
	      end do
	    end if
	  end if
	mc_flag=.true.
	n_b_left=grid_pts-1
	n_c_left=grid_pts-1
	end if

	if (filling .eq. 0) then
	N_STEP=ifix(grid_pts*b_occup_frac)
	  DO I=1,N_STEP
	    I_Site=IFIX(Float(N_B_left)*Ran(seed)+1.)
	    K=0
	    DO J=1,GRID_PTS
	      if (b_occup(J).eq.0 .and. N_B_left.gt.0) then
	      K=K+1
	        if (K .eq. I_site) then
	        N_B_Left=N_B_Left-1
		b_occup(J)=1.
		N_B=N_B+1
	        go to 50
	  	end if
	      end if
	    end do
  50	  end do	

	N_STEP=ifix(grid_pts*c_occup_frac)
	  DO I=1,N_STEP
	    I_Site=IFIX(Float(N_c_left)*Ran(seed)+1.)
	    K=0
	    DO J=1,GRID_PTS
	      if (c_occup(J).eq.0 .and. N_C_left.gt. 0) then
	      K=K+1
	        if (K.eq. I_site) then
	        N_C_Left=N_C_Left-1
		c_occup(J)=1.
		N_C=N_C+1
	        go to 60
	  	end if
	      end if
	    end do
   60	  end do	
	else if (filling .eq. 1) then
	  if (b_occup_frac.ne.0.0) then
	  N_STEP=IFIX((1./b_occup_frac)+.01)
	    DO I=1,grid_pts,N_step
	      if (b_occup(i).le.0) then
	      b_occup(i)=1.
	      N_B_Left=N_B_Left-1
	      N_B=N_B+1
	      end if
	    end do
	  end if

	  if (c_occup_frac.ne.0.0) then
	  N_STEP=IFIX((1./c_occup_frac)+.01)
	    DO I=1,grid_pts,N_step
	      if (c_occup(i).le.0) then
	      c_occup(i)=1.
	      N_c=N_c+1
	      N_C_Left=N_C_Left-1
	      end if
	    end do
	  end if

	else if (filling .eq. 2 .or. filling .eq. 22 .or.
	2 filling .eq. 23) then
	  open(unit=18,file='model_bc.par',status='old')
	   Do I=1,2*grid_pts
	   read(18,*,err=99,end=99) i_site,i_loc
	   
	     if (i_site.eq.1.and.b_occup(i_loc).eq. 0.0) then
		if (i_loc.lt.0) then
	        i_loc=-i_loc
		b_lock(i_loc)=.true.
		end if
	     b_occup(i_loc)=1.0
	     n_b=n_b+1
	     N_b_Left=N_b_Left-1
		if (filling .eq. 23) then
	    	c_occup(i_loc)=1.0
	     	n_c=n_c+1
	     	N_c_Left=N_c_Left-1
		end if
	      i_a1=grid_map(1,i_loc)
	      i_a2=grid_map(2,i_loc)
		if (filling .eq. 22) then
		nn1=grid(i_a1  ,i_a2)
		nn2=grid(i_a1  ,i_a2+1)
		nn3=grid(i_a1+1,i_a2+1)
	        grid_rot(nn1)=0.
	        grid_rot(nn2)=PI/3.
	        grid_rot(nn3)=-PI/3.
		else if (filling .eq. 23) then
		nn1=grid(i_a1  ,i_a2)
		nn2=grid(i_a1  ,i_a2+1)
		nn3=grid(i_a1+1,i_a2+1)
		nn4=grid(i_a1+1,i_a2)
	        grid_rot(nn1)=-PI/6.
	        grid_rot(nn2)= PI/3.
	        grid_rot(nn3)=-PI/6.
	        grid_rot(nn4)= PI/3.
		end if
C These lines allow nearest neighbor sites to be excluded
C		c_occup(grid(i_a1,i_a2))=-1.0
C		c_occup(grid(i_a1+1,i_a2))=-1.0
C		c_occup(grid(i_a1,i_a2-1))=-1.0
	     else if (i_site.eq.2.and.c_occup(i_loc).eq. 0.0) then
		if (i_loc.lt.0) then
	        i_loc=-i_loc
		c_lock(i_loc)=.true.
		end if
	     c_occup(i_loc)=1.0
	     n_c=n_c+1
	     N_C_Left=N_C_Left-1
	      i_a1=grid_map(1,i_loc)
	      i_a2=grid_map(2,i_loc)

		if (filling .eq. 22) then
		nn1=grid(i_a1  ,i_a2)
		nn2=grid(i_a1+1,i_a2)
		nn3=grid(i_a1+1,i_a2+1)
	        grid_rot(nn1)=-PI/3.
	        grid_rot(nn2)= PI/3.
	        grid_rot(nn3)=0.

		else if (filling .eq. 23) then

	    	b_occup(grid(i_a1,i_a2-1))=1.0
	     	n_b=n_b+1
	     	N_b_Left=N_b_Left-1

		nn1=grid(i_a1  ,i_a2)
		nn2=grid(i_a1+1,i_a2)
		nn3=grid(i_a1+1,i_a2+1)
	        grid_rot(nn1)= PI/2.
	        grid_rot(nn2)= PI/2.
	        grid_rot(nn3)= 0.
		end if
C These lines allow nearest neighbor sites to be excluded
C		b_occup(grid(i_a1,i_a2))=-1.0
C		b_occup(grid(i_a1-1,i_a2))=-1.0
C		b_occup(grid(i_a1,i_a2+1))=-1.0
	     end if
           end do
  99	 close(unit=18)

	end if
  	 b_occup_frac=float(n_b)/float(grid_pts)
	 c_occup_frac=float(n_c)/float(grid_pts)
	 filling=-1
	return
	end
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       This routine takes one metropolis step of rotation
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
	SUBROUTINE METROP(alpha,beta,gamma,theta_max,Del_E,site,
	2 temperature,seed,n_up_succ,n_up_fail,in_type)
        implicit none
	include 'model.inc'        
C	integer grid,grid_map,grid_size,grid_pts
C	real*8 grid_rot,E,E_b,E_c
C	real*4 b_occup,c_occup
C Array sizes and initialization values for above in 'model.inc'
        real*8 alpha,beta,gamma,E_old,E_new,theta_max,e_next
        integer site,SEED,n_up_succ,n_up_fail,site_0
	integer i_a1,i_a2,i_b1,i_b2,nn1,nn2,nn3,in_type
	real*8 theta_old,theta_new,Del_E,w,z,temperature
	logical*1 update_flag/.false./

	i_a1=grid_map(1,site)
	i_a2=grid_map(2,site)	
	site_0 =grid(i_a1  ,i_a2)
	theta_old=grid_rot(site_0)
	e_old=e(site_0)
	del_e=0.d0

	  if (in_type.eq.0) then
       	  theta_new=(2.0d0*DBLE(RAN(SEED))-1.0d0)*theta_max+theta_old
	  else 
	  theta_new=theta_max
	  end if

	CALL CALC_SITE_ENERGY(alpha,beta,gamma,theta_new,site_0,e_new)
C	type *, 'Old= ',e_old,' New= ',e_new

	  IF (e_new .LT. e_old .or. in_type .eq. 1 ) THEN
	   grid_rot(site_0)=theta_new
	   e(site_0)=e_new
	   CALL UPDATE_NEIGHBOR_SITES(alpha,beta,gamma,site_0,e_next)
	   Del_E=e_new-e_old+e_next
	  ELSE
	   W=DEXP(-(e_new-e_old)/temperature)
	   Z=dble(RAN(SEED))
	    IF (W .GT. Z) THEN
	      grid_rot(site_0)=theta_new
	      e(site_0)=e_new
	      CALL UPDATE_NEIGHBOR_SITES(alpha,beta,gamma,site_0,e_next)
	      Del_E=e_new-e_old+e_next
              n_up_succ=n_up_succ+1
	    ELSE
	      n_up_fail=n_up_fail+1
	      Del_E=0.d0
	      e(site_0)=e_old
	      grid_rot(site_0)=theta_old
	    ENDIF
	ENDIF

C	type *, del_e
        return
        end       ! metrop

C--------------------------------------------------------------------
C Algorithm for moving dopant ions
C--------------------------------------------------------------------
              
	SUBROUTINE METROP_D(alpha,beta,gamma,Del_E,site_1,temperature,seed,
	2 move_list,n_move,n_type,rad0,rad1,ddelta,ddelta_2,theta_max,
	2 distort_flag,x_move_flag,y_move_flag,radmin_in,radmax_in,
	2 d_energy,rotate_flag,x_max,y_max)
        implicit none
	include 'model.inc'        
C	integer grid,grid_map,grid_size,grid_pts
C	real*8 grid_rot,E,E_b,E_c
C	real*4 b_occup,c_occup
C Array sizes and initialization values for above in 'model.inc'
        real*8 alpha,beta,gamma,E_old,E_new,e_next,occup,ddelta,ddelta_2
	real*8 t_energy,t_check,t_check2,t_e_old,d_energy
	integer LL,d_a1,d_a2
        integer site_1,SEED,site_0,loci,i_b1,i_b2,nn1,nn2,nn3,num
	integer i_a1,i_a2,neighbor,move_list(800),n_move,n_type(800)
	real*8 theta_old,theta_new,Del_E,w,z,temperature,del_b,del_c
	real*4 rad0,rad1,position
	real*4 old_x(4),old_y(4),old_bx(4),old_by(4),old_cx(4),old_cy(4)
	real*4 x_org,y_org,bx_org,by_org,cx_org,cy_org
	real*8 old_theta(4),Del_E_dop,theta_max,theta_org
	integer mini_grid_pts,mini(4),m_a1,m_a2,site,n_dummy_fail,
	2 n_dummy_succ,in_type,i,j,k,l,n_fold/2/
	logical*1 update_flag,distort_flag,x_move_flag,y_move_flag,
	2 check_flag/.false./,rotate_flag
	real*4 radmin_in,radmax_in,x_max,y_max

	i_a1=grid_map(1,site_1)
	i_a2=grid_map(2,site_1)	
	site_0 =grid(i_a1  ,i_a2)
	del_e=0.d0
	del_b=0.d0
	del_c=0.d0	
	if (b_occup(site_0).le.0.0 .and. c_occup(site_0).le.0.0) goto 999
	del_e_dop=0.d0
	n_dummy_succ=0
	n_dummy_fail=0
	t_energy=d_energy

	if (b_occup(site_0).le.0.0 .or. b_lock(site_0) .eq. .true.) goto 500
       	loci=ifix(3.000*RAN(SEED))+1
	  if (loci.eq.1) then
	  i_b1=i_a1-1
	  i_b2=i_a2
	  neighbor=grid(i_a1-1,i_a2)
	  else if (loci.eq.2) then
	  i_b1=i_a1
	  i_b2=i_a2+1
	  neighbor=grid(i_a1,i_a2+1)
	  else
	  i_b1=i_a1
	  i_b2=i_a2
	  neighbor=grid(i_a1,i_a2)
	  end if


c 	    nn1=grid(i_b1  ,i_b2  )
c 	    nn2=grid(i_b1+1,i_b2  )
c 	    nn3=grid(i_b1  ,i_b2-1)
	    num=3

C These lines allow a B to C motion only if a B next-nearest neighbor
C is available
C 	    if (b_occup(nn1).eq.0.0 ) num=num-1
C 	    if (b_occup(nn2).eq.0.0 ) num=num-1
C 	    if (b_occup(nn3).eq.0.0 ) num=num-1

	  IF (c_occup(neighbor) .eq. 0.0.and. num .ne. 0) THEN 


C	TYPE *, NEIGHBOR,C_OCCUP(NEIGHBOR)
C Now it is necessary to arbitrarily move the atom and then
C run a mini-MC 
C Choose sites
	  mini_grid_pts=4
	  mini(1)=grid(i_a1  ,i_a2  )
	  mini(2)=grid(i_a1  ,i_a2+1)
	  mini(3)=grid(i_a1+1,i_a2+1)
	  m_a1=grid_map(1,neighbor)	
	  m_a2=grid_map(2,neighbor)	
	  mini(4)=grid(m_a1,m_a2  )
	  if ( loci .eq. 2) mini(4)=grid(m_a1+1,m_a2+1)
	  if ( loci .eq. 3) mini(4)=grid(m_a1+1,m_a2  )
C Save original theta, x, and y values
	    DO I=1,mini_grid_pts
	    site=mini(I)
            old_theta(I)= grid_rot(site)
	    old_x(I) = grid_x(site)
	    old_y(I) = grid_y(site)
	    END DO

	  occup=dble(b_occup(site_0))
	  call B_site_position(site_0)
 	  CALL CALC_SITE_ENERGY_B(gamma,site_0,e_old,ddelta,ddelta_2,rad1)
	  call C_site_position(neighbor)
 	  CALL CALC_SITE_ENERGY_C(gamma,neighbor,e_new,ddelta,ddelta_2,rad1)
 	  c_occup(neighbor)=b_occup(site_0)
 	  b_occup(site_0)=0.
 	  CALL UPDATE_Dopant_BC(Del_b,occup,rad0,rad1,ddelta,ddelta_2)

	  del_E=del_B+del_E
c	if (check_flag.eq. .true.) then
c 	      t_e_old=t_energy+del_e
c 		 t_check2=0.d0
c 		 DO LL=1,grid_pts
c 		 t_check2=t_check2+e(ll)
c 		 end do
c  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
c  	type *, ' D00: ', t_E_old, t_check, t_check2
c	end if
	  in_type=0
	   DO K=1,3

C Now to perform a chain rotation relaxaton
	     IF (rotate_flag .eq. .true.) THEN
	     DO J=1,8
	       DO I=1,mini_grid_pts
	        site=mini(I)
 	        call METROP(alpha,beta,gamma,theta_max,Del_E_dop,
	2 site,temperature,seed,n_dummy_succ,n_dummy_fail,in_type)
		del_E=del_E_dop+Del_E

	       END DO
	     END DO
	     END IF
C Now to perform x-y relaxation
	     IF (distort_flag .eq. .true. .and. ddelta.ne. 0.d0 ) THEN
	     DO J=1,8
	       DO I=1,mini_grid_pts
	        site=mini(I)

		IF (x_move_flag .eq. .true.) THEN
		CALL METROP_XY(alpha,beta,gamma,x_max,Del_E_dop,site,
	2 	temperature,seed,n_dummy_succ,n_dummy_fail,1,radmin_in,
	2	radmax_in,ddelta,ddelta_2,n_fold,in_type,d_energy+del_E,
	2	rad1,rad0,.false.)
		del_E=del_E_dop+Del_E
		END IF

		IF (y_move_flag .eq. .true. .and. ddelta.ne.0.d0) THEN
		CALL METROP_XY(alpha,beta,gamma,y_max,Del_E_dop,site,
	2 	temperature,seed,n_dummy_succ,n_dummy_fail,2,radmin_in,
	2	radmax_in,ddelta,ddelta_2,n_fold,in_type,d_energy+del_E,
	2	rad1,rad0,.false.)
		del_E=del_E_dop+Del_E
		END IF

	       END DO

	     END DO

c	if (check_flag.eq. .true.) then
c 	      t_e_old=t_energy+del_e
c 		 t_check2=0.d0
c 		 DO LL=1,grid_pts
c 		 t_check2=t_check2+e(ll)
c 		 end do
c  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
c  	type *, ' METROP_D: ', t_E_old, t_check, t_check2
c	end if


             END IF

	   END DO

	update_flag=.false.

	   IF (del_E .LT. 0.0) THEN
	   update_flag=.true.
	   ELSE
	   W=DEXP(-(del_E)*occup/temperature)
	   Z=dble(RAN(SEED))
	     IF (W .GT. Z) THEN
	     update_flag=.true.
	     end if
	   END IF
	     
	   IF (update_flag.eq. .true.) then
C Move is now assumed
C	    c_occup(neighbor)=b_occup(site_0)
C	    b_occup(site_0)=0.
C	    CALL UPDATE_Dopant_BC(Del_b,occup,rad0,rad1,ddelta,ddelta_2)
C	 type *, 'From B', site_0, ' to C ',neighbor
C Lock out nearest neighbors
C
c	    nn1=grid(i_b1  ,i_b2  )
c	    nn2=grid(i_b1+1,i_b2  )
c	    nn3=grid(i_b1  ,i_b2-1)
c	    if (b_occup(nn1).eq.0.0 ) b_occup(nn1)=-1.0
c	    if (b_occup(nn2).eq.0.0 ) b_occup(nn2)=-1.0
c	    if (b_occup(nn3).eq.0.0 ) b_occup(nn3)=-1.0
C Free up old nearest neighbors
c	      if (loci.eq.1) then
c		i_b1=i_a1
c		i_b2=i_a2+1
c		nn1=c_occup(grid(i_b1,i_b2))
c		  if (c_occup(nn1).eq.-1.0 .and. 
c	2 	      b_occup(grid(i_b1,i_b2))  .le. 0.0  .and.
c	2 	      b_occup(grid(i_b1+1,i_b2)).le. 0.0) 
c	2	      c_occup(grid(i_b1,i_b2))=0.0
c		i_b1=i_a1
c		i_b2=i_a2
c		nn1=c_occup(grid(i_b1,i_b2))
c		  if (c_occup(nn1).eq.-1.0 .and. 
c	2 	      b_occup(grid(i_b1+1,i_b2)).le. 0.0  .and.
c	2 	      b_occup(grid(i_b1,i_b2-1)).le. 0.0) 
c	2		c_occup(grid(i_b1,i_b2))=0.0
c	      else if (loci.eq.2) then
c		i_b1=i_a1
c		i_b2=i_a2
c		nn1=c_occup(grid(i_b1,i_b2))
c		  if (c_occup(nn1).eq.-1.0 .and. 
c	2 	      b_occup(grid(i_b1,i_b2-1)).le. 0.0  .and.
c	2 	      b_occup(grid(i_b1+1,i_b2)).le. 0.0) 
c	2		c_occup(grid(i_b1,i_b2))=0.0
c		i_b1=i_a1-1
c		i_b2=i_a2
c		nn1=c_occup(grid(i_b1,i_b2))
c		  if (c_occup(nn1).eq.-1.0 .and. 
c	2 	      b_occup(grid(i_b1,i_b2))  .le. 0.0  .and.
c	2 	      b_occup(grid(i_b1,i_b2-1)).le. 0.0) 
c	2		c_occup(grid(i_b1,i_b2))=0.0
c	      else if (loci.eq.3) then
c		i_b1=i_a1
c		i_b2=i_a2+1
c		nn1=c_occup(grid(i_b1,i_b2))
c		  if (c_occup(nn1).eq.-1.0 .and. 
c	2 	      b_occup(grid(i_b1,i_b2))  .le. 0.0  .and.
c	2 	      b_occup(grid(i_b1+1,i_b2)).le. 0.0) 
c	2		c_occup(grid(i_b1,i_b2))=0.0
c		i_b1=i_a1-1
c		i_b2=i_a2
c		nn1=c_occup(grid(i_b1,i_b2))
c		  if (c_occup(nn1).eq.-1.0 .and. 
c	2 	      b_occup(grid(i_b1,i_b2-1)).le. 0.0  .and.
c	2 	      b_occup(grid(i_b1,i_b2))  .le. 0.0) 
c	2		c_occup(grid(i_b1,i_b2))=0.0
c             end if

 	     if (n_move.lt.800) then
	     n_move=n_move+1
 	     move_list(n_move)=site_0
	     n_type(n_move)=0	     ! B-site
	     n_move=n_move+1
	     move_list(n_move)=neighbor
	     n_type(n_move)=1        ! C-site
	     end if
	     
	   ELSE ! it was a false move so everything goes back

	     DO I=1,mini_grid_pts
	     site=mini(I)
             theta_org=old_theta(I)
	     x_org	 =old_x(I)
	     y_org	 =old_y(I) 

	     in_type=1	! theta_max becomes theta_org

	       if (rotate_flag.eq. .true.) then
 	       call METROP(alpha,beta,gamma,theta_org,Del_E_dop,site,
 	2      temperature,seed,n_dummy_succ,n_dummy_fail,in_type)
	       del_E=del_E_dop+Del_E
	       end if
	 	if (x_move_flag .eq. .true. .and. ddelta .ne. 0.d0) then
		CALL METROP_XY(alpha,beta,gamma,x_org,Del_E_dop,site,
	2 	temperature,seed,n_dummy_succ,n_dummy_fail,1,radmin_in,
	2	radmax_in,ddelta,ddelta_2,n_fold,in_type,d_energy+del_E,
	2	rad1,rad0,.false.)
		del_E=del_E_dop+Del_E
		end if

	 	if (y_move_flag .eq. .true. .and. ddelta .ne. 0.d0) then
		CALL METROP_XY(alpha,beta,gamma,y_org,Del_E_dop,site,
	2 	temperature,seed,n_dummy_succ,n_dummy_fail,2,radmin_in,
	2	radmax_in,ddelta,ddelta_2,n_fold,in_type,d_energy+del_E,
	2	rad1,rad0,.false.)
		del_E=del_E_dop+Del_E
		end if

	     END DO

	   call C_site_position(neighbor)
	   CALL CALC_SITE_ENERGY_C(gamma,neighbor,e_old,ddelta,ddelta_2,rad1)
	   call B_site_position(site_0)
	   CALL CALC_SITE_ENERGY_B(gamma,site_0,e_new,ddelta,ddelta_2,rad1)
	   b_occup(site_0)=c_occup(neighbor)
	   c_occup(neighbor)=0.
	   CALL UPDATE_Dopant_CB(Del_c,occup,rad0,rad1,ddelta,ddelta_2)
	   del_E=del_c+Del_E
c	if (check_flag.eq. .true.) then
c 	      t_e_old=t_energy+del_e
c 		 t_check2=0.d0
c 		 DO LL=1,grid_pts
c 		 t_check2=t_check2+e(ll)
c 		 end do
c  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
c  	type *, ' Df2: ', t_E_old, t_check, t_check2
c	end if
	   ENDIF
	  end if

	if (update_flag .eq. .true.) goto 999

  500	continue	
C 	TYPE *, SITE_0,C_OCCUP(SITE_0)
	if (c_occup(site_0).le.0.0.or.c_lock(site_0).eq..true.) go to 999

       	loci=ifix(3.000*RAN(SEED))+1
	  if (loci.eq.1) then
	   i_b1=i_a1+1
	   i_b2=i_a2
	   neighbor=grid(i_a1+1,i_a2)
	  else if (loci.eq.2) then
	   i_b1=i_a1
	   i_b2=i_a2-1
	   neighbor=grid(i_a1,i_a2-1)
	  else 
	   i_b1=i_a1
	   i_b2=i_a2
	   neighbor=grid(i_a1,i_a2)
	  end if

c	    nn1=grid(i_b1  ,i_b2  )
c	    nn2=grid(i_b1-1,i_b2  )
c	    nn3=grid(i_b1  ,i_b2+1)
	    num=3
C These lines allow a C to B motion only if a B next-nearest neighbor
C is available
C	    if (c_occup(nn1).eq.0.0 ) num=num-1
C	    if (c_occup(nn2).eq.0.0 ) num=num-1
C	    if (c_occup(nn3).eq.0.0 ) num=num-1

	  IF (b_occup(neighbor) .eq. 0.0 .and. num .ne. 0) THEN

	if (check_flag.eq. .true.) then
 	      t_e_old=t_energy+del_e
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
  	type *, ' D: ', t_E_old, t_check, t_check2
	end if

C	TYPE *, NEIGHBOR,B_OCCUP(NEIGHBOR)
C Now it is necessary to arbitrarily move the atom and then
C run a mini-MC 
C Choose sites
	  mini_grid_pts=4
	  mini(1)=grid(i_a1  ,i_a2  )
	  mini(2)=grid(i_a1+1,i_a2  )
	  mini(3)=grid(i_a1+1,i_a2+1)
	  m_a1=grid_map(1,neighbor)	
	  m_a2=grid_map(2,neighbor)	
	  mini(4)=grid(m_a1+1,m_a2+1)
	  if ( loci .eq. 2) mini(4)=grid(m_a1  ,m_a2  )
	  if ( loci .eq. 3) mini(4)=grid(m_a1  ,m_a2+1)
C Save original theta, x, and y values
	    DO I=1,mini_grid_pts
	    site=mini(I)
            old_theta(I)= grid_rot(site)
	    old_x(I) = grid_x(site)
	    old_y(I) = grid_y(site)
	    END DO

	  occup=dble(c_occup(site_0))
	  CALL CALC_SITE_ENERGY_C(gamma,site_0,e_old,ddelta,ddelta_2,rad1)
	  Call CALC_SITE_ENERGY_B(gamma,neighbor,e_new,ddelta,ddelta_2,rad1)
	  b_occup(neighbor)=c_occup(site_0)
	  c_occup(site_0)=0.
	  CALL UPDATE_Dopant_CB(Del_c,occup,rad0,rad1,ddelta,ddelta_2)
C	type *, 'C to B'

	if (check_flag.eq. .true.) then
 	      t_e_old=t_energy+del_e
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
  	type *, ' D: ', t_E_old, t_check, t_check2
	end if

	  del_E=Del_C+del_E
	  in_type=0
	    DO K=1,3

	      IF (rotate_flag .eq. .true.) THEN
	      DO J=1,8
	        DO I=1,mini_grid_pts
	        site=mini(I)
	        call METROP(alpha,beta,gamma,theta_max,Del_E_dop,site,
	2       temperature,seed,n_dummy_succ,n_dummy_fail,in_type)
		del_E=del_E_dop+Del_E
	        END DO
	      END DO
	      END IF
C Now to perform x-y relaxation

	     IF (distort_flag .eq. .true. .and. ddelta.ne. 0.d0 ) THEN
	     DO J=1,8
	       DO I=1,mini_grid_pts
	        site=mini(I)

		IF (x_move_flag .eq. .true.) THEN
		CALL METROP_XY(alpha,beta,gamma,x_max,Del_E_dop,site,
	2 	temperature,seed,n_dummy_succ,n_dummy_fail,1,radmin_in,
	2	radmax_in,ddelta,ddelta_2,n_fold,in_type,d_energy+del_E,
	2	rad1,rad0,.false.)
		del_E=del_E_dop+Del_E
		END IF

		IF (y_move_flag .eq. .true.) THEN
		CALL METROP_XY(alpha,beta,gamma,y_max,Del_E_dop,site,
	2 	temperature,seed,n_dummy_succ,n_dummy_fail,2,radmin_in,
	2	radmax_in,ddelta,ddelta_2,n_fold,in_type,d_energy+del_E,
	2	rad1,rad0,.false.)
		del_E=del_E_dop+Del_E
		END IF
	       END DO

	     END DO

             END IF

	    END DO


	  update_flag=.false.

	    IF (del_E .LT. 0.0) THEN
	     update_flag=.true.
	    ELSE
	     W=DEXP(-(del_E)*occup/temperature)
	     Z=dble(RAN(SEED))
	      IF (W .GT. Z) THEN
	       update_flag=.true.
	      ENDIF
	    ENDIF
	
	    IF (update_flag.eq..true.) then
C Move is now assumed
C	     b_occup(neighbor)=c_occup(site_0)
C	     c_occup(site_0)=0.
C	     CALL UPDATE_Dopant_CB(Del_c,occup,rad0,rad1,ddelta,ddelta_2)

C	 type *, 'From C', site_0, ' to B ',neighbor
C Lock out nearest neighbors
C
c	    nn1=grid(i_b1  ,i_b2  )
c	    nn2=grid(i_b1-1,i_b2  )
c	    nn3=grid(i_b1  ,i_b2+1)
c	    if (c_occup(nn1).eq.0.0 ) c_occup(nn1)=-1.0
c	    if (c_occup(nn2).eq.0.0 ) c_occup(nn2)=-1.0
c	    if (c_occup(nn3).eq.0.0 ) c_occup(nn3)=-1.0
C Free up old nearest neighbors
c	      if (loci.eq.1) then
c		i_b1=i_a1
c		i_b2=i_a2-1
c		nn1=b_occup(grid(i_b1,i_b2))
c		  if (b_occup(nn1).eq.-1.0 .and. 
c	2 	      c_occup(grid(i_b1,i_b2))  .le. 0.0  .and.
c	2 	      c_occup(grid(i_b1-1,i_b2)).le. 0.0) 
c	2		b_occup(grid(i_b1,i_b2))=0.0
c		i_b1=i_a1
c		i_b2=i_a2
c		nn1=b_occup(grid(i_b1,i_b2))
c		  if (b_occup(nn1).eq.-1.0 .and. 
c	2 	      c_occup(grid(i_b1-1,i_b2)).le. 0.0  .and.
c	2 	      c_occup(grid(i_b1,i_b2+1)).le. 0.0) 
c	2		b_occup(grid(i_b1,i_b2))=0.0
c	      else if (loci.eq.2) then
c		i_b1=i_a1
c		i_b2=i_a2
c		nn1=b_occup(grid(i_b1,i_b2))
c		  if (b_occup(nn1).eq.-1.0 .and. 
c	2 	      c_occup(grid(i_b1,i_b2+1)) .le. 0.0  .and.
c	2 	      c_occup(grid(i_b1-1,i_b2)) .le. 0.0) 
c	2		b_occup(grid(i_b1,i_b2))=0.0
c		i_b1=i_a1+1
c		i_b2=i_a2
c		nn1=b_occup(grid(i_b1,i_b2))
c		  if (b_occup(nn1).eq.-1.0 .and. 
c	2 	      c_occup(grid(i_b1,i_b2))  .le. 0.0  .and.
c	2 	      c_occup(grid(i_b1,i_b2+1)).le. 0.0) 
c	2		b_occup(grid(i_b1,i_b2))=0.0
c	      else if (loci.eq.3) then
c		i_b1=i_a1
c		i_b2=i_a2-1
c		nn1=b_occup(grid(i_b1,i_b2))
c  		  if (b_occup(nn1).eq.-1.0 .and. 
c	2 	      c_occup(grid(i_b1,i_b2))  .le. 0.0  .and.
c	2 	      c_occup(grid(i_b1-1,i_b2)).le. 0.0) 
c	2		b_occup(grid(i_b1,i_b2))=0.0
c		i_b1=i_a1+1
c		i_b2=i_a2
c		nn1=b_occup(grid(i_b1,i_b2))
c		  if ( b_occup(nn1).eq.-1.0 .and. 
c	2 	       c_occup(grid(i_b1,i_b2+1)).le. 0.0 .and.
c	2 	       c_occup(grid(i_b1,i_b2))  .le. 0.0) 
c	2		b_occup(grid(i_b1,i_b2))=0.0
c             end if

	      IF (n_move.lt.800) then
	      n_move=n_move+1
	      move_list(n_move)=site_0
	      n_type(n_move)=1
	      n_move=n_move+1
      	      move_list(n_move)=neighbor
	      n_type(n_move)=0
	      ENDIF

	    ELSE ! it was a false move so everything goes back
	      DO I=1,mini_grid_pts
	      site=mini(I)
              theta_org	=old_theta(I)
	      x_org	=old_x(I)
	      y_org	=old_y(I) 
	      in_type=1	! theta_max becomes theta_new

		if (rotate_flag .eq. .true.) then
	        call METROP(alpha,beta,gamma,theta_org,Del_E_dop,site,
	2       temperature,seed,n_dummy_succ,n_dummy_fail,in_type)
	        del_E=del_E_dop+Del_E
		end if

	 	if (x_move_flag .eq. .true. .and. ddelta .ne. 0.d0) then
		CALL METROP_XY(alpha,beta,gamma,x_org,Del_E_dop,site,
	2 	temperature,seed,n_dummy_succ,n_dummy_fail,1,radmin_in,
	2	radmax_in,ddelta,ddelta_2,n_fold,in_type,d_energy+del_E,
	2	rad1,rad0,.false.)
		del_E=del_E_dop+Del_E
		end if

	 	if (y_move_flag .eq. .true. .and. ddelta .ne. 0.d0) then
		CALL METROP_XY(alpha,beta,gamma,y_org,Del_E_dop,site,
	2 	temperature,seed,n_dummy_succ,n_dummy_fail,2,radmin_in,
	2	radmax_in,ddelta,ddelta_2,n_fold,in_type,d_energy+del_E,
	2	rad1,rad0,.false.)
		del_E=del_E_dop+Del_E
		end if

	      END DO


	    call B_site_position(neighbor)
	    CALL CALC_SITE_ENERGY_B(gamma,neighbor,e_old,ddelta,ddelta_2,rad1)
	    call C_site_position(site_0)
	    CALL CALC_SITE_ENERGY_C(gamma,site_0,e_new,ddelta,ddelta_2,rad1)
	    c_occup(site_0)=b_occup(neighbor)
	    b_occup(neighbor)=0.
	    CALL UPDATE_Dopant_BC(Del_b,occup,rad0,rad1,ddelta,ddelta_2)
	    Del_E=Del_E+Del_b

	if (check_flag.eq. .true.) then
 	      t_e_old=t_energy+del_e
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
  	type *, ' D3: ', t_E_old, t_check, t_check2
	end if

	    end if
          end if

999	continue

        return
        end       ! metrop

C
C-------------------------------------------------------------------
C  This routine takes one metropolis step of x or y displacement
C-------------------------------------------------------------------
C
	SUBROUTINE METROP_XY(alpha,beta,gamma,xy_max,Del_E,site,
	2 temperature,seed,n_succ,n_fail,move,radmin_in,radmax_in,
	2 ddelta,ddelta_2,n_fold,in_type,energy,rad1,rad0,check_flag)
        implicit none
	include 'model.inc'        
C	integer grid,grid_map,grid_size,grid_pts,n_fold
C	real*8 grid_rot,E,E_b,E_c
C	real*4 b_occup,c_occup
C Array sizes and initialization values for above in 'model.inc'
        real*8 alpha,beta,gamma,E_old,E_new,e_next,ddelta,ddelta_2
        integer site,SEED,n_succ,n_fail,site_0
	integer i_a1,i_a2,move,n_fold,in_type,LL
	real*8 Del_E,w,z,temperature
	real*4 x_old,x_new,y_old,y_new,radmin,radmin_in,radmax_in,
	2 radmax,xy_max,rad1,rad0
	logical*1 check_flag
	real*8 t_check,t_check2,t_energy,t_e_old,energy

	t_energy=energy
	Del_E=0.d0
	i_a1=grid_map(1,site)
	i_a2=grid_map(2,site)	
	site_0 =grid(i_a1  ,i_a2)
	x_old=grid_x(site_0)
	y_old=grid_y(site_0)
	  if (move.eq.1) then
	  y_new=y_old
	    if (in_type.eq.0) then
      	    x_new=(2.0d0*DBLE(RAN(SEED))-1.0d0)*xy_max+x_old
	    else if (in_type .eq.1) then
	    x_new=xy_max
	    end if
          else if (move.eq.2) then
	  x_new=x_old
	    if (in_type.eq.0) then
      	    y_new=(2.0d0*DBLE(RAN(SEED))-1.0d0)*xy_max+y_old
	    else if (in_type .eq. 1) then
	    y_new=xy_max
	    end if
	  end if
	
	CALL CALC_XY_ENERGY(alpha,beta,gamma,ddelta,ddelta_2,
	2 x_new,y_new,site,e_new,radmin,radmax,e_old,n_fold,rad1)

	  if (radmin .lt. radmin_in .or. radmax .gt. radmax_in) then
	  n_fail=n_fail+1
	  e_new=e_old
	  goto 909
	  end if

	  IF (e_new .LT. e_old .or. in_type.eq.1) THEN
	   grid_x(site_0)=x_new
	   grid_y(site_0)=y_new
	   CALL UPDATE_XY_NN_SITES(alpha,beta,gamma,ddelta,ddelta_2,e_next)
C
	   Del_E=e_new-e_old+e_next
	  ELSE
	   W=DEXP(-(e_new-e_old)/temperature)
	   Z=dble(RAN(SEED))
	    IF (W .GT. Z) THEN
	      grid_x(site_0)=x_new
	      grid_y(site_0)=y_new
	      CALL UPDATE_XY_NN_SITES(alpha,beta,gamma,ddelta,ddelta_2,e_next)
	      Del_E=e_new-e_old+e_next
              n_succ=n_succ+1
	    ELSE
	      n_fail=n_fail+1
	    ENDIF
	ENDIF

	if (check_flag.eq. .true.) then
C	type *, del_e, t_energy
 	      t_e_old=t_energy+del_e
 		 t_check2=0.d0
 		 DO LL=1,grid_pts
 		 t_check2=t_check2+e(ll)
 		 end do
  	call total_energy(alpha,beta,gamma,ddelta,ddelta_2,rad0,rad1,t_check)
	if (abs(t_E_old-t_check).gt. .001) then
  	type *, t_E_old, t_check, t_check2
	pause
	else if (abs(t_E_old-t_check2).gt. .001) then
  	type *, t_E_old, t_check, t_check2
	pause
	end if
	end if

C 909	type *, site, e_old, e_new, del_e
 909	return
        end       ! metrop

C----------------------------------------------------------------------------
C This subroutine allows for parameter to be inputed from an external
C file 'MODEL.PAR'
C All commands must be in quotes and lower case
C  'alpha' -1.
C  'beta'  -1.
C  'gamma' -1.
C  'delta' 10.  delta
C  'rdelta' 10. delta_2
C  'radius' 1.
C  'temperature' 3.
C  'nave'  100
C  'nequ'  100
C  'c_occup' .25
C  'b_occup' .25
C  'run'        --- Engage Monte-Carlo Calculation again
C  'reset'	--- Do not use final results of previous run
C  'graphics' .true.
C  'hardcopy' .false.
C  'rotate' .true.
C  'dopant' .true.
C  'distort' .true.
C  'sf' .true.  --- Save value to a structure factore file
C  'init_rotate' 
C  'init_dopant' 
C  'init_distort' 
C  'x_move' .false.
C  'y_move' .false.
C  'io_driver' 2
C  'seed' 12345  --- Integer for random number generator
C  'store' 'NAME.EXT' --- this command must be in the set-up call
C  'screen_flag' .true.
C  
C

	subroutine get_mc_parameters(input_flag,stop_flag,
	2 alpha,beta,gamma,delta,delta_2,io_driver,seed,temperature,
	2 b_occup_frac,c_occup_frac,graphics,hardcopy,Nequ,Nave,
	2 save_data_flag,reset_flag,screen_flag,rotate_flag,
	2 dopant_flag,n_fold,filling,batch,
	2 x_move_flag,y_move_flag,distort_flag,rotate_init_flag,
	2 dopant_init_flag,distort_init_flag,sf_flag,rad0,rad1,node)
	implicit none
	include 'model.inc'
	logical*1 input_flag,graphics,stop_flag,distort_flag,
	2 batch,hardcopy, exit, reset_flag,save_data_flag,screen_flag,
	2 rotate_flag,x_move_flag,y_move_flag,sf_flag,dopant_flag,
	2 rotate_init_flag,dopant_init_flag,distort_init_flag
	real*8 alpha,beta,gamma,temperature,delta,delta_2
	integer io_driver,n_par,seed , nave,nequ,i,j,n_fold,filling
	real*4 b_occup_frac,c_occup_frac,rad0,rad1
	character*40 array,string,file_name,node*4
	node='comb'
	hardcopy=.false.
	stop_flag=.false.
	input_flag=.false.
	save_data_flag=.false.
	distort_flag=.false.
	filling=0	!at random
	dopant_flag=.false.
	rotate_flag=.true.
	x_move_flag=.false.
	y_move_flag=.false.
	screen_flag=.true.
	graphics=.true.
	batch=.false.
	open(unit=15,file='model.par',status='old',err=999)
	input_flag=.true. 
	nave=1
	nequ=1
	n_par=0
	n_fold=3
	anisot=1.
	angle=120.
	delta=0.0d0
	delta_2=0.0d0
	rad0=1.
	rad1=1.
	exit=.false.
	  DO WHILE (exit.eq..false.)
	  read(15,'(A200)') array
C	type *, array
	  read(array ,*,end=995) string

	  if 	  (string(1:5).eq.'alpha') then
	  read(array ,*,err=995) string,alpha
	  n_par=n_par+1
	  else if (string(1:4).eq.'beta') then
	  read(array ,*,err=995) string,beta  
	  n_par=n_par+1
	  else if (string(1:5).eq.'gamma') then
	  read(array ,*,err=995) string,gamma
	  else if (string(1:6).eq.'n_fold') then
	  read(array ,*,err=995) string,n_fold
	  n_par=n_par+1
	  else if (string(1:5).eq.'delta') then
	  read(array ,*,err=995) string,delta
	  else if (string(1:5).eq.'rdelt') then
	  read(array ,*,err=995) string,delta_2
	  else if (string(1:5).eq.'angle') then
	  read(array ,*,err=995) string,angle
	  else if (string(1:5).eq.'aniso') then
	  read(array ,*,err=995) string,anisot
	  else if (string(1:4).eq.'seed') then
	  read(array ,*,err=995) string,seed
	  n_par=n_par+1
	  else if (string(1:4).eq.'temp') then
	  read(array ,*,err=995) string,temperature
	  n_par=n_par+1
	  else if (string(1:4).eq.'b_oc') then
	  read(array ,*,err=995) string,b_occup_frac
	  n_par=n_par+1
	  else if (string(1:4).eq.'c_oc') then
	  read(array ,*,err=995) string,c_occup_frac
	  else if (string(1:6).eq.'fillin') then
	  read(array ,*,err=995) string,filling
	  else if (string(1:4).eq.'radi' ) then
	  read(array ,*,err=995) string,rad0 
	  else if (string(1:5).eq.'dradi' ) then
	  read(array ,*,err=995) string,rad1
	  n_par=n_par+1
	  else if (string(1:4).eq.'grap') then
	  read(array ,*,err=995) string,graphics
	  else if (string(1:4).eq.'nave') then
	  read(array ,*,err=997) string,nave
	  else if (string(1:4).eq.'nequ') then
	  read(array ,*,err=997) string,nequ
	  else if (string(1:4).eq.'io_d') then
	  read(array ,*,err=997) string,io_driver
	  else if (string(1:3).eq.'run' ) then
	  stop_flag=.false.
	  exit=.true.
	  else if (string(1:4).eq.'hard') then
	  read(array ,*,err=995) string,hardcopy
	  else if (string(1:4).eq.'batc') then
	  read(array ,*,err=995) string,batch
	  else if (string(1:4).eq.'node') then
	  read(array ,*,err=995) string,node
	  else if (string(1:4).eq.'scre') then
	  read(array ,*,err=995) string,screen_flag
	  else if (string(1:4).eq.'rota') then
	  read(array ,*,err=995) string,rotate_flag
	  else if (string(1:4).eq.'dist') then
	  read(array ,*,err=995) string,distort_flag
	  else if (string(1:4).eq.'dopa') then
	  read(array ,*,err=995) string,dopant_flag
	  else if (string(1:2).eq.'sf') then
	  read(array ,*,err=995) string,sf_flag
	  else if (string(1:8).eq.'init_rot') then
	  rotate_init_flag=.true.
	  else if (string(1:8).eq.'init_dop') then
	  dopant_init_flag=.true.
	  else if (string(1:8).eq.'init_dis') then
	  distort_init_flag=.true.
	  else if (string(1:4).eq.'x_mo') then
	  read(array ,*,err=995) string,x_move_flag
	  else if (string(1:4).eq.'y_mo') then
	  read(array ,*,err=995) string,y_move_flag
	  else if (string(1:5).eq.'store') then
	  read(array ,*,err=995) string,file_name
	  open(unit=16,file=file_name,status='new',access='sequential')
	  open(unit=30,file='EC.dat',status='new',access='sequential')
	  open(unit=31,file='ord1.dat',status='new',access='sequential')
	  open(unit=32,file='ord2.dat',status='new',access='sequential')
	  open(unit=33,file='ord3.dat',status='new',access='sequential')
	  open(unit=34,file='ord4.dat',status='new',access='sequential')
c	  open(unit=35,file='ord5.dat',status='new',access='sequential')
c	  open(unit=36,file='ord6.dat',status='new',access='sequential')
c	  open(unit=40,file='rot.ave',status='new',access='sequential')
	  open(unit=19,file='rot.ang',status='new',access='sequential')
	  save_data_flag=.true.
	  end if
	end do
	  do i=1,grid_pts
	   do j=1,6
	   grid_r0(j,i)=rad0
	   end do
	  end do
	if (delta.ne. 0.d0 .and. delta_2 .eq. 0.d0) delta_2=delta
	if (n_par.ne.7) then 
	  if (batch.eq..false.) type *, 'Incomplete startup list'
	  if (batch.eq..true.) type *, 'Incomplete startup list'
	end if
	return
  995   if (batch.eq..false.) type *, ' Error in initial parameter list'
	if (batch.eq..true.) type *, ' Error in initia parameter list'
	return
  999	graphics=.true.
	return

	entry new_mc_parameters(input_flag,stop_flag,
	2 alpha,beta,gamma,delta,delta_2,io_driver,seed,temperature,
	2 b_occup_frac,c_occup_frac,graphics,hardcopy,Nequ,Nave,
	2 save_data_flag,reset_flag,screen_flag,rotate_flag,
	2 dopant_flag,n_fold,filling,batch,
	2 x_move_flag,y_move_flag,distort_flag,rotate_init_flag,
	2 dopant_init_flag,distort_init_flag,sf_flag,rad0,rad1,node)
	exit=.false.
	hardcopy=.false.
	stop_flag=.true.
	if (input_flag.eq..false.) exit=.true.
	  DO WHILE (exit.eq..false.)
	  read(15,'(A200)',end=998) array
c	type *, array
	  read(array ,*,err=997) string
	  if 	  (string(1:5).eq.'alpha') then
	  read(array ,*,err=997) string,alpha
	  else if (string(1:4).eq.'beta') then
	  read(array ,*,err=997) string,beta  
	  else if (string(1:5).eq.'gamma') then
	  read(array ,*,err=997) string,gamma
	  else if (string(1:5).eq.'delta') then
	  read(array ,*,err=997) string,delta
	  else if (string(1:5).eq.'rdelt') then
	  read(array ,*,err=997) string,delta_2
	  else if (string(1:4).eq.'temp') then
	  read(array ,*,err=997) string,temperature
	  else if (string(1:4).eq.'b_oc') then
	  read(array ,*,err=997) string,b_occup_frac
	  else if (string(1:4).eq.'c_oc') then
	  read(array ,*,err=997) string,c_occup_frac
	  else if (string(1:4).eq.'radi') then
	  read(array ,*,err=997) string,rad0
	  else if (string(1:4).eq.'dradi') then
	  read(array ,*,err=997) string,rad1
	  else if (string(1:4).eq.'grap') then
	  read(array ,*,err=997) string,graphics
	  else if (string(1:4).eq.'scre') then
	  read(array ,*,err=997) string,screen_flag
	  else if (string(1:4).eq.'nave') then
	  read(array ,*,err=997) string,nave
	  else if (string(1:4).eq.'nequ') then
	  read(array ,*,err=997) string,nequ
	  else if (string(1:3).eq.'run ') then
	  exit=.true.
	  stop_flag=.false.
	  else if (string(1:4).eq.'stop') then
	  exit=.true.
	  stop_flag=.true.
	  else if (string(1:4).eq.'hard') then
	  read(array ,*) string,hardcopy
	  else if (string(1:4).eq.'io_d') then
	  read(array ,*,err=997) string,io_driver
	  else if (string(1:5).eq.'reset') then
	  read(array ,*,err=997) string,reset_flag
	  else if (string(1:4).eq.'rota') then
	  read(array ,*,err=995) string,rotate_flag
	  else if (string(1:4).eq.'dopa') then
	  read(array ,*,err=995) string,dopant_flag
	  else if (string(1:4).eq.'dist') then
	  read(array ,*,err=995) string,distort_flag
	  else if (string(1:2).eq.'sf') then
	  read(array ,*,err=995) string,sf_flag
	  else if (string(1:6).eq.'init_r') then
	  rotate_init_flag=.true.
	  else if (string(1:8).eq.'init_dop') then
	  dopant_init_flag=.true.
	  else if (string(1:8).eq.'init_dis') then
	  distort_init_flag=.true.
	  else if (string(1:4).eq.'x_mo') then
	  read(array ,*,err=995) string,x_move_flag
	  else if (string(1:4).eq.'y_mo') then
	  read(array ,*,err=995) string,y_move_flag
	  else if (string(1:6).eq.'fillin') then
	  read(array ,*,err=995) string,filling
	  end if
	end do
	if (delta.ne. 0.d0 .and. delta_2 .eq. 0.d0) delta_2=delta
	return
  997   if (batch.eq..false.) then 
	type *, ' Error in parameter list:', string
	end if
	if (batch.eq..true.) type *, ' Error in parameter list:',
	2 string
	return
  998	stop_flag=.true.
	return
	end
 	
 
	SUBROUTINE INITIALIZE_METROP(t_E_old,accpt_in,graphics,
	2 screen_flag,KSTEP,K_accpt,theta_max,alpha,beta,gamma,
	2 seed,temperature,theta_final,save_data_flag,Del_E_sum,
	2 delta,delta_2,rad0,rad1,n_fold,batch,node)
	IMPLICIT NONE
	include 'model.inc'
	integer n_up_succ,n_up_fail,site,I,J,K,L,seed,KSTEP,K_accpt,
	2 n_fold
	real*8 t_E_old,theta_max,alpha,beta,gamma,Del_e,t_energy,
	2 temperature,theta_factor,PI,theta_final,Del_E_sum,delta,
	2 delta_2,t_check
	real*4 accpt_in,accpt,rad0,rad1
	logical*1 graphics,screen_flag,save_data_flag,batch
	character*4 node
	parameter(PI=3.141592653589793238)

	theta_final=0.d0
	theta_factor=0.5d0
C *******************************************************************
C                                                                   *
C  This section of code finds theta_max so that the (number         *
C    of successful uphill moves)/(number of tries uphill)=accpt_in  *
C                                                                   *
C********************************************************************
	    DO K=1,K_accpt
            n_up_succ=0
            n_up_fail=0
	      DO I=1,2  ! Was 5,20
	        DO L=1,grid_pts
	 	site=L
		call METROP(alpha,beta,gamma,theta_max,Del_E,site,
	2 	temperature,seed,n_up_succ,n_up_fail,0)
	        Del_E_sum=Del_E_sum+Del_E
C 	call total_energy(alpha,beta,gamma,delta,delta_2,rad0,rad1,t_check)
C 	type *, 'E_old= ',t_e_old+del_e_sum,'   E_check= ', t_check
		end do
	      end do
	    ACCPT=dble(n_up_succ)/dble(n_up_succ+n_up_fail)
	      IF (ACCPT .LT. accpt_in) THEN
	       theta_max =theta_max*theta_factor
	      ELSE
	       theta_factor=0.9d0
	       theta_max=theta_max*1.1d0
	      ENDIF
C
	    if (theta_max .GT. PI) theta_max=PI
	    IF (K .GT. 25) theta_final=theta_final+theta_max
	      if ((K/KSTEP)*KSTEP .eq. K ) then
	        if (graphics.eq. .true.) then
		  if (batch .eq. .true. .and. node .eq. 'comb') then
		  continue
		  else
c		call disable_graphics
		  call PLOT_N_FOLD(N_fold)
c		  call enable_graphics
		  end if
		end if
	      IF (screen_flag.eq..true.) 
	2     type *, 'theta_max=',theta_max, 'acceptance=', accpt
	      IF (save_data_flag.eq..true.) write(16,*)
	2     'theta_max=',theta_max, 'acceptance=', accpt
	      end if
	    end do
	return
	end

C *******************************************************************
C                                                                   *
C  This subroutine of code finds theta_max so that the (number      *
C    of successful uphill moves)/(number of tries uphill)=accpt_in  *
C                                                                   *
C********************************************************************
	SUBROUTINE Norm_ang_rot(rot)
      real*8 rot, PI,tpi,tpit
      parameter(PI=3.141592653589793238)
      tpi=2.0d0*PI
      tpit=2.0d0*pi/3.0d0
      DO WHILE(rot .LT. 0.0d0   ) 
        rot = rot + tpit
      END DO
C               type *, 'rot1=',rot
      DO WHILE(rot.GT. tpit)
        rot = rot - tpit   
      END DO
C               type *, 'rot2=',rot
      return
      end




      SUBROUTINE set_up_rot
      IMPLICIT NONE
      include 'model.inc'
      integer i,j
      real*8 pi

      parameter(PI=3.141592653589793238)
      varphi(1)=0.0d0
      varphi(2)=2.0d0*pi/3.0d0
      varphi(3)=4.0d0*pi/3.0d0

      x0=8.6133d0
      y0=8.6133d0
      r=0.1d0
     
      DO i=1,3
        kx(i)=1.0d0
        ky(i)=1.0d0
      END DO

      DO i=0,11
        DO j=0,11
         rot_x(i,j)=x0*dble(i)-y0*dble(j)/2.0d0
         rot_y(i,j)=y0*dble(j)*dsqrt(1.50d0)
        END DO
      END DO

      RETURN
      END
