**********************************************************************
      PROGRAM SF           
********************************************************************** 
      IMPLICIT NONE          
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF.INC'

      LOGICAL      INIT
      LOGICAL      DO_IT/.FALSE./
      CHARACTER*20 COMMAND

      DATA INIT/.TRUE./
      SAVE INIT

      IF (INIT.EQ..TRUE.)THEN
        CALL init_sf()
        INIT=.FALSE.
        OPEN(UNIT=22,FILE='RSF.INF',STATUS='NEW')
        WRITE(22,5)
5       FORMAT('NO')
        CLOSE(22)
      END IF

33    DO WHILE(DO_IT.EQ..FALSE.)
        OPEN(UNIT=100,FILE='SF.INF',STATUS='OLD',ERR=33)
        READ(100,*)DO_IT
        TYPE *,'DO_IT1=',DO_IT
        IF (DO_IT.EQ..FALSE.)THEN
          CLOSE(100)
          CALL LIB$WAIT(2.0)
        ELSE IF(DO_IT.EQ..TRUE.)THEN
          READ(100,'(A)')COMMAND
          TYPE *,'COMMAND=',COMMAND
          DO_IT=.FALSE.
          REWIND(100)
          WRITE(100,*)DO_IT
          CLOSE(100)
          CALL EXEC_COMMAND(COMMAND)
          CALL WR_RSF_INF()
        END IF
      END DO

      END
*----------------------------------------------------------------------

***********************************************************************
      SUBROUTINE EXEC_COMMAND(COMMAND)
***********************************************************************
      IMPLICIT NONE
 
      CHARACTER*20 COMMAND

      TYPE *,'COMMAND_1=',COMMAND
      IF (COMMAND.EQ.'NEW SF.PAR')THEN
        CALL SF_PAR()                  !the argument here is # of par files
      ELSE IF(COMMAND.EQ.'NEW SF.BGD')THEN
        CALL get_sf_bgd()
      ELSE IF(COMMAND(1:).EQ.'NEW SF.PAR1')THEN
        CALL NEW_SF_PAR(1)
      ELSE IF(COMMAND.EQ.'NEW SF.PAR2')THEN
        CALL NEW_SF_PAR(2)
      ELSE IF(COMMAND.EQ.'NEW FIT.DAT')THEN
        CALL wr_fit_dat(0)
        CALL wr_fit_dat(1)
        CALL wr_fit_dat(2)
      ELSE IF(COMMAND.EQ.'CROSS FIT')THEN
        CALL auto_fit(0)
        CALL wr_sf_datc(0)
      ELSE IF(COMMAND.EQ.'AUTO FIT_1')THEN
        CALL auto_fit(1)
        CALL wr_sf_datc(0)
      ELSE IF(COMMAND.EQ.'AUTO FIT_2')THEN
        CALL auto_fit(2)
        CALL wr_sf_datc(0)
      ELSE IF(COMMAND.EQ.'COMPUTER NODE')THEN
        CALL CHANGE_NODE()
      ELSE IF(COMMAND.EQ.'NEW SF.IDX1')THEN
        CALL get_sf_idx(1)
      ELSE IF(COMMAND.EQ.'NEW SF.IDX2')THEN
        CALL get_sf_idx(2)
      ELSE IF(COMMAND.EQ.'NEW SF.MONO1')THEN
        CALL get_sf_mono(1)
      ELSE IF(COMMAND.EQ.'NEW SF.MONO2')THEN
        CALL get_sf_mono(2)
      ELSE IF(COMMAND.EQ.'SAVE SF.DATC')THEN
        CALL wr_sf_datc(0)
        CALL wr_sf_datc(1)
        CALL wr_sf_datc(2)
      ELSE IF(COMMAND.EQ.'VIEW PHASE_1')THEN
        CALL wr_sf_datc(1)
      ELSE IF(COMMAND.EQ.'VIEW PHASE_2')THEN
        CALL wr_sf_datc(2)
      ELSE IF(COMMAND.EQ.'SAVE SF.BGDC')THEN
        CALL wr_sf_bgdc()
      ELSE IF(COMMAND.EQ.'SAVE SF.PAR1')THEN
        CALL WR_SF_PAR12(1)
      ELSE IF(COMMAND.EQ.'SAVE SF.PAR2')THEN
        CALL WR_SF_PAR12(2)
      ELSE IF(COMMAND.EQ.'SAVE SF.IDX1')THEN
        CALL wr_sf_idx(1)
      ELSE IF(COMMAND.EQ.'SAVE SF.IDX2')THEN
        CALL wr_sf_idx(2)
      ELSE IF(COMMAND.EQ.'EXIT')THEN
        WRITE(6,44)
44      FORMAT('EXIT CURRENT SF PROGRAM')
        STOP
      END IF

      RETURN
      END
*---------------------------------------------------------------------


***********************************************************************
      SUBROUTINE INIT_SF()
      
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'

      INTEGER*4 I
      CALL get_sf_par()
      CALL get_expt_data()
      CALL get_sf_bgd()

      DO I=NP,1,-1
        CALL get_sf_par12(I)
        CALL cal_sf_par12(I)
        CALL get_sf_mono(I)
        CALL cal_atom_pos(I)
        CALL cal_k_vec(I)
        CALL cal_mu_rho(I)
        CALL get_sf_idx(I)
        CALL cal_2_theta(I)
        CALL cal_peak_width(I)
        CALL cal_sf_int(I)
        CALL cal_tot_prof()
        CALL wr_sf_datc(0)
      END DO
      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
      SUBROUTINE SF_PAR()
***********************************************************************
 
      IMPLICIT NONE

      CALL get_sf_par()
      CALL get_expt_data()
      CALL get_sf_bgd()
      CALL cal_tot_prof()
      CALL wr_sf_datc(0)

      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
      SUBROUTINE NEW_SF_PAR(N)
***********************************************************************
 
      IMPLICIT NONE
      INTEGER*4 N

      CALL get_sf_par12(N)
      CALL cal_sf_par12(N)
      CALL cal_atom_pos(N)
      CALL cal_k_vec(N)
      CALL cal_mu_rho(N)
      CALL cal_2_theta(N)
      CALL cal_peak_width(N)
      CALL cal_sf_int(N)
C     CALL profile(N)
      CALL cal_tot_prof()
      CALL wr_sf_datc(0)

      RETURN

      END
*----------------------------------------------------------------------


***********************************************************************
      SUBROUTINE VIEW_XYZ()
***********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF.INC'

      IF (CAST.GE.3)CAST=0
      CAST=CAST+1

      IF (CAST.EQ.1)THEN
        TYPE *,'Z-Projection'
      ELSE IF (CAST.EQ.2)THEN
        TYPE *,'X-Projection'
      ELSE IF (CAST.EQ.3)THEN
        TYPE *,'Y-Projection'
      END IF

      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
      SUBROUTINE CHANGE_NODE()
***********************************************************************
      IMPLICIT NONE
      INCLUDE  'SF.INC'

      IF (COMPUTER_NODE.EQ.'COMB')THEN
        COMPUTER_NODE='EWALD'
      ELSE IF(COMPUTER_NODE.EQ.'EWALD')THEN
        COMPUTER_NODE='LANDAU'
      ELSE IF(COMPUTER_NODE.EQ.'LANDAU')THEN
        COMPUTER_NODE='COMB'
      ELSE
        TYPE *,'Wrong Node'
      END IF

      TYPE *,'CURRENT NODE:: ',COMPUTER_NODE
      END
*----------------------------------------------------------------------


***********************************************************************
      SUBROUTINE WR_RSF_INF() 
***********************************************************************
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_HKL.INC'

      INTEGER*4 I

      OPEN(UNIT=22,FILE='RSF.INF',STATUS='NEW')
      WRITE(22,10)
10    FORMAT('YES')
      DO I=1,NP
        WRITE(22,*)PHS_RATIO(I)
      END DO
      WRITE(22,*)DOP_DENSITY

      CLOSE(22)

      RETURN
      END
*----------------------------------------------------------------------
