**********************************************************************
      SUBROUTINE GET_SF_PAR()
**********************************************************************
      Implicit INTEGER(A-Z)
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'

      REAL*4       JUNK
      INTEGER*4    I
      CHARACTER*70 information

      information='open sf.par'
      OPEN (UNIT=100,FILE='SF.PAR',STATUS='OLD',ERR=99)

      information='read sf.par'
      READ(100,*,ERR=99)FILE_NAME,DEFAULT_DIR,MONOMER
      READ(100,*,ERR=99)XMIN,XMAX,YMIN,YMAX   !range of data and window limits
      READ(100,*,ERR=99)X_SHIFT,Y_SHIFT,X_MULT,Y_MULT      !for proper scaling
      READ(100,*,ERR=99)ASMIN,ASMAX,WMIN,WMAX   
      READ(100,*,ERR=99)LAYER,LORTYPE,N_PHASES
      READ(100,*,ERR=99)WIDTH0,K_SCHERRER,LAMDA
      CLOSE (UNIT=100)

      IF (ASMIN.GT.XMAX)ASMIN=XMIN
      IF (ASMAX.LT.XMIN)ASMAX=XMAX

      IF (XMAX.LE.XMIN)THEN
        TYPE *,'XMAX is less than XMIN, check your sf.par file'
        STOP
      END IF
      IF (YMAX.LE.YMIN)THEN
        TYPE *,'YMAX is less than YMIN, check your sf.par file'
        STOP
      END IF

      IF (WMAX.LT.XMAX)THEN
        WMAX=XMAX
        TYPE*,' ERROR:  WMAX<XMAX'
      END IF
      IF (WMIN.GT.XMIN)THEN
        WMIN=XMIN
        TYPE*,' ERROR:  WMIN>XMIN'
      END IF

      IF (LORTYPE.EQ.0) LOR='Cryst-Powder: 1/sin(2Q)/sin(Q)'        
      IF (LORTYPE.EQ.1) LOR='Poeder: 1/sin(2Q)'     
      IF (LORTYPE.EQ.2) LOR='GDW: 1/sin^2(T)/cos(T)/sin(P)'
      IF (LORTYPE.EQ.3) LOR='Experimental: 1/sin^1.5(2Q)'    
C     GDW=General DeWolff

      TYPE *,'  Layer      Wave_Length                 Lor_Type'  
      WRITE(6,44)LAYER,LAMDA,LOR
44    FORMAT(I6,F16.4,'          'A30)

      RETURN
99    CALL display_err(information)
      CLOSE (UNIT=100)
      RETURN
      END
*----------------------------------------------------------------------

**********************************************************************
      SUBROUTINE GET_EXPT_DATA()
**********************************************************************
      INCLUDE   '($LIBDEF)'                                            
      IMPLICIT  INTEGER(A-Z)
      INCLUDE   'SF_CON.INC'
      INCLUDE   'SF_DAT.INC'   
      
      INTEGER*4 I,N_EXPT_DATA  !number of expt data
      INTEGER*4 LEN
      CHARACTER*80 NAME
      REAL*4    X,Y  !x and y column data of expt. data file
      CHARACTER*80 information
*    Data must be an ASCII file                          

      CALL STR$TRIM(DEFAULT_DIR,DEFAULT_DIR,LEN)
      NAME=DEFAULT_DIR(1:LEN)//FILE_NAME
      TYPE *,'NAME=',NAME
      information='Open '//NAME
      OPEN(unit=90,file=NAME,access='sequential',
     *             status='old',err=99,READONLY)
C     IO_TYPE=2
  
      information='Reading '//NAME 
      N_EXPT_DATA=0
11    READ(90,*,ERR=99,END=33)X,Y
        IF (X.GE.XMIN .AND. X.LE.XMAX)THEN
          N_EXPT_DATA=N_EXPT_DATA+1
          XVAL(N_EXPT_DATA)=X*X_MULT+X_SHIFT
          YVAL(N_EXPT_DATA)=Y*Y_MULT+Y_SHIFT
        END IF
        IF (Y. LE. 0.0)THEN
          information='File '//NAME
          GO TO 99
        END IF
      GOTO 11
33    IF (XVAL(1).GE.XMAX .OR. XVAL(N_EXPT_DATA).LE.XMIN)THEN
        information='Expt. data is out of pre-set range'
        GOTO 99
      END IF
      CLOSE(UNIT=90)
      DO I=1,N_EXPT_DATA
        IF (XVAL(I).GE.XMIN)THEN
          JMIN=I
          GOTO 44
        END IF
      END DO
44    IF (XVAL(N_EXPT_DATA).LE.XMAX)THEN
        JMAX=N_EXPT_DATA
      ELSE  
        DO I=JMIN,N_EXPT_DATA
          IF (XVAL(I).GT.XMAX)THEN
            JMAX=I-1
            GO TO 55
          END IF
        END DO
      END IF
      information='Finish reading '//DEFAULT_DIR(1:1+LEN)//FILE_NAME
      TYPE *, INFORMATION
55    RETURN
99    CALL DISPLAY_ERR(information)
      CLOSE(UNIT=90)
      RETURN
      END
*---------------------------------------------------------------------

**********************************************************************
      SUBROUTINE GET_SF_BGD()
**********************************************************************
C     CHECK TO SEE IF THE BACKGROUND FILE HAS PARAMATERS SUBJECT
C     TO THE OLD OR NEW NORMALIZATION CONSTANTS.
C     NEW NORMALIZATION CONSTANTS NEED HAVE "NEW" IN FIRST THREE
C     SPOTS IN .BGD FILE

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'

      REAL*4       BA(20),BB(20),BC(20),BD(20),BE,BG,BASE
      REAL*4       BGDSCALE,BGD_XSHIFT,BGD_YSHIFT,BGD1(NDAT)
      REAL*4       BGCONST,BLCONST
      REAL*4       BGAUS,BLORN
      INTEGER*4    I,J
      character*80 information

      information='Open sf.bgd file'
      OPEN (UNIT=13,FILE='SF.BGD',STATUS='OLD')
      information='Read sf.bgd file'

      READ(13,*,ERR=99)  !dummay line
      DO I=1,20
        READ(13,*,ERR=99)BA(I),BB(I),BC(I),BD(I)
C       TYPE *, BA(I),BB(I),BC(I),BD(I)
      END DO

      READ(13,*) BASE
      READ(13,*) BGDSCALE
      READ(13,*) BGD_XSHIFT,BGD_YSHIFT

      DO I=1,20
        BB(I)=BB(I)+BGD_XSHIFT+X_SHIFT
      END DO

*     BGCONST=1.77245
*     BLCONST=3.1415926
      BGCONST=1.66511
      BLCONST=1.4427 

      DO I=JMIN,JMAX
        BGD(I)=0.0
        BGD1(I)=0.0
      END DO
  
      IF (BGDSCALE.NE.0.0)THEN
        DO J = 1,20
          BG=BGCONST/BC(J)
          BE=(BG)**2.
          DO I = JMIN,JMAX
            BGAUS = EXP(-BE*(XVAL(I)-BB(J))**2.)
            BLORN = 1./(1.+BLCONST*BE*(XVAL(I)-BB(J))**2.)
            BGD1(I)= BGD1(I)+BA(J)*(BD(J)*BGAUS+(1.-BD(J))*BLORN)
          END DO
        END DO
        DO I=JMIN,JMAX
          BGD1(I)=BGD1(I)+BASE
          BGD1(I)=BGD1(I)*BGDSCALE+BGD_YSHIFT
        END DO
      END IF

      READ(13,*,ERR=99)  !dummay line
      DO I=1,20
        READ(13,*,ERR=99)BA(I),BB(I),BC(I),BD(I)
C       TYPE *, BA(I),BB(I),BC(I),BD(I)
      END DO

      READ(13,*) BASE
      READ(13,*) BGDSCALE
      READ(13,*) BGD_XSHIFT,BGD_YSHIFT

      DO I=1,20
        BB(I)=BB(I)+BGD_XSHIFT+X_SHIFT
      END DO

      IF (BGDSCALE.NE.0.0)THEN
        DO J = 1,20
          BG=BGCONST/BC(J)
          BE=(BG)**2.
          DO I = JMIN,JMAX
            BGAUS = EXP(-BE*(XVAL(I)-BB(J))**2.)
            BLORN = 1./(1.+BLCONST*BE*(XVAL(I)-BB(J))**2.)
            BGD(I)= BGD(I)+BA(J)*(BD(J)*BGAUS+(1.-BD(J))*BLORN)
          END DO
        END DO
        DO I=JMIN,JMAX
          BGD(I)=BGD(I)+BASE
          BGD(I)=BGD(I)*BGDSCALE+BGD_YSHIFT
        END DO
      END IF

      DO I=JMIN,JMAX
        BGD(I)=(BGD(I)+BGD1(I))*Y_MULT+Y_SHIFT
      END DO

      TYPE *,'Finish reading SF.BGD'
      CLOSE (UNIT=13)
      RETURN
99    CALL DISPLAY_ERR(information)
      CLOSE (UNIT=13)

*________________________________________
      ENTRY WR_SF_BGDC()
      
      OPEN(UNIT=1,NAME='SF.BGDC',STATUS='NEW')
      DO I=JMIN,JMAX
        WRITE(1,11)XVAL(I),BGD(I)
      END DO
11    FORMAT(F7.2, F10.2)
      CLOSE(UNIT=1)
      TYPE *,'SF.BGDC has been saved'
      RETURN
      END
*----------------------------------------------------------------------

**********************************************************************
      SUBROUTINE GET_SF_PAR12(N)
**********************************************************************
                              
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_HKL.INC'
      INCLUDE  'SF_PAR.INC'

      CHARACTER*80   INFORMATION
      CHARACTER*5    TAG            
      CHARACTER*8    NAME         
      CHARACTER*12   JUNK   
      INTEGER*4      I,J,N          
      REAL*4         TEMP
      REAL*4         A_LENGTH(NP)          !square of A_vector
      REAL*4         B_LENGTH(NP)          !square of B_vector
      REAL*4         AB_LENGTH(NP)         !square of A_vector + B_vector
      REAL*4         AB_TIMES(NP)  !length of A_vector times length of b_vector
      REAL*4         AB_ANGLE(NP)           !angle between A_vector and B_vector
      REAL*4         AREA_PER_CHAIN(NP)  !area enclose by A_vector and
                                           !B_vector for one chain

      DO I=0,50
        PAR_FLAG(N,I)=.FALSE.
      END DO
      WRITE(TAG,9)N
9     FORMAT(I1)
      NAME='SF.PAR'//TAG
      information='Open '//NAME 
      OPEN (UNIT=1,FILE=NAME,STATUS='OLD')
      information='Reading '//NAME        

      READ (1,*,ERR=99)                          !dummy line
      READ (1,*,ERR=99)                          !dummy line
      READ (1,*,ERR=99)                          !dummy line
      READ (1,*,ERR=99)                          !dummy line

      READ (1,*,ERR=99)((A0(N,I),I=1,3),(A_RATIO(N,I),I=1,3))
      READ (1,*,ERR=99)((A_LOGIC(N,I),I=1,3))  
      READ (1,*,ERR=99)((B0(N,I),I=1,3),(B_RATIO(N,I),I=1,3))
      READ (1,*,ERR=99)((B_LOGIC(N,I),I=1,3))  
      READ (1,*,ERR=99)((C0(N,I),I=1,3),(C_RATIO(N,I),I=1,3))
      READ (1,*,ERR=99)((C_LOGIC(N,I),I=1,3))  

      READ (1,*,ERR=99) N_MONO0(N)
      READ (1,*,ERR=99)                          !dummy line

      IF (N_MONO0(N).NE.0) THEN
        DO I=1,N_MONO0(N)
          READ(1,*,ERR=99) X_START0(N,I),Y_START0(N,I),Z_START0(N,I),
     *                     RAD_DIS0(N,I),TRN_DIS0(N,I),
     *                     ROT_ANG0(N,I),RAD_ANG0(N,I),
     *                     SET_ANG0(N,I),DIH_ANG0(N,I)   
          READ(1,*,ERR=99) X_LOGIC(N,I),Y_LOGIC(N,I),Z_LOGIC(N,I),
     *                     RAD_DIS_LOGIC(N,I),TRN_DIS_LOGIC(N,I),
     *                     ROT_ANG_LOGIC(N,I),RAD_ANG_LOGIC(N,I),
     *                     SET_ANG_LOGIC(N,I),DIH_ANG_LOGIC(N,I)

          IF (MONOMER(1:4).EQ.'THIO') THEN
            IF (MONOMER(5:5).EQ.' ') THEN
              MONO_DAT(N)=1
            ELSE IF (MONOMER(5:5).EQ.'+') THEN
              MONO_DAT(N)=8
            ELSE
              MONO_DAT(N)=8
            END IF
          END IF
          IF (MONOMER(1:5).EQ.'PPVH6') MONO_DAT(N)=2
          IF (MONOMER(1:5).EQ.'PPVD2') MONO_DAT(N)=3
          IF (MONOMER(1:5).EQ.'PPVD4') MONO_DAT(N)=4
          IF (MONOMER(1:5).EQ.'PPVD6') MONO_DAT(N)=5
          IF (MONOMER(1:3).EQ.'PPV')   MONO_DAT(N)=6
          IF (MONOMER(1:2).EQ.'I3')    MONO_DAT(N)=7
          IF (MONOMER(1:3).EQ.'I3A')   MONO_DAT(N)=9
          IF (MONOMER(1:3).EQ.'I3B')   MONO_DAT(N)=10
          IF (MONOMER(1:2).EQ.'PA')    MONO_DAT(N)=11
        END DO
      END IF

      read(1,*,ERR=99)N_DOPANTS(N) 
      read (1,*,ERR=99)         !dummy line
      IF (N_DOPANTS(N).NE.0) THEN
        DO I=1,N_DOPANTS(N)
          READ (1,*,ERR=99)XA_START0(N,I),YA_START0(N,I),
     *                     ZA_START0(N,I),DOP_DIS0(N,I),
     *                     TOT_ANG0(N,I),DOP_ANG0(N,I),
     *                     DOP_FRAC0(N,I),DOP_TYPE0(N,I)
          READ (1,*,ERR=99)XA_LOGIC(N,I),YA_LOGIC(N,I),
     *                     ZA_LOGIC(N,I),DOP_DIS_LOGIC(N,I),
     *                     TOT_ANG_LOGIC(N,I),DOP_ANG_LOGIC(N,I),
     *                     DOP_FRAC_LOGIC(N,I),DOP_TYPE_LOGIC(N,I)
        END DO
      END IF

      READ(1,*,ERR=99)                         !dummy line
      READ(1,*,ERR=99)(DB0(N,I),I=1,3),AFA0(N),SIDE_LIB0(N)
      READ(1,*,ERR=99)(DB_LOGIC(N,I),I=1,3),
     *                 AFA_LOGIC(N),SIDE_LOGIC(N)

      READ(1,*,ERR=99)DB_DOP0(N),DB_DOP_LOGIC(N)

      READ (1,*,ERR=99)                         !dummy line
      READ (1,*,ERR=99)ANISOTR0(N),SHP_FRAC0(N),PHS_FRAC0(N)
      READ (1,*,ERR=99)ANISOTR_LOGIC(N),SHP_LOGIC(N),PHS_LOGIC(N)
  
      READ (1,*,ERR=99)                         !dummy line
      DO I=1,10
  	READ (1,*,ERR=99)PWIDTH0(N,I),P_LOGIC(N,I),P_PEAK(N,I),PR(N,I)
      END DO
      READ (1,*,ERR=99)                         !dummy
      READ (1,*,ERR=99)(PWA0(N,I),I=1,8)
      READ (1,*,ERR=99)(PWA_LOGIC(N,I),I=1,8)

      READ (1,*,ERR=99)                         !dummy
      DO I=1,NAP
     	READ (1,*,END=20,err=16)PAR_VAL(N,0),PARAM(N,0),
     *                          PAR_DELTA(N,0),
     *                          PAR_MIN(N,0),PAR_MAX(N,0)
16  	IF (PAR_VAL(N,0).EQ.0) GOTO 20
        IF (PAR_MAX(N,0).LT. PAR_MIN(N,0)) THEN
          TEMP=PAR_MIN(N,0)                   !swap max and min of PAR
          PAR_MIN(N,0)=PAR_MAX(N,0)
      	  PAR_MAX(N,0)=TEMP
	END IF
	IF (PAR_MAX(N,0)-PAR_MIN(N,0) .LT. 0.00002 ) THEN
          PAR_MIN(N,0)=PARAM(N,0)-1.            !avoid too close max and min
	  PAR_MAX(N,0)=PARAM(N,0)+1.
	END IF
C
	IF (PARAM(N,0).LT.PAR_MIN(N,0) .OR.
     *	  PARAM(N,0).GT.PAR_MAX(N,0)) THEN
	  TEMP=0.5*(PAR_MAX(N,0)-PAR_MIN(N,0))  !birng PAR between min and max
	  PAR_MIN(N,0)=PARAM(N,0)-TEMP
	  PAR_MAX(N,0)=PARAM(N,0)+TEMP
	END IF
C
	IF (PAR_DELTA(N,0).LT. 0.00002) PAR_DELTA(N,0)=0.0001
	J=PAR_VAL(N,0)
	PAR_VAL(N,J)   = PAR_VAL(N,0)
	PARAM(N,J)     = PARAM(N,0)
	PAR_DELTA(N,J) = PAR_DELTA(N,0) 
	PAR_MIN(N,J)   = PAR_MIN(N,0)
	PAR_MAX(N,J)   = PAR_MAX(N,0)
20    END DO 	
      CLOSE(UNIT=1)
      DO I=1,NAP
     	PARAM(N,-I)=-PARAM(N,I)
      END DO
      IF (SHP_FRAC(N).LT. 0.0 .OR.SHP_FRAC(N).GT. 1.0 ) THEN
	TYPE *, 'Parameter SHAPE_FACTOR is out of bounds'
      END IF

C     DO I=1,3
C	PAR_FLAG(N,IABS(A_LOGIC(N,I)))=.TRUE.
C	PAR_FLAG(N,IABS(B_LOGIC(N,I)))=.TRUE.
C	PAR_FLAG(N,IABS(C_LOGIC(N,I)))=.TRUE.
C     END DO 
C     DO I=1,N_MONO(N)
C 	PAR_FLAG(N,IABS(X_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(Y_LOGIC(N,I)))=.TRUE.
C	PAR_FLAG(N,IABS(Z_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(ROT_DIS_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(ROT_ANG_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(DOP_TYP_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(DOP_FRAC_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(ROT_DHI_LOGIC(N,I)))=.TRUE.
C     END DO
C     DO I=1,N_DOPANTS(N)
C	PAR_FLAG(N,IABS(XA_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(YA_LOGIC(N,I)))=.TRUE.
C	PAR_FLAG(N,IABS(ZA_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(A_TYPE_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(A_FRAC_LOGIC(N,I)))=.TRUE.
C       PAR_FLAG(N,IABS(A_SPECIAL_LOGIC(N,I)))=.TRUE.
C     END DO
C     DO I=1,3
C       PAR_FLAG(N,IABS(DB_LOGIC(N,I)))=.TRUE.
C     END DO
C     PAR_FLAG(N,IABS(AFA_LOGIC(N)))=.TRUE.
C     PAR_FLAG(N,IABS(SIDE_LOGIC(N)))=.TRUE.
C     PAR_FLAG(N,IABS(ANISOTR_LOGIC(N)))=.TRUE.
C     PAR_FLAG(N,IABS(SHP_LOGIC(N)))=.TRUE.
C     PAR_FLAG(N,IABS(PHS_LOGIC(N)))=.TRUE.
C     DO I=1,10
C       PAR_FLAG(N,IABS(P_LOGIC(N,I)))=.TRUE.
C     END DO
C     PAR_FLAG(N,IABS(PWA_LOGIC(N)))=.TRUE.
C
      information='Finish reading '//NAME        
      TYPE *, INFORMATION
      RETURN
99    CALL DISPLAY_ERR(INFORMATION)
      CLOSE(UNIT=1)
      RETURN
*--------------------------------------------
      ENTRY CAL_SF_PAR12(N)

*    The following program will re-calculate the value of parameters 
*    accroding to their adjustment or their logic number

      DO I=1,3
        AA(N,I)=A0(N,I)+PARAM(N,A_LOGIC(N,I))
        BB(N,I)=B0(N,I)+PARAM(N,B_LOGIC(N,I))
        CC(N,I)=C0(N,I)+PARAM(N,C_LOGIC(N,I))
      END DO 

      IF (A_RATIO(N,1).EQ.0)THEN
        A(N,1)=AA(N,1)
        A(N,2)=AA(N,2)
        A(N,3)=AA(N,3)
      ELSE IF(A_RATIO(N,1).EQ.1)THEN
        A(N,1)=AA(N,1)
        A(N,2)=AA(N,1)*AA(N,2)
        A(N,3)=AA(N,1)*AA(N,3)
      ELSE IF(A_RATIO(N,1).EQ.2)THEN
        A(N,1)=AA(N,1)*COSD(AA(N,2))
        A(N,2)=AA(N,1)*SIND(AA(N,2))
        A(N,3)=AA(N,3)
      END IF

      IF (B_RATIO(N,1).EQ.0)THEN
        B(N,1)=BB(N,1)
        B(N,2)=BB(N,2)
        B(N,3)=BB(N,3)
      ELSE IF(B_RATIO(N,1).EQ.1)THEN
        B(N,1)=AA(N,1)*BB(N,1)
        B(N,2)=AA(N,1)*BB(N,2)
        B(N,3)=AA(N,1)*BB(N,3)
      ELSE IF(B_RATIO(N,1).EQ.2)THEN
        B(N,1)=BB(N,1)*COSD(BB(N,2))
        B(N,2)=BB(N,1)*SIND(BB(N,2))
        B(N,3)=BB(N,3)
      END IF

      IF (C_RATIO(N,1).EQ.0)THEN
        C(N,1)=CC(N,1)
        C(N,2)=CC(N,2)
        C(N,3)=CC(N,3)
      ELSE IF(C_RATIO(N,1).EQ.1)THEN
        C(N,1)=AA(N,1)*CC(N,1)
        C(N,2)=AA(N,1)*CC(N,2)
        C(N,3)=AA(N,1)*CC(N,3)
      ELSE IF(C_RATIO(N,1).EQ.2)THEN
        C(N,1)=CC(N,1)                  
        C(N,2)=CC(N,2)                
        C(N,3)=CC(N,3)                  
      END IF

      A_LENGTH(N)=A(N,1)*A(N,1)+A(N,2)*A(N,2)
      B_LENGTH(N)=B(N,1)*B(N,1)+B(N,2)*B(N,2)
      AB_LENGTH(N)=(A(N,1)+B(N,1))*(A(N,1)+B(N,1))+
     *             (A(N,2)+B(N,2))*(A(N,2)+B(N,2))
      AB_TIMES(N)=SQRT(A_LENGTH(N))*SQRT(B_LENGTH(N))
      IF (AB_TIMES(N).NE.0.0) AB_ANGLE(N)=
     *  ACOS((AB_LENGTH(N)-A_LENGTH(N)-B_LENGTH(N))/2/AB_TIMES(N))
      IF (N_MONO0(N).NE.0) AREA_PER_CHAIN(N)=AB_TIMES(N)*
     *  SIN(AB_ANGLE(N))/FLOAT(N_MONO0(N))

      N_MONO(N)=2*N_MONO0(N)

      DO I=1,N_MONO0(N)
        X_START(N,I)=X_START0(N,I)+PARAM(N,X_LOGIC(N,I))
        Y_START(N,I)=Y_START0(N,I)+PARAM(N,Y_LOGIC(N,I))
        Z_START(N,I)=Z_START0(N,I)+PARAM(N,Z_LOGIC(N,I))
        RAD_DIS(N,I)=RAD_DIS0(N,I)+PARAM(N,RAD_DIS_LOGIC(N,I))
        TRN_DIS(N,I)=TRN_DIS0(N,I)+PARAM(N,TRN_DIS_LOGIC(N,I))
        ROT_ANG(N,I)=ROT_ANG0(N,I)+PARAM(N,ROT_ANG_LOGIC(N,I))
        RAD_ANG(N,I)=RAD_ANG0(N,I)+PARAM(N,RAD_ANG_LOGIC(N,I))
        SET_ANG(N,I)=SET_ANG0(N,I)+PARAM(N,SET_ANG_LOGIC(N,I))
        DIH_ANG(N,I)=DIH_ANG0(N,I)+PARAM(N,DIH_ANG_LOGIC(N,I))
      END DO

      IF (N_DOPANTS(N).NE.0) THEN
        DO I=1,N_DOPANTS(N)
          XA_START(N,I)=XA_START0(N,I)+PARAM(N,XA_LOGIC(N,I))
          YA_START(N,I)=YA_START0(N,I)+PARAM(N,YA_LOGIC(N,I))
          ZA_START(N,I)=ZA_START0(N,I)+PARAM(N,ZA_LOGIC(N,I))
          DOP_DIS(N,I)=DOP_DIS0(N,I)+PARAM(N,DOP_DIS_LOGIC(N,I))
          TOT_ANG(N,I)=TOT_ANG0(N,I)+PARAM(N,TOT_ANG_LOGIC(N,I))
          DOP_ANG(N,I)=DOP_ANG0(N,I)+PARAM(N,DOP_ANG_LOGIC(N,I))
          DOP_FRAC(N,I)=DOP_FRAC0(N,I)+PARAM(N,DOP_FRAC_LOGIC(N,I))
          DOP_TYPE(N,I)=DOP_TYPE0(N,I)+PARAM(N,DOP_TYPE_LOGIC(N,I))
        END DO
      END IF

      DO I=1,3
        DB(N,I)=DB0(N,I)+PARAM(N,DB_LOGIC(N,I))
      END DO     

      DB_DOP(N)=DB_DOP0(N)+PARAM(N,DB_DOP_LOGIC(N))

      AFA(N)=AFA0(N)+PARAM(N,AFA_LOGIC(N))
      SIDE_LIB(N)=SIDE_LIB0(N)+PARAM(N,SIDE_LOGIC(N))

      ANISOTR(N)=ANISOTR0(N)+PARAM(N,ANISOTR_LOGIC(N))
      SHP_FRAC(N)=SHP_FRAC0(N)+PARAM(N,SHP_LOGIC(N))
      PHS_FRAC(N)=PHS_FRAC0(N)+PARAM(N,PHS_LOGIC(N))

      DO I=1,10
        PWIDTH(N,I)=PWIDTH0(N,I)+PARAM(N,P_LOGIC(N,I))
      END DO

      DO I=1,8
      PWA(N,I)=PWA0(N,I)+PARAM(N,PWA_LOGIC(N,I))
      END DO

      RETURN
*___________________________________________                              
      ENTRY WR_SF_PAR12(N)

      WRITE(TAG,10)N
10    FORMAT(I1)
      NAME='SF.PAR'//TAG
      OPEN (UNIT=1,FILE=NAME,STATUS='NEW')

      WRITE(1,73)FILE_NAME
73    FORMAT(' ',A50)

      WRITE(1,75)
75    FORMAT(' Phase_1   Phase_2   Doping_Density   Area_per_Chain')

      WRITE(1,77)PHS_RATIO(1)*100.0,PHS_RATIO(2)*100.0,
     *           DOP_DENSITY*100.0,AREA_PER_CHAIN(N)
77    FORMAT(F6.2,'%',F9.2,'%',F12.1,'%',F18.4)

      WRITE(1,79)
79    FORMAT('******************************************************')

      WRITE(1,12)((AA(N,I),I=1,3),(A_RATIO(N,I),I=1,3)) 
      WRITE(1,11)(A_LOGIC(N,I),I=1,3)         
      WRITE(1,13)((BB(N,I),I=1,3),(B_RATIO(N,I),I=1,3))        
      WRITE(1,11)(B_LOGIC(N,I),I=1,3)         
      WRITE(1,14)((CC(N,I),I=1,3),(C_RATIO(N,I),I=1,3))        
      WRITE(1,11)(C_LOGIC(N,I),I=1,3)         

11    FORMAT(I9,2I12)
12    FORMAT(3F12.5,'   ',3I2,'   AX AY AZ   A_ratio(3)')
13    FORMAT(3F12.5,'   ',3I2,'   BX BY BZ   B_ratio(3)')
14    FORMAT(3F12.5,'   ',3I2,'   CX CY CZ   C_ratio(3)')

      WRITE(1,15) N_MONO0(N)
15    FORMAT(I3,' number of polymers')

      WRITE(1,19)                          
19    FORMAT('  Pos.A   Pos.B   Pos.C   Rad_Dis  Trn_Dis
     *  Rot_Ang  Rad_Ang  Set_Ang  Dih_Ang')

      IF (N_MONO0(N).NE.0) THEN
        DO I=1,N_MONO0(N)
          WRITE(1,21) X_START(N,I),Y_START(N,I),Z_START(N,I),
     *                RAD_DIS(N,I),TRN_DIS(N,I),
     *                ROT_ANG(N,I),RAD_ANG(N,I),
     *                SET_ANG(N,I),DIH_ANG(N,I)   
21        FORMAT(3F8.4,2F9.4,4F9.2)

          WRITE(1,23) X_LOGIC(N,I),Y_LOGIC(N,I),Z_LOGIC(N,I),
     *                RAD_DIS_LOGIC(N,I),TRN_DIS_LOGIC(N,I),
     *                ROT_ANG_LOGIC(N,I),RAD_ANG_LOGIC(N,I),
     *                SET_ANG_LOGIC(N,I),DIH_ANG_LOGIC(N,I)
23        FORMAT(I6,2I8,6I9)
        END DO
      END IF

      WRITE(1,25)N_DOPANTS(N) 
25    FORMAT(I3,' number of dopants in unit cell')

      WRITE(1,27)         
27    FORMAT('   Pos.AA   Pos.BA   Pos.CA   Dop_Dis   Tot_Ang
     *   Dop_Ang   Dop_Frac  Dop_Type')

      IF (N_DOPANTS(N).NE.0) THEN
        DO I=1,N_DOPANTS(N)
          WRITE(1,29)XA_START(N,I),YA_START(N,I),
     *               ZA_START(N,I),DOP_DIS(N,I),
     *               TOT_ANG(N,I),DOP_ANG(N,I),
     *               DOP_FRAC(N,I),DOP_TYPE(N,I)
29        FORMAT(3F9.4,F10.4,2F10.2,F10.4,I8)

          WRITE(1,31)XA_LOGIC(N,I),YA_LOGIC(N,I),
     *               ZA_LOGIC(N,I),DOP_DIS_LOGIC(N,I),
     *               TOT_ANG_LOGIC(N,I),DOP_ANG_LOGIC(N,I),
     *               DOP_FRAC_LOGIC(N,I),DOP_TYPE_LOGIC(N,I)
31        FORMAT(I7,3I9,4I10)
        END DO
      END IF

      WRITE(1,33)                         
33    FORMAT('     DB_X      DB_Y      DB_Z    AFA/LIB     SIDE/LIB')
 
      WRITE(1,35)((DB(N,I),I=1,3),AFA(N),SIDE_LIB(N))
35    FORMAT(4F10.5,F14.5)

      WRITE(1,37)(DB_LOGIC(N,I),I=1,3),AFA_LOGIC(N),SIDE_LOGIC(N)
37    FORMAT(I7,I10,I10,I10,I13)
  
      WRITE(1,38)DB_DOP(N),DB_DOP_LOGIC(N)
38    FORMAT(F10.5,I7,'         DB_Dopant and DB_Dopant_Logic')

      WRITE(1,39)
39    FORMAT('   Anisotropy   Shape_Factor   Phase_Fraction')

      WRITE(1,41)ANISOTR(N),SHP_FRAC(N),PHS_FRAC(N)
41    FORMAT(F12.5,F13.5,F15.5)

      WRITE(1,43)ANISOTR_LOGIC(N),SHP_LOGIC(N),PHS_LOGIC(N)
43    FORMAT(I9,I14,I14)
  
      WRITE(1,45)
45    FORMAT('   Peakwidth  Peak-Logic  P-Peak  Peak-Range')

      DO I=1,10
  	WRITE(1,47) PWIDTH(N,I),P_LOGIC(N,I),P_PEAK(N,I),PR(N,I)
47      FORMAT(F11.5,I9,I8,F12.2)
      END DO

      WRITE(1,48)
48    FORMAT('   Cos_1    Cos_2    Cos_3    Cos_4    Cos_5    Cos_6
     *    Cos_7    Cos_8')
      WRITE(1,49) (PWA(N,I),I=1,8)
49    FORMAT(8F9.4)
      WRITE(1,50) (PWA_LOGIC(N,I),I=1,8)
50    FORMAT(I7,7I9)

      WRITE(1,51)
51    FORMAT('   Auto_Fitting Variables') 
      DO I=1,NAP
        PARAM(N,I)=0.0
        PARAM(N,-I)=0.0
      END DO

      DO I=1,NAP
     	WRITE(1,53)PAR_VAL(N,I),PARAM(N,I),PAR_DELTA(N,I),
     *             PAR_MIN(N,I),PAR_MAX(N,I)

53      FORMAT(I6,4F12.6)
      END DO

      CLOSE(UNIT=1)
      TYPE *,NAME,' has been saved'
      RETURN
*_____________________________________________________

      ENTRY WR_FIT_DAT(N)

      WRITE(TAG,7)N
7     FORMAT(I1)
      NAME='FIT.DAT'//TAG

      OPEN(unit=10,name=NAME,type='new')
      WRITE(10,100) 
      DO I=1,NAP
        IF (ABS(PAR_MIN(N,I)).GT.10. .OR. 
     *      ABS(PAR_MAX(N,I)).GT.10.)THEN 
	  WRITE(10,121)
     *    I,I,PARAM(N,I),PAR_DELTA(N,I),PAR_MIN(N,I),PAR_MAX(N,I)
	ELSE 
	  WRITE(10,101)
     *    I,I,PARAM(N,I),PAR_DELTA(N,I),PAR_MIN(N,I),PAR_MAX(N,I)
	END IF
      END DO
      WRITE(10,102)
      DO I=1,NAP
	WRITE(10,103) FLOAT(I)
      END DO
      WRITE(10,104)
      WRITE(10,105)
      CLOSE(UNIT=10)

100	FORMAT('TITLE')
101 	FORMAT(I10,' XPM(',I2,') ',3X,F7.4,3X,F7.4,1X,F9.5,3X,F7.4)
102	FORMAT()
103	FORMAT('FIX',12X,F3.0)
104	FORMAT('MIGRAD 10')
C104	FORMAT('SIMPLEX')
105	FORMAT('END RETURN')
121 	FORMAT(I10,' XPM(',I2,') ',3X,F7.3,3X,F7.3,1X,F9.4,3X,F7.3)

      TYPE *,NAME,' have been saved'
      RETURN
      END
*----------------------------------------------------------------------


**********************************************************************
      SUBROUTINE GET_SF_MONO(N)
**********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      CHARACTER*4       TAG            
      CHARACTER*8       NAME         
      CHARACTER*80      information
      INTEGER*4         I,J,K,N,M
      INTEGER*4         N_MONO_FILES
      CHARACTER*8       MONO_FILE  
      real*4 rot,x,y

      WRITE(TAG,11)N
11    FORMAT(I1)
      NAME='SF.MONO'//TAG
      information='Open '//NAME 
      OPEN (UNIT=2,FILE=NAME,STATUS='OLD',ERR=99)

      information='Reading '//NAME        

      READ(2,*)N_MONO_FILES 
      IF (N_MONO_FILES.LT.1) N_MONO_FILES=1

      DO J=1,N_MONO_FILES        
        READ (2,*,ERR=99)           !dummy line            
        READ (2,108,ERR=99)MONO_FILE
108     FORMAT(A8)
        IF (MONO_FILE(1:4).EQ.'THIO') THEN
          K=1                  !K actually is mono_dat(N)
        ELSE IF (MONO_FILE(1:5).EQ.'PPVH6') THEN
          K=2
        ELSE IF (MONO_FILE(1:5).EQ.'PPVD2') THEN
          K=3
        ELSE IF (MONO_FILE(1:5).EQ.'PPVD4') THEN
          K=4
        ELSE IF (MONO_FILE(1:5).EQ.'PPVD6') THEN
          K=5
        ELSE IF (MONO_FILE(1:3).EQ.'PPV') THEN
          K=6
        ELSE IF (MONO_FILE(1:3).EQ.'I3') THEN
          K=7
        ELSE IF (MONO_FILE(1:3).EQ.'I3A') THEN
          K=9
        ELSE IF (MONO_FILE(1:3).EQ.'I3B') THEN
          K=10
        ELSE IF (MONO_FILE(1:2).EQ.'PA') THEN
          K=11
        ELSE
          TYPE *,'ERROR IN SF.MONO'
          STOP
        END IF
        READ(2,*,ERR=99)NUM(K)       !NUM is total number of atoms

        IF (K.EQ.MONO_DAT(N))THEN
          DO I=1,N_MONO0(N)
            N_ATOMS(N,I)=NUM(K)
          END DO
        END IF
        ROT=90.0
	DO I=1,NUM(K)
          TH_LOG(N,I,K)=.TRUE.
          READ(2,*,ERR=99)M,THA_TYPE(N,I,K),     !m is a dummy number
     *                      THX_POS(N,I,K),THY_POS(N,I,K),
     *                      THZ_POS(N,I,K),TH_LOG(N,I,K)

          x=thx_pos(n,i,k)*cosd(rot)-thy_pos(n,i,k)*sind(rot)
          y=thx_pos(n,i,k)*sind(rot)+thy_pos(n,i,k)*cosd(rot)
          thx_pos(n,i,k)=x
          thy_pos(n,i,k)=y
      	END DO  
      END DO

      CLOSE(UNIT=2)
      information='Finish reading '//NAME        
      TYPE *, INFORMATION

77    RETURN
99    CALL DISPLAY_ERR(information)
      CLOSE(UNIT=2)
      RETURN
      END
*---------------------------------------------------------------------

***********************************************************************
      SUBROUTINE GET_SF_IDX(N)                       
***********************************************************************
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_HKL.INC'

      INTEGER*4    N,I,J
      INTEGER*4    ORDER_TEMP

      REAL*4       TWO_THETA(NI)       !used for sorting of idx(=t_theta)
      REAL*4       TWO_THETA_TEMP                                        
      REAL*4       CRYSTAL_SIZE(NI),DOMINATOR,TRUE_WIDTH(NI)
      CHARACTER*1  TAG
      CHARACTER*4  TAG1,TAG2
      CHARACTER*7  NAME
      CHARACTER*5  MILLER_TYPE
      CHARACTER*80  INFORMATION

      WRITE(TAG,11)N
11    FORMAT(I1)
      NAME='SF.IDX'//TAG
      MILLER_TYPE='NONE'
      OPEN(UNIT=2,FILE=NAME,STATUS='OLD',ERR=66)
      READ(2,22) MILLER_TYPE
22    FORMAT(A5)
      IF (MILLER_TYPE(2:5).EQ.'LIST' .OR.
     *    MILLER_TYPE(1:4).EQ.'LIST') N_USED(N)=100

      READ(2,*)      !dummy line
      READ(2,*) N_USED(N),N_REFLECTIONS(N)

      READ(2,*)      !dummy line
      DO I=1,N_REFLECTIONS(N)
	READ(2,*,END=33)N_M(N,I),H_M(N,I),K_M(N,I),L_M(N,I)
     *                  ,MULT(N,I),
     *                  WIDTH(N,I),K_VEC(N,I),
     *                  T_THETA(N,I),INT_BAR(N,I)
        IF (LAYER.GE.0)L_M(N,I)=LAYER
      END DO
33    IF (I.LT.N_REFLECTIONS(N)) N_REFLECTIONS(N)=I-1
      IF (N_USED(N).GT.N_REFLECTIONS(N))N_USED(N)=N_REFLECTIONS(N)

      CALL SORT_INT(N)    !sort idx according their intensity from max to min
c      CALL CAL_2_THETA(N) !cal 2_theta for each idx HKL

      WRITE(TAG1,44)N_REFLECTIONS(N)
      WRITE(TAG2,44)N_USED(N)
44    FORMAT(I2)
      INFORMATION='TOTAL OF '//TAG1//'REFLECTIONS, AND '//TAG2//
     *'OF THEM ARE BEING USED'
      TYPE *,INFORMATION
      TYPE *,'             '
      CLOSE(UNIT=2)
      TYPE *,'               '
      TYPE *,'Finish reading SF.IDX',TAG
      RETURN

66    TYPE *, 'SF.IDX',TAG,
     * ' IS NOT EXIST,THE PROGRAM WILL NOW ESTIMATE LIMITS'
      CALL CAL_SF_IDX(N)
      N_USED(N)=100
      IF (N_USED(N).GT.N_REFLECTIONS(N))N_USED(N)=N_REFLECTIONS(N)
      WRITE(TAG1,44)N_REFLECTIONS(N)
      WRITE(TAG2,44)N_USED(N)
      INFORMATION='TOTAL OF '//TAG1//'REFLECTIONS, AND '//TAG2//
     *'OF THEM ARE BEING USED'
      TYPE *,INFORMATION
      TYPE *,'             '
      RETURN
*----------------------------------------------------------------------
 
***********************************************************************
      ENTRY WR_SF_IDX(N)
***********************************************************************
      CALL SORT_ANG(N)


      DO I=1,N_REFLECTIONS(N)
        True_width(i)=SQRT(width(n,i)*width(n,i)-width0*width0)
        DOMINATOR=3.1416*TRUE_WIDTH(I)/180.0*COSD(T_THETA(N,I)/2.0)   

        IF (DOMINATOR.NE.0.)CRYSTAL_SIZE(I)=
     *                      K_SCHERRER*LAMDA/DOMINATOR
      END DO

      WRITE(TAG,77)N
77    FORMAT(I1)
      NAME='SF.IDX'//TAG
      MILLER_TYPE=' LIST'

      OPEN(UNIT=2,FILE=NAME,STATUS='NEW')
      WRITE(2,*)MILLER_TYPE
      WRITE(2,*)' Line for H_MIN H_MAX K_MIN K_MAX L_MIN L_MAX'
      WRITE(2,*)N_USED(N),N_REFLECTIONS(N)
      WRITE(2,88)
88    FORMAT('       H   K   L  MULT PEAK_WIDTH  K_VEC   2_THETA  
     *INTENSITY  CRYSTAL_SIZE')

      DO I=1,N_REFLECTIONS(N)
        WRITE(2,99)N_M(N,I),H_M(N,I),K_M(N,I),L_M(N,I),MULT(N,I),
     *       TRUE_WIDTH(I),K_VEC(N,I),T_THETA(N,I),INT_BAR(N,I),
     *       CRYSTAL_SIZE(I)
99      FORMAT(5I4,F11.4,F9.4,F9.3,E13.4,F10.1)
      END DO
      CLOSE(UNIT=2)
      TYPE *,NAME,' has been saved'
      END
*----------------------------------------------------------------------

***********************************************************************
      SUBROUTINE DISPLAY_ERR(INF)
***********************************************************************
      IMPLICIT NONE
      CHARACTER*70 INF
      CHARACTER*1  ANSWER
 
      WRITE(6,11)INF
11    FORMAT('  Error: ',A70)

      RETURN
      END
*----------------------------------------------------------------------
