***********************************************************************
      SUBROUTINE CAL_ATOM_POS(N)
* The subroutine is used to calculate the positions of all monomer
**********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      REAL*4            X_TRANS,Y_TRANS,Z_TRANS
      INTEGER*4         I,J,K,L,N,M,MDN
      CHARACTER*80      information


      MDN=MONO_DAT(N)

      L=0
      IF (N_MONO0(N).NE.0)THEN 
        DO I=1,N_MONO0(N)             
          X_TRANS=X_START(N,I)*A(N,1)+
     *            Y_START(N,I)*B(N,1)+
     *            Z_START(N,I)*C(N,1)
          Y_TRANS=X_START(N,I)*A(N,2)+
     *            Y_START(N,I)*B(N,2)+
     *            Z_START(N,I)*C(N,2)
          Z_TRANS=X_START(N,I)*A(N,3)+
     *            Y_START(N,I)*B(N,3)+
     *            Z_START(N,I)*C(N,3)
          L=L+1
          N_ATOMS(N,L)=N_ATOMS(N,I)
          DO J=1,N_ATOMS(N,L) 
            X_POS(N,L,J)=X_TRANS+        
     *                   RAD_DIS(N,I)*COSD(ROT_ANG(N,I)+RAD_ANG(N,I))+
     *                   TRN_DIS(N,I)*COSD(ROT_ANG(N,I)+SET_ANG(N,I))+
     *                   THX_POS(N,J,MDN)*
     *                   COSD(ROT_ANG(N,I)+SET_ANG(N,I)+DIH_ANG(N,I))-
     *                   THY_POS(N,J,MDN)*
     *                   SIND(ROT_ANG(N,I)+SET_ANG(N,I)+DIH_ANG(N,I))
            Y_POS(N,L,J)=Y_TRANS+
     *                   RAD_DIS(N,I)*SIND(ROT_ANG(N,I)+RAD_ANG(N,I))+
     *                   TRN_DIS(N,I)*SIND(ROT_ANG(N,I)+SET_ANG(N,I))+
     *                   THX_POS(N,J,MDN)*
     *                   SIND(ROT_ANG(N,I)+SET_ANG(N,I)+DIH_ANG(N,I))+
     *                   THY_POS(N,J,MDN)*
     *                   COSD(ROT_ANG(N,I)+SET_ANG(N,I)+DIH_ANG(N,I)) 
            Z_POS(N,L,J)=Z_TRANS+THZ_POS(N,J,MDN)
            A_LOG(N,L,J)=TH_LOG(N,J,MDN)
            ATOM_TYPE(N,L,J)=THA_TYPE(N,J,MDN)
            ATOM_FRAC(N,L,J)=0.5
          END DO

          L=L+1
          N_ATOMS(N,L)=N_ATOMS(N,I)
          DO J=1,N_ATOMS(N,I)
          X_POS(N,L,J)=X_TRANS+        
     *                 RAD_DIS(N,I)*COSD(ROT_ANG(N,I)+RAD_ANG(N,I))+
     *                 TRN_DIS(N,I)*COSD(ROT_ANG(N,I)+SET_ANG(N,I))+
     *                 THX_POS(N,J,MDN)*
     *                 COSD(ROT_ANG(N,I)+SET_ANG(N,I)-DIH_ANG(N,I))-
     *                 THY_POS(N,J,MDN)*
     *                 SIND(ROT_ANG(N,I)+SET_ANG(N,I)-DIH_ANG(N,I))
          Y_POS(N,L,J)=Y_TRANS+
     *                 RAD_DIS(N,I)*SIND(ROT_ANG(N,I)+RAD_ANG(N,I))+
     *                 TRN_DIS(N,I)*SIND(ROT_ANG(N,I)+SET_ANG(N,I))+
     *                 THX_POS(N,J,MDN)*
     *                 SIND(ROT_ANG(N,I)+SET_ANG(N,I)-DIH_ANG(N,I))+
     *                 THY_POS(N,J,MDN)*
     *                 COSD(ROT_ANG(N,I)+SET_ANG(N,I)-DIH_ANG(N,I)) 
           Z_POS(N,L,J)=Z_TRANS+THZ_POS(N,J,MDN)
           A_LOG(N,L,J)=TH_LOG(N,J,MDN)
           ATOM_TYPE(N,L,J)=THA_TYPE(N,J,MDN)
           ATOM_FRAC(N,L,J)=0.5
         END DO

        END DO
      END IF
C   MDN: 1=THIO 2=PPVH6 3=PPVD2 4=PPVD4 5=PPVD6 
C        6=PPV 7=I3 8=THIO+ 9=I3A 10=I3B

      L=L+1                   !locate pos. of dopants                    
      IF (N_DOPANTS(N).NE.0)THEN      
        DO I=1,N_DOPANTS(N)
          X_TRANS=XA_START(N,I)*A(N,1)+
     *            YA_START(N,I)*B(N,1)+
     *            ZA_START(N,I)*C(N,1)
          Y_TRANS=XA_START(N,I)*A(N,2)+
     *            YA_START(N,I)*B(N,2)+
     *            ZA_START(N,I)*C(N,2)
          Z_TRANS=XA_START(N,I)*A(N,3)+
     *            YA_START(N,I)*B(N,3)+
     *            ZA_START(N,I)*C(N,3)

          X_POS(N,L,I)=X_TRANS+               
     *                 DOP_DIS(N,I)*COSD(TOT_ANG(N,I)+DOP_ANG(N,I))
          Y_POS(N,L,I)=Y_TRANS+               
     *                 DOP_DIS(N,I)*SIND(TOT_ANG(N,I)+DOP_ANG(N,I))
          Z_POS(N,L,I)=Z_TRANS                
          ATOM_TYPE(N,L,I)=DOP_TYPE(N,I)
          IF (DOP_TYPE(N,I).NE.0)THEN
            ATOM_FRAC(N,L,I)=DOP_FRAC(N,I)
          ELSE
            ATOM_FRAC(N,L,I)=0.0
          END IF
        END DO
      END IF
      N_ATOMS(N,L)=N_DOPANTS(N)  !total # of dopants

99    CALL DISPLAY_ERR(information)
      RETURN
      END
*--------------------------------------------------------------------

**********************************************************************      
*      This converts x,y,z coordinates to the fractional unit cell 
*       coordinates
	SUBROUTINE CAL_K_VEC(N)
**********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      REAL*4     DOT
      REAL*4     BXC(NP,3),CXA(NP,3),AXB(NP,3) !B cross C, C cross A, A cross B 
      INTEGER*4  I,J,N

      CHARACTER*1 TAG

      CALL CROSS(B,C,BXC,N)
      CALL CROSS(C,A,CXA,N)
      CALL CROSS(A,B,AXB,N)

      VOLUME(N)=DOT(A,BXC,N)
c     TYPE *,'VOLUME=',VOLUME(N)

C     Calculate reciprocal lattice vector
      DO I=1,3
	KA(N,I)=BXC(N,I)/VOLUME(N)
	KB(N,I)=CXA(N,I)/VOLUME(N)
	KC(N,I)=AXB(N,I)/VOLUME(N)
      END DO

      KAKA(N)=SQRT(DOT(KA,KA,N))
      KBKB(N)=SQRT(DOT(KB,KB,N))
      KCKC(N)=SQRT(DOT(KC,KC,N))

      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
*   This subroutine determines what Miller indicies are within range
      SUBROUTINE CAL_SF_IDX(N)
***********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_HKL.INC'

      REAL*4     T_MIN,T_MAX                     !min two_theta, max two_theta
      REAL*4     RU(NP,3),RURU,RU_MIN,RU_MAX        !ru is recipecial lattice
      REAL*4     DOT
      REAL*4     H,K,L
      REAL*4     TWO_THETA,WAVEVECTOR
      INTEGER*4  H_MIN,K_MIN,L_MIN
      INTEGER*4  H_MAX,K_MAX,L_MAX
      INTEGER*4  N,IIH,IIK,IIL
      INTEGER*4  I,N_R                           !# of reflections

      WAVEVECTOR(TWO_THETA)=2.0*SIND(TWO_THETA/2.0)/LAMDA
C     DSPACING(TWO_THETA)=1.0/WAVEVECTOR(TWO_THETA)     

      T_MAX=XVAL(JMAX)
      IF (T_MAX.GT.180.0) T_MAX=180.0
      T_MIN=XVAL(JMIN)
      IF (T_MIN.LT.0.) T_MIN=0.00001
      RU_MIN=WAVEVECTOR(T_MIN)
      RU_MAX=WAVEVECTOR(T_MAX)

C     Use only a half plane of points (assume centrosymmetric)
      H_MAX=IFIX(2.*RU_MAX/KAKA(N))+1
      K_MAX=IFIX(2.*RU_MAX/KBKB(N))+1
      L_MAX=IFIX(2.*RU_MAX/KCKC(N))+1
      H_MIN=-H_MAX
      K_MIN=-K_MAX
      L_MIN=-L_MAX

      IF (LAYER.GE.0)THEN
        L=FLOAT(LAYER)
        IIL=LAYER
11      N_R=0
        DO IIH=0,H_MAX
          DO IIK=K_MIN,K_MAX
	    IF (IIH.EQ.0 .AND. IIK.LE.0 .AND. IIL.EQ.0)GOTO 22
            H=FLOAT(IIH)
	    K=FLOAT(IIK)

            DO I=1,3
              RU(N,I)=H*KA(N,I)+K*KB(N,I)+L*KC(N,I)
            END DO
            RURU=(DOT(RU,RU,N))**0.5       !magnitude of vector RU
     	    IF (RURU.GT.RU_MAX.OR.RURU.LT.RU_MIN)GOTO 22
	    N_R=N_R+1
	    IF (N_R .GT. NI) THEN
              TYPE *, 'TOO MANY REFLECTIONS'
      	      RU_MAX=.95*RU_MAX
	      RU_MIN=1.05*RU_MIN
	      GOTO 11
	    END IF
	    N_M(N,N_R)=N_R
	    H_M(N,N_R)=IIH
	    K_M(N,N_R)=IIK
	    L_M(N,N_R)=IIL
            MULT(N,N_R)=1
            T_THETA(N,N_R)=2.0*ASIND(RURU*LAMDA/2.0)
c        type *,'NHKL=',n_m(n,n_r),h_m(n,n_r),k_m(n,n_r),l_m(n,n_r)
22  	  END DO
        END DO
        N_REFLECTIONS(N)=N_R
      ELSE  
        TYPE *,'Wrong Layer Number'
      END IF

      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
*   This subroutine determines the 2_theta for each HKL idx
      SUBROUTINE CAL_2_THETA(N)
***********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_HKL.INC'

      INTEGER*4    N,I,IDX
      REAL*4       H,K,L
      REAL*4       DOT
      REAL*4       RU(NP,3)            !ru vector (recipecial vector)
      REAL*4       RURU                !magnitude of RU vector        
      REAL*4       R(NP,3)             !real vector

      DO IDX=1,N_REFLECTIONS(N)
        H=FLOAT(H_M(N,IDX))
        K=FLOAT(K_M(N,IDX))
        L=FLOAT(L_M(N,IDX))
        DO I=1,3
          RU(N,I)=H*KA(N,I)+K*KB(N,I)+L*KC(N,I)
        END DO
        RURU=(DOT(RU,RU,N))**0.5       !magnitude of vector RU
        T_THETA(N,IDX)=2.0*ASIND(RURU*LAMDA/2.0)
      END DO

      RETURN
      END
*----------------------------------------------------------------------


***********************************************************************
*     This subroutine calculates the cross product of two vectors
*     using a CALL statement.
      SUBROUTINE CROSS(x,y,z,N)
***********************************************************************
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'

      REAL*4      x(NP,3),y(NP,3),z(NP,3)
      INTEGER*4   N

      z(N,1)=x(N,2)*y(N,3)-x(N,3)*y(N,2)
      z(N,2)=x(N,3)*y(N,1)-x(N,1)*y(N,3)
      z(N,3)=x(N,1)*y(N,2)-x(N,2)*y(N,1)

      RETURN
      END 
*----------------------------------------------------------------------

***********************************************************************
*    This function calculates the volume enclused by three vectors 
*    using a variable pass.
       FUNCTION DET(x1,x2,x3,y1,y2,y3,z1,z2,z3)
***********************************************************************
       REAL*4 x1,x2,x3 
       real*4 y1,y2,y3
       real*4 z1,z2,z3

       DET=x1*y2*z3+y1*z2*x3+z1*y3*x2-x3*y2*z1-y3*z2*x1-z3*y1*x2
       return
       end
*----------------------------------------------------------------------

***********************************************************************
*    This function calculates the dot product of two vectors 
*    using a variable pass.
      REAL FUNCTION DOT(x,y,N)
***********************************************************************
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'

      INTEGER*4   N
      REAL*4      x(NP,3),y(NP,3)

      DOT=x(N,1)*y(N,1)+x(N,2)*y(N,2)+x(N,3)*y(N,3)
      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
	FUNCTION MU_RHO(ATOMN)
***********************************************************************
        REAL*4 CUALPHA(0:106)
        INTEGER*4 ATOMN
        REAL*4 MU_RHO
C Nada  
        DATA CUALPHA(0)/0./
C Hydrogen
        DATA CUALPHA(1)/.435/
C Hydrogen - neutron
        DATA CUALPHA(101)/.545/
C Deuterium - neutron
        DATA CUALPHA(102)/.545/
C Deuterium Hydrogen crossover - neutron
        DATA CUALPHA(103)/.545/
C Lithium
        DATA CUALPHA(3)/0.716/
C Carbon
        DATA CUALPHA(6)/4.6/
C Carbon - neutron
        DATA CUALPHA(106)/14.5/
C Sodium 
        DATA CUALPHA(11)/30.1/
C Sulfer
        DATA CUALPHA(16)/89.1/
C Clorine
        DATA CUALPHA(17)/89.1/
C Potassium +1
        DATA CUALPHA(19)/143./
C Gallium
        DATA CUALPHA(31)/67.9/
C Rubidium 
        DATA CUALPHA(37)/117./
C Iodine  oops      
        DATA CUALPHA(50)/294./
C Iodine        
        DATA CUALPHA(53)/294./
C Cesium +1
        DATA CUALPHA(55)/318./
C Oxygen
        DATA CUALPHA(8)/11.5/
C Calcium
        DATA CUALPHA(20)/162./
C Copper
        DATA CUALPHA(29)/52.9/
C Strontium
        DATA CUALPHA(38)/125./
C Bismuth
        DATA CUALPHA(83)/240./
C
        MU_RHO=CUALPHA(ATOMN)
	RETURN
	END 
*----------------------------------------------------------------------

***********************************************************************
	FUNCTION ATOMIC_WEIGHT(ATOMN)
***********************************************************************
        REAL*4 ATOMW(0:106)
        INTEGER*4 ATOMN
        REAL*4 ATOMIC_WEIGHT
C Nada  
        DATA ATOMW(0)/0./
C Hydrogen
        DATA ATOMW(1)/1.00797/
C Hydrogen - neutron
        DATA ATOMW(101)/1.0079/
C Deuterium - neutron
        DATA ATOMW(102)/2.0000/
C Deuterium Hydrogen crossover - neutron
        DATA ATOMW(103)/2.0000/
C Lithium
        DATA ATOMW(3)/6.939/    
C Carbon
        DATA ATOMW(6)/12.01115/
C Carbon - neutron
        DATA ATOMW(106)/12.011/
C Sodium 
        DATA ATOMW(11)/22.9898/
C Sulfer
        DATA ATOMW(16)/32.06/
C Clorine
        DATA ATOMW(17)/35.453/
C Potassium +1
        DATA ATOMW(19)/39.098/
C Gallium
        DATA ATOMW(31)/69.72/
C Rubidium
        DATA ATOMW(37)/85.47/
C Iodine        
        DATA ATOMW(50)/126.9045/
C Iodine        
        DATA ATOMW(53)/126.9045/
C Cesium +1
        DATA ATOMW(55)/132.9054/
C Oxygen
        DATA ATOMW(8)/15.9994/
C Calcium
        DATA ATOMW(20)/40.08/
C Copper
        DATA ATOMW(29)/63.546/
C Strontium
        DATA ATOMW(38)/87.62/
C Bismuth
        DATA ATOMW(83)/208.9804/
C
        ATOMIC_WEIGHT=ATOMW(ATOMN)
	RETURN
	END 
*---------------------------------------------------------------------

***********************************************************************
*     This subroutine sorts idx according to intensity from min to max
      SUBROUTINE SORT_INT(N)
***********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_HKL.INC'

      REAL*4      INT_TEMP,T_THETA_TEMP,K_VEC_TEMP,WIDTH_TEMP
      INTEGER*4   N,I,J
      INTEGER*4   N_TEMP,H_TEMP,K_TEMP,L_TEMP

      IF (N_REFLECTIONS(N).EQ.0)THEN
        TYPE *,'NUMBER OF REFLECTIONS = 0'
        STOP
      END IF

      DO I=1,N_REFLECTIONS(N)
        N_M(N,I)=I
        DO J=I+1,N_REFLECTIONS(N)
          IF (INT_BAR(N,J).GT.INT_BAR(N,I))THEN
            INT_TEMP=INT_BAR(N,I)
            INT_BAR(N,I)=INT_BAR(N,J)
            INT_BAR(N,J)=INT_TEMP

            T_THETA_TEMP=T_THETA(N,I)
            T_THETA(N,I)=T_THETA(N,J)
            T_THETA(N,J)=T_THETA_TEMP

            N_TEMP  =N_M(N,I)
            N_M(N,I)=N_M(N,J)
            N_M(N,J)=N_TEMP

            H_TEMP  =H_M(N,I)
            H_M(N,I)=H_M(N,J)
            H_M(N,J)=H_TEMP

            K_TEMP  =K_M(N,I)
            K_M(N,I)=K_M(N,J)
            K_M(N,J)=K_TEMP

            L_TEMP  =L_M(N,I)
            L_M(N,I)=L_M(N,J)
            L_M(N,J)=L_TEMP

            WIDTH_TEMP=WIDTH(N,I)
            WIDTH(N,I)=WIDTH(N,J)
            WIDTH(N,J)=WIDTH_TEMP

            K_VEC_TEMP  =K_VEC(N,I)
            K_VEC(N,I)=K_VEC(N,J)
            K_VEC(N,J)=K_VEC_TEMP
          END IF
        END DO
c      type *,'nhkl=',n_m(n,I),h_m(n,I),k_m(n,I),l_m(n,I),intensity(n,I)
      END DO
      RETURN 
      END
*----------------------------------------------------------------------

***********************************************************************
*     This subroutine sorts idx according to two theta from min to max
      SUBROUTINE SORT_ANG(N)
***********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_HKL.INC'

      REAL*4      INT_TEMP,T_THETA_TEMP,K_VEC_TEMP,WIDTH_TEMP
      INTEGER*4   N,I,J
      INTEGER*4   N_TEMP,H_TEMP,K_TEMP,L_TEMP

      IF (N_REFLECTIONS(N).EQ.0)THEN
        TYPE *,'NUMBER OF REFLECTIONS = 0'
        STOP
      END IF

      DO I=1,N_REFLECTIONS(N)
        DO J=I+1,N_REFLECTIONS(N)
          IF (T_THETA(N,J).LT.T_THETA(N,I))THEN
            INT_TEMP=INT_BAR(N,I)
            INT_BAR(N,I)=INT_BAR(N,J)
            INT_BAR(N,J)=INT_TEMP

            T_THETA_TEMP=T_THETA(N,I)
            T_THETA(N,I)=T_THETA(N,J)
            T_THETA(N,J)=T_THETA_TEMP

            N_TEMP  =N_M(N,I)
            N_M(N,I)=N_M(N,J)
            N_M(N,J)=N_TEMP

            H_TEMP  =H_M(N,I)
            H_M(N,I)=H_M(N,J)
            H_M(N,J)=H_TEMP

            K_TEMP  =K_M(N,I)
            K_M(N,I)=K_M(N,J)
            K_M(N,J)=K_TEMP

            L_TEMP  =L_M(N,I)
            L_M(N,I)=L_M(N,J)
            L_M(N,J)=L_TEMP

            WIDTH_TEMP=WIDTH(N,I)
            WIDTH(N,I)=WIDTH(N,J)
            WIDTH(N,J)=WIDTH_TEMP

            K_VEC_TEMP=K_VEC(N,I)
            K_VEC(N,I)=K_VEC(N,J)
            K_VEC(N,J)=K_VEC_TEMP
          END IF
        END DO
c     type *,'nhkl=',n_m(n,I),h_m(n,I),k_m(n,I),l_m(n,I),intensity(n,I)
      END DO
      RETURN 
      END
*----------------------------------------------------------------------

***********************************************************************       
      SUBROUTINE CAL_MU_RHO(N)
***********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      REAL*4     MU
      REAL*4     POS_AFA               !AFA par
      REAL*4     ATOM_MU_SUM           !sum of atom mu
      REAL*4     A_WEIGHT              !sum of atoms
      REAL*4     ATOMIC_WEIGHT         !weight of anatom
      REAL*4     DENSITY               !
      REAL*4     MU_RHO                !
      REAL*4     XS,YS,CO,SI           !local variables
      REAL*4     XRP,YRP,XRN,YRN       !local variables
      INTEGER*4  I,J,N

      CHARACTER*1 TAG



C   Equatorial Librational parameter which varies for each atom
C   This is not a perfect algorithm for it fails if the setting 
C   angle is close to 0,90,180,270 degrees and the arc cuts through 
C   a priciple axis.  (but it is not too bad)
  
      IF (AUTO_FLAG.EQ..TRUE. .AND. SIDE_LIB(N).EQ.0.0)THEN
        RETURN
      END IF

      POS_AFA=AFA(N)
      ATOM_MU_SUM=0.0
      A_WEIGHT=0.0
      IF (N_MONO(N).NE.0)THEN
	DO I=1,N_MONO(N)
          IF (N_ATOMS(N,I).NE.0) then
            DO J=1,N_ATOMS(N,I)
              ATOM_MU_SUM=ATOM_MU_SUM+ATOMIC_WEIGHT(ATOM_TYPE(N,I,J))
     *                   *MU_RHO(ATOM_TYPE(N,I,J))*ATOM_FRAC(N,I,J)
              A_WEIGHT=A_WEIGHT+ATOMIC_WEIGHT(ATOM_TYPE(N,I,J))
     *                   *ATOM_FRAC(N,I,J)
              IF (A_LOG(N,I,J))THEN
                xs=X_POS(N,I,J)
                ys=Y_POS(N,I,J)
                CO=COSD(POS_AFA)
                SI=SIND(POS_AFA)
                xrp=xs*co-ys*si-xs
                yrp=xs*si+ys*co-ys  
                xrn=xs*co+ys*si-xs  
                yrn=-xs*si+ys*co-ys  
	        xr(N,I,J)=0.5*(ABS(xrp)+ABS(xrn))
    	        yr(N,I,J)=0.5*(ABS(yrp)+ABS(yrn))
              ELSE
                XR(N,I,J)=0.0
                YR(N,I,J)=0.0
              END IF
            END DO
          END IF
 	END DO
      END IF
      I=N_MONO(N)+1
      IF (N_ATOMS(N,I).NE.0)THEN
        DO J=1,N_ATOMS(N,I)
          ATOM_MU_SUM=ATOM_MU_SUM+ATOMIC_WEIGHT(ATOM_TYPE(N,I,J))
     *               *MU_RHO(ATOM_TYPE(N,I,J))*ATOM_FRAC(N,I,J)
          A_WEIGHT=A_WEIGHT+ATOMIC_WEIGHT(ATOM_TYPE(N,I,J))
     *               *ATOM_FRAC(N,I,J)
          XR(N,I,J)=0.0
          YR(N,I,J)=0.0
        END DO
      END IF
      MU=ATOM_MU_SUM/VOLUME(N)/.602
      SIDE_FACT(N)=SIDE_LIB(N)    !thickness
      MU_T(N)=SIDE_FACT(N)*MU
      DENSITY=A_WEIGHT/VOLUME(N)/.602

      WRITE(TAG,11)N
11    FORMAT(I1)

      IF (AUTO_FLAG.NE..TRUE.)THEN
        WRITE(6,12)N,MU,N,DENSITY 
12      FORMAT(' Mu-System(',I1,')=',F11.4,'(1/cm)   Density(',
     * I1,')=   ',F14.4,'(g/cm3)')
      END IF
      RETURN
      END
*----------------------------------------------------------------------



***********************************************************************
      SUBROUTINE CAL_SF_INT(N)
***********************************************************************
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      REAL*4       XXP                 !shape factor       
      REAL*4       H,K,L
      REAL*4       DOT, A_FORM_F
      REAL*4       RU(NP,3)            !ru vector (recipecial vector)
      REAL*4       STL                 !sin(theta)/lamda
      REAL*4       RURU                !magnitude of RU vector        
      REAL*4       R(NP,3)             !real vector
      REAL*4       RDOTRU              !R dots RU  
      REAL*4       PHASE
      REAL*4       BR, TEMP_LIB, FF
      REAL*4       F_REAL, F_IMAG
      REAL*4       AMPAMP              !squared of F
      REAL*4       BT, DEBYE           !debye factor of monomers
      REAL*4       BT_DOP, DEBYE_DOP   !debye factor of dopants
      REAL*4       ANISO_FACTOR        !anisotropy factor
      REAL*4       AG,CG,XMP,FRACTION  !for peak at hkl
      REAL*4       VALUE,GAUS,LORN     !for peak at hkl
      REAL*4       SIN_PHI,XX,YY,CHIA
      REAL*4       INT_FACT            !a function to compute FACT
      REAL*4       FACT(Ndat)          !various factor for intensity
      INTEGER*4    N,I,J,IDX

      DATA SIN_PHI/1.0/

      XXP=SHP_FRAC(N)                          !shape fraction factor
      DO I=JMIN,JMAX
        INTENSITY(N,I)=0.0
        FACT(I)=INT_FACT(XVAL(I),LAMDA,LORTYPE,MU_T(n))
      END DO

      DO IDX=1,N_USED(N)
        H=FLOAT(H_M(N,IDX))
        K=FLOAT(K_M(N,IDX))
        L=FLOAT(L_M(N,IDX))
        DO I=1,3
          RU(N,I)=H*KA(N,I)+K*KB(N,I)+L*KC(N,I)
        END DO

        RURU=(DOT(RU,RU,N))**0.5       !magnitude of vector RU
        STL=RURU/2.0
        K_VEC(N,IDX)=RURU
        T_THETA(N,IDX)=2.0*ASIND(RURU*LAMDA/2.0)

        FORM_F(0)=A_FORM_F(0,STL)
        FORM_F(1)=A_FORM_F(1,STL)  
        FORM_F(3)=A_FORM_F(3,STL)  
        FORM_F(6)=A_FORM_F(6,STL)      
        FORM_F(8)=A_FORM_F(8,STL)      
        FORM_F(11)=A_FORM_F(11,STL)        
        FORM_F(16)=A_FORM_F(16,STL)      
        FORM_F(17)=A_FORM_F(17,STL)
        FORM_F(19)=A_FORM_F(19,STL)
        FORM_F(20)=A_FORM_F(20,STL)
        FORM_F(29)=A_FORM_F(29,STL)      
        FORM_F(31)=A_FORM_F(31,STL)      
        FORM_F(37)=A_FORM_F(37,STL)      
        FORM_F(38)=A_FORM_F(38,STL)      
        FORM_F(50)=A_FORM_F(50,STL)      
        FORM_F(53)=A_FORM_F(55,STL)      
        FORM_F(55)=A_FORM_F(55,STL)      
        FORM_F(83)=A_FORM_F(83,STL)      
C    !neutron form factors are independant of k
        FORM_F(101)=A_FORM_F(101,STL)      
        FORM_F(102)=A_FORM_F(102,STL)      
        FORM_F(103)=A_FORM_F(103,STL)      
        FORM_F(106)=A_FORM_F(106,STL)      

        BT=0.0
        DO I=1,3
          BT=BT+DB(N,I)*RU(N,I)**2.0                                     
        END DO
        DEBYE=SQRT(EXP(-19.7392*BT))            

        BT_DOP=0.0
        DO I=1,3
          BT_DOP=BT_DOP+DB_DOP(N)*RU(N,I)**2.0    
        END DO
        DEBYE_DOP=SQRT(EXP(-19.7392*BT_DOP))            

        CALL ANISOTROPY(N,H,K,ANISO_FACTOR)

        F_REAL=0.0              !scattering factor
        F_IMAG=0.0
        DO I=1,N_MONO(N)+1
          DO J=1,N_ATOMS(N,I)
            R(N,1)=X_POS(N,I,J)
            R(N,2)=Y_POS(N,I,J)
            R(N,3)=Z_POS(N,I,J)
            RDOTRU=DOT(R,RU,N)
            PHASE=TWOPI*RDOTRU
	    BR=(XR(N,I,J)*RU(N,1))**2.+(YR(N,I,J)*RU(N,2))**2.+  !libration
     *         ((XR(N,I,J)**2.+YR(N,I,J)**2.)**.5*RU(N,3))**2.
            TEMP_LIB=EXP(-19.7392*BR)                     
            FF=FORM_F(ATOM_TYPE(N,I,J))*ATOM_FRAC(N,I,J)*TEMP_LIB*
     *         PHS_FRAC(N)

            IF (I.LE.N_MONO(N))THEN
              F_REAL=F_REAL+FF*COS(PHASE)*DEBYE*ANISO_FACTOR         
              F_IMAG=F_IMAG+FF*SIN(PHASE)*DEBYE*ANISO_FACTOR  
            ELSE
              F_REAL=F_REAL+FF*COS(PHASE)*DEBYE_DOP*ANISO_FACTOR         
              F_IMAG=F_IMAG+FF*SIN(PHASE)*DEBYE_DOP*ANISO_FACTOR  
            END IF
          END DO
        END DO

      
C       get debye factor


        IF (LORTYPE.EQ.2)THEN
          YY=RU(N,3)/RURU*RURU
          XX=(ABS(RURU*RURU-YY*YY))**.5
          IF (XX.EQ.0.) THEN
            CHIA=90.
          ELSE 
            CHIA=ATAND(YY/XX)
          ENDIF
          SIN_PHI=1./SIND(90.-SIND(CHIA)*T_THETA(N,IDX))
        END IF

        AMPAMP=(F_REAL*F_REAL+F_IMAG*F_IMAG)*FLOAT(MULT(N,IDX))
        IF (AMPAMP .LT. 1.0E-08)AMPAMP=0.0

        INT_BAR(N,IDX)=(AMPAMP/SIN_PHI)*
     *                 INT_FACT(T_THETA(N,IDX),LAMDA,LORTYPE,MU_T(N))     



C       calculate intensity at each two_theta
C       AG=1.77245/WIDTH(N,IDX)       !set peak width and shape
C       CG=(AG)**2.
C	XMP=1.0-XXP
C       DO I=JMIN,JMAX
C         VALUE=CG*(XVAL(I)-T_THETA(N,IDX))**2.
C         GAUS = EXP(-VALUE)
C         LORN = 1./(1.+3.1415926*VALUE)
C         FRACTION=AMPAMP*(XXP*GAUS+XMP*LORN)/WIDTH(N,IDX)
C         INTENSITY(N,I)=INTENSITY(N,I)+FRACTION*FACT(I)     
C       END DO
C     END DO

        AG=2.0/WIDTH(N,IDX)       !set peak width and shape
        CG=(AG)**2.0
	XMP=1.0-XXP
        DO I=JMIN,JMAX
          VALUE=CG*(XVAL(I)-T_THETA(N,IDX))**2.0
          GAUS = EXP(-0.6931471*VALUE)
          LORN = 1.0/(1.0+VALUE)
          FRACTION=AMPAMP*(XXP*GAUS+XMP*LORN)/WIDTH(N,IDX)
          INTENSITY(N,I)=INTENSITY(N,I)+FRACTION*FACT(I)     
        END DO
      END DO



      CALL SORT_INT(N)

      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
	FUNCTION A_FORM_F(IA,SIN_LAMDA)
***********************************************************************
        IMPLICIT NONE

   	REAL A1(0:106),B1(0:106),A2(0:106),B2(0:106),A3(0:106),
	2 B3(0:106),A4(0:106),B4(0:106),C(0:106)
        REAL SIN_LAMDA,FVAL
        REAL A_FORM_F
        INTEGER*4 IA
C Nada 
	DATA A1(0),B1(0),A2(0),B2(0),A3(0),B3(0),A4(0),B4(0),C(0)/
	2 0.00000,00.0000,0.00000,00.0000,0.000000,0.00000,
	2 0.000000,0000000,0.000000/
C Hydrogen
	DATA A1(1),B1(1),A2(1),B2(1),A3(1),B3(1),A4(1),B4(1),C(1)/
	2 0.49300,10.5109,0.32291,26.1257,0.140191,3.14236,
	2 0.040810,57.7997,0.003038/
C Hydrogen - neutron
	DATA A1(101),B1(101),A2(101),B2(101),A3(101),B3(101),
	2 A4(101),B4(101),C(101)/8*0.0,-.374/
C Deuterium - neutron
	DATA A1(102),B1(102),A2(102),B2(102),A3(102),B3(102),
	2 A4(102),B4(102),C(102)/8*0.0,.667/
C Deuterium Hydrogen crossover - neutron
	DATA A1(103),B1(103),A2(103),B2(103),A3(103),B3(103),
	2 A4(103),B4(103),C(103)/8*0.0,.2504/
C Lithum 1+
	DATA A1(3),B1(3),A2(3),B2(3),A3(3),B3(3),A4(3),
	2 B4(3),C(3)/
	2 0.696800,4.62370,0.78880, 1.95570, 0.341400,0.631600,
	2 0.156300, 10.0953,0.016700/
C Carbon
	DATA A1(6),B1(6),A2(6),B2(6),A3(6),B3(6),A4(6),B4(6),C(6)/
	2 2.31000,20.8439,1.02000,10.20750,1.56870,0.56870,
	2 0.8650000,51.6512,0.215600/
C Carbon - neutron
	DATA A1(106),B1(106),A2(106),B2(106),A3(106),B3(106),
	2 A4(106),B4(106),C(106)/8*0.0,.665/
C Oxygen
	DATA A1(8),B1(8),A2(8),B2(8),A3(8),B3(8),A4(8),
	2 B4(8),C(8)/
	2 3.04850,13.2771,2.28680,5.7011,1.5463,0.3239,
	2 0.867,32.9089,0.2508/
C Sodium 1+
	DATA A1(11),B1(11),A2(11),B2(11),A3(11),B3(11),A4(11),
	2 B4(11),C(11)/
	2 3.25650, 2.6671,3.93620, 6.11530,1.39980,0.20010,
	2 1.0032000,14.0390,0.404000/
C Sulfer
	DATA A1(16),B1(16),A2(16),B2(16),A3(16),B3(16),A4(16),
	2 B4(16),C(16)/
	2 6.90530,1.4679,5.20340,22.2151,1.43790,0.2536,
	2 1.58630,56.1720,0.866900/
C Clorine 
	DATA A1(17),B1(17),A2(17),B2(17),A3(17),B3(17),A4(17),
	2 B4(17),C(17)/
	2 11.4604,0.01040,7.1964,1.16620,6.25560,18.5194,
	2 1.64550,47.7784,-9.55740/
C Potassium +1
	DATA A1(19),B1(19),A2(19),B2(19),A3(19),B3(19),A4(19),
	2 B4(19),C(19)/
	2 7.95780,12.633,7.49170,0.76740,6.35900,-.0020,
	2 1.19150,31.9128,-4.99780/
C Calcium
	DATA A1(20),B1(20),A2(20),B2(20),A3(20),B3(20),A4(20),
	2 B4(20),C(20)/
	2 8.6266,10.4421,7.3873,0.6599,1.5899,85.7484,
	2 1.0211,178.437,1.3751/
C Copper
	DATA A1(29),B1(29),A2(29),B2(29),A3(29),B3(29),A4(29),
	2 B4(29),C(29)/
	2 13.338,3.5828,7.1676,0.247,5.6158,11.3966,
	2 1.6735,64.8126,1.191/
C Gallium  
	DATA A1(31),B1(31),A2(31),B2(31),A3(31),B3(31),A4(31),
	2 B4(31),C(31)/
	2 15.2354,3.0669,6.70060,.241200,4.35910,10.7805,
	2 2.96230,61.4135,1.71890/
C Rubidium 1+
	DATA A1(37),B1(37),A2(37),B2(37),A3(37),B3(37),A4(37),
	2 B4(37),C(37)/
	2 17.5816, 1.71390,7.65980, 14.7957,5.89810,0.160300,
	2 2.78170, 31.2087, 2.07820/
C Strontium
	DATA A1(38),B1(38),A2(38),B2(38),A3(38),B3(38),A4(38),
	2 B4(38),C(38)/
	2 17.5663,1.5564,9.8184,14.0988,5.422,0.1664,
	2 2.66940,132.376,2.50640/
C Iodine oops       
	DATA a1(50),b1(50),a2(50),b2(50),a3(50),b3(50),a4(50),
	2 B4(50),C(50)/
	2 20.1472,4.3470,19.9949,0.38140,7.51380,27.7660,
	2 2.27350,66.8776, 4.07120/
C Iodine        
	DATA a1(53),b1(53),a2(53),b2(53),a3(53),b3(53),a4(53),
	2 B4(53),C(53)/
	2 20.1472,4.3470,19.9949,0.38140,7.51380,27.7660,
	2 2.27350,66.8776, 4.07120/
C Cesium +1
	DATA A1(55),B1(55),A2(55),B2(55),A3(55),B3(55),A4(55),
	2 B4(55),C(55)/
	2 20.3524,3.5520,19.1278,.308600,10.2821,23.7128,
	2 .961500,59.4565,3.279100/
C Bismuth
	DATA A1(83),B1(83),A2(83),B2(83),A3(83),B3(83),A4(83),
	2 B4(83),C(83)/
	2 33.3689,0.704,12.951,2.9238,16.5877,8.7937,
	2 6.4692,48.0093,13.5782/
C
	FVAL=SIN_LAMDA*SIN_LAMDA
	A_FORM_F=A1(IA)/EXP(B1(IA)*FVAL)+A2(IA)/EXP(B2(IA)*FVAL)+
	2  A3(IA)/EXP(B3(IA)*FVAL)+A4(IA)/EXP(B4(IA)*FVAL)+C(IA)
	RETURN
	END 
*----------------------------------------------------------------------
 
***********************************************************************
      REAL FUNCTION INT_FACT(ANGLE,LAMDA,LORTYPE,MU_T)
***********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'

      REAL*4   ANGLE                           !two_theta for data
      REAL*4   LAMDA                           !wavelength
      REAL*4   MU_T                            !absorption coef.
      REAL*4   POLA,POLB,POLARIZ               !polarization factor 
      REAL*4   LORENTZ                         !lorentz factor 
      REAL*4   GEOM                            !absorption factor  
      INTEGER*4 LORTYPE

      POLA=1.0+(COSD(ANGLE)*COSD(2.*26.))**2.0    
      POLB=1.0+(COSD(2.*26.))**2.0
      POLARIZ=POLA/POLB
      IF (LAMDA.GE.2.) POLARIZ=1.
c     type *,'polariz=',polariz
      LORENTZ=1.0/SIND(ANGLE)/SIND(ANGLE/2.0)   
      IF (LORTYPE.EQ.1) LORENTZ=1./SIND(ANGLE)
      IF (LORTYPE.EQ.3) LORENTZ=1./(SIND(ANGLE)**1.5)
      IF (LORTYPE.EQ.2) LORENTZ=1./(SIND(ANGLE))**2.0/COSD(ANGLE)
c     type *,'lorentz=',lorentz

      GEOM=EXP(-MU_T)/COSD(ANGLE)/COSD(ANGLE)  
c        type *,'geom=',geom

      INT_FACT=POLARIZ*LORENTZ*GEOM

      RETURN
      END
*----------------------------------------------------------------------


********************************************************************
*  The subroutine will calculate the intensity distribution through
*  two-theta range, and add them togther as fitted data
      SUBROUTINE PROFILE(N)
********************************************************************
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      REAL*4       INT_EXPT,INT_CALC           
      REAL*4       GEOMFACT,REDUCE
      REAL*4       CHI_SQUARE(0:NP)     
      INTEGER*4    N,I,J
      CHARACTER*1  TAG

      INT_EXPT=0.0    !sumation of expt. intensity
      INT_CALC=0.0    !sumation of calc. intensity
      DO I=JMIN,JMAX
        IF (XVAL(I).LE.ASMAX .AND. XVAL(I).GE.ASMIN) THEN
          INT_EXPT=INT_EXPT+YVAL(I)-BGD(I)
          INT_CALC=INT_CALC+INTENSITY(N,I)
        END IF
      END DO

*---------------------------------------------------------------------
*   Inserted here is an invisible approximate geometrical correction
*   on the reported scale factor
      GEOMFACT=1.0
      IF (INT_CALC.NE.0.) THEN
        REDUCE=INT_EXPT*GEOMFACT/INT_CALC
      ELSE 
        REDUCE=1.0
        TYPE*,'INT_CALC=0'
      END IF

      DO I=JMIN,JMAX
        FIT_D(N,I)=INTENSITY(N,I)*REDUCE+BGD(I)
      END DO

      DO J=1,N_USED(N)
            X_BAR(N,J)=T_THETA(N,J)
            Y_BAR(N,J)=INT_BAR(N,J)*REDUCE
      END DO

      S(N)=0.
      DO I=JMIN,JMAX
        IF (YVAL(I).NE.0.0)THEN
	  S(N)=S(N)+((YVAL(I)-FIT_D(N,I))**2.)/YVAL(I)
c        ELSE IF(FIT_D(N,I).NE.0)THEN
c	  S(N)=S(N)+((YVAL(I)-FIT_D(N,I))**2.)/FIT_D(N,I)
        END IF
      END DO
      S(N)=S(N)/FLOAT(JMAX-JMIN+1)
      CHI_SQUARE(N) = S(N)
                           
C     CALL DISTANCES
      WRITE(TAG,11)N
11    FORMAT(I1)

      WRITE(6,15)TAG,CHI_SQUARE(N),TAG,REDUCE
15    FORMAT(' Chi-Square(',A1,')=',E15.8,'   Integrated-Scale(',
     *A1,')=',E11.4)
      TYPE *,'          '
      RETURN                
      END
*----------------------------------------------------------------------


********************************************************************
*  The subroutine will find the peak width for each HKL idx   
*  when p_peak in sf.par1 or sf.par2 equals PWID in sf.idx1
*  or sf.idx2 .
      SUBROUTINE CAL_PEAK_WIDTH(N)
********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      INTEGER*4 I,J,K,N
      REAL*4    FACTOR,KK

      IF (XVAL(JMIN).LT.PR(N,1))THEN
        PR(N,0)=XVAL(JMIN)
      ELSE
        PR(N,0)=0.0  
      END IF

      IF (XVAL(JMAX).GT.PR(N,10))PR(N,10)=XVAL(JMAX)
      PR(N,11)=PR(N,10)+20.0

      DO I =1,N_USED(N)
        FACTOR=0.0
        DO K=1,8
          KK=FLOAT(K)
          FACTOR=FACTOR+PWA(N,K)/(COSD(T_THETA(N,I)/2.0))**KK
        END DO
        DO J=1,10
          IF (T_THETA(N,I).LE.PR(N,0))THEN
            WIDTH(N,I)=PWIDTH(N,1)*FACTOR
          ELSE IF (T_THETA(N,I).GT.PR(N,J-1) .AND.
     *             T_THETA(N,I).LE.PR(N,J))THEN
            WIDTH(N,I)=PWIDTH(N,J)*FACTOR                       
          ELSE IF(T_THETA(N,I).GT.PR(N,10))THEN
            WIDTH(N,I)=PWIDTH(N,10)*FACTOR                   
          END IF
        END DO
      END DO
      RETURN
      END
*----------------------------------------------------------------------

**************************************************************************
*
C NOTE:   THE REDUCE FACTOR(SCALING FACTOR) IS NOW AN ANISOTROPY FACTOR
C(REDUCE) WHICH HAS MAXIMUMS AT 30 AND 90 DEGREES FOR TRANSMISSION
C         (POSITIVE REDUCE) AND AT 0 AND 60 DEGREES FOR REFLECTION
C         (NEGATIVE REDUCE).  THESE ANGLES ARE MEASURED IN THE A STAR
C         B STAR PLANE WITH A STAR BEING ZERO DEGREES.
C         TO THE A STAR AXIS.
C     IF ANISO INFO IS DEFAULT(ANISO_ANGLE=0,ANISO_WIDTH=20)
C     , THEN IT IS ASSUMED TO BE PPV ISO FACTOR
C     AS ABOVE.  OTHERWISE ANISOTROPY IS A FACTOR WITH A MAXIMUM
C     AT ANISO_ANGLE WITH A HWHM OF ANISO_WIDTH
*
*************************************************************************
*
      SUBROUTINE ANISOTROPY(N,H,K,G)
*************************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_HKL.INC'
      INCLUDE  'SF_PAR.INC'

      INTEGER*4 N,I
      REAL*4    A_ST(3),B_ST(3),X,G,A_ST_MAG,K_MAG_AB,PHI,H,K,GFACTOR,
     *          PHIFACTOR,HH,KK

      DO I=1,3
        A_ST(I)=KA(N,I)
        B_ST(I)=KB(N,I)
      END DO

      X=ANISOTR(N)

      IF (ANISO_ANGLE.EQ.0 .AND. ANISO_WIDTH.EQ.20) THEN !PPV 2 HUMP ANISO
        IF (H.EQ.0.AND.K.EQ.0) THEN
          G=1.
          RETURN
        END IF

        HH=H
        KK=K
        A_ST_MAG=(A_ST(1)*A_ST(1)+A_ST(2)*A_ST(2)+A_ST(3)*A_ST(3))**.5
        K_MAG_AB=((HH*A_ST(1)+KK*B_ST(1))**2.+(HH*A_ST(2)+KK*B_ST(2))**2.
     *        +(HH*A_ST(3)+KK*B_ST(3))**2.)**.5
        PHIFACTOR=ABS(HH*A_ST(1)*A_ST(1)+KK*A_ST(1)*B_ST(1)+
     *              HH*A_ST(2)*A_ST(2)+KK*A_ST(2)*B_ST(2)+
     *              HH*A_ST(3)*A_ST(3)+KK*A_ST(3)*B_ST(3))
     *              /A_ST_MAG/K_MAG_AB
        IF (PHIFACTOR.GE.1.) PHIFACTOR=1.
        PHI=ABS(ACOSD(PHIFACTOR))
        IF (X.LT.0.) THEN
          PHI=ABS(PHI-90.)
          X=-X
        END IF
        GFACTOR=4.43614E-03           !4.*LN(2)/25./25.
        G=1.+X*(     EXP(-(PHI-30)*(PHI-30)*GFACTOR)
     *          +1.8*EXP(-(PHI-90)*(PHI-90)*GFACTOR))   
      ELSE  ! SINGLE HUMP ANIO AT ANISO_ANGLE WITH ANISO_WIDTH
        IF (H.EQ.0.AND.K.EQ.0) THEN
          G=1.
          RETURN
        END IF
        
        HH=H
        KK=K
        A_ST_MAG=(A_ST(1)*A_ST(1)+A_ST(2)*A_ST(2)+A_ST(3)*A_ST(3))**.5
        K_MAG_AB=((HH*A_ST(1)+KK*B_ST(1))**2.+(HH*A_ST(2)+KK*B_ST(2))**2.
     *        +(HH*A_ST(3)+KK*B_ST(3))**2.)**.5
        PHIFACTOR=(HH*A_ST(1)*A_ST(1)+KK*A_ST(1)*B_ST(1)+
     *              HH*A_ST(2)*A_ST(2)+KK*A_ST(2)*B_ST(2)+
     *              HH*A_ST(3)*A_ST(3)+KK*A_ST(3)*B_ST(3))
     *              /A_ST_MAG/K_MAG_AB
C        IF (ABS(PHIFACTOR).GT.1.) THEN
C          TYPE*,'PHI FACTOR OUT OF BOUNDS!'
C          TYPE*,'PHIFACTOR: ',PHIFACTOR
C          TYPE*,'H,K: ',HH,KK
C          TYPE*,'A_ST: ',A_ST(1),A_ST(2),A_ST(3)
C          TYPE*,'B_ST: ',B_ST(1),B_ST(2),B_ST(3)
C        END IF
        IF (KK.EQ.0) THEN
          IF (HH.GE.0) PHI=0.
          PHI=180.
        ELSE
          PHI=ACOSD(PHIFACTOR)
        END IF
        IF (KK.LE.0) PHI=-PHI
        PHI=PHI+(90.-ANISO_ANGLE)
        IF (PHI.GE.180.) PHI=PHI-360.
        IF (PHI.LE.-180.) PHI=PHI+360.
        IF (PHI.GT.90. .AND. PHI.LE.180.) THEN
          PHI=-PHI+180.
        ELSE IF (PHI.LT.0. .AND. PHI.GE.-90.) THEN 
          PHI=-PHI
        ELSE IF (PHI.LE.-90. .AND. PHI.GE.-180.) THEN
          PHI=PHI+180.
        END IF
        PHI=PHI-(90.-ANISO_ANGLE)
        GFACTOR=-2.772588722/ANISO_WIDTH/ANISO_WIDTH  !4.*LN(.5)
        G=1.+X*EXP((ANISO_ANGLE-PHI)*(ANISO_ANGLE-PHI)*GFACTOR)
      END IF
      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
*     The subroutine will sum profile_1 and profile_2 
      SUBROUTINE CAL_TOT_PROF()
***********************************************************************
      IMPLICIT NONE
	include '($iodef)'
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      INTEGER*4    N,I,J
      REAL*4       INT_EXPT,INT_CALC           
      REAL*4       GEOMFACT,REDUCE
      REAL*4       CHI_SQUARE(0:NP)     
      REAL*4       TOT_INT(0:NP)
      REAL*4       TOT_PHS(0:NP)
      REAL*4       DOP_WEIGHT,MONO_WEIGHT
      REAL*4       INT_RATIO(NP)                
      INTEGER*4    DATC_TYPE
      CHARACTER*1  TAG

      DOP_WEIGHT=0.0
      MONO_WEIGHT=0.0
      DO I=1,N_PHASES
        MONO_WEIGHT=MONO_WEIGHT+float(N_MONO0(I))*PHS_FRAC(I)
        IF (N_DOPANTS(I).NE.0.0)THEN
          DO J=1,N_DOPANTS(I)
            DOP_WEIGHT=DOP_WEIGHT+DOP_FRAC(I,J)*PHS_FRAC(I)
          END DO
        END IF
      END DO
      IF (MONO_WEIGHT.NE.0.0)DOP_DENSITY=DOP_WEIGHT/MONO_WEIGHT


      DO I=JMIN,JMAX
        INTENSITY(0,I)=INTENSITY(1,I)+
     *                 INTENSITY(2,I)
C        TYPE *,INTENSITY(0,I),INTENSITY(1,I),INTENSITY(2,I)
      END DO

      INT_EXPT=0.0    !sumation of expt. intensity
      INT_CALC=0.0    !sumation of calc. intensity
      DO I=JMIN,JMAX
        IF (XVAL(I).LE.ASMAX .AND. XVAL(I).GE.ASMIN) THEN
          INT_EXPT=INT_EXPT+YVAL(I)-BGD(I)
          INT_CALC=INT_CALC+INTENSITY(0,I)
        END IF
      END DO

      IF (INT_CALC.NE.0.) THEN
        GEOMFACT=1.0
        REDUCE=INT_EXPT*GEOMFACT/INT_CALC
      ELSE 
        TYPE*,'INT_CALC=0'
      END IF

      PHS_FRAC(0)=1.0
      DO I=0,N_PHASES
        TOT_INT(I)=0.0
        TOT_PHS(I)=0.0
      END DO

      DO N=0,2
        DO I=JMIN,JMAX
          FIT_D(N,I)=INTENSITY(N,I)*REDUCE+BGD(I)
          TOT_INT(N)=TOT_INT(N)+FIT_D(N,I)-BGD(I)
        END DO
      END DO

      IF (TOT_INT(0).NE.0.0)THEN
        INT_RATIO(1)=TOT_INT(1)/TOT_INT(0)
        INT_RATIO(2)=TOT_INT(2)/TOT_INT(0)
      END IF

      DO I=1,2
        IF (N_MONO0(I).NE.0) TOT_PHS(I)=INT_RATIO(I)/N_MONO0(I)
        TOT_PHS(0)=TOT_PHS(0)+TOT_PHS(I)
      END DO

      IF (TOT_PHS(0).NE.0.0)THEN
        DO I=1,2
          PHS_RATIO(I)=TOT_PHS(I)/TOT_PHS(0)
        END DO
      END IF

      DO N=1,2
        DO I=1,N_USED(N)
          X_BAR(N,I)=T_THETA(N,I)
          Y_BAR(N,I)=INT_BAR(N,I)*REDUCE
        END DO
      END DO
      AVE_DEV(0)=0.0
      S(0)=0.0 
      DO I=JMIN,JMAX
        IF (YVAL(I).NE.0.0)THEN
	  S(0)=S(0)+((YVAL(I)-FIT_D(0,I))**2.)/YVAL(I)
	  AVE_DEV(0)=AVE_DEV(0)+ABS(YVAL(I)-FIT_D(0,I))/FIT_D(0,I)
        END IF
      END DO
      AVE_DEV(0)=AVE_DEV(0)/FLOAT(JMAX-JMIN+1)
      S(0)=S(0)/FLOAT(JMAX-JMIN+1)
      CHI_SQUARE(0) = S(0)
                           
C     CALL DISTANCES


      IF (AUTO_FLAG.EQ..FALSE.)THEN
        WRITE(6,19)REDUCE
19      FORMAT(' REDUCE-FACTOR=',E15.4)
C        WRITE(6,20)DOP_DENSITY                            
C20      FORMAT(' Doping_Density=',F15.4)
      END IF

      IF (AUTO_FLAG.EQ..TRUE. .AND. SS_MIN-S(0).GT.0.0001)THEN
        TYPE*,'NEW SS_MIN!'
      END IF


        WRITE(6,21)INT_RATIO(1),INT_RATIO(2)              
21      FORMAT(' Int_1:         ',F9.4,
     *'         Int_2:              ',F8.4)

C      WRITE(6,23)PHS_RATIO(1),PHS_RATIO(2)               
C23    FORMAT(' Phase_1:       ',F9.4,
C     *'         Phase_2:            ',F8.4)


      TAG='0'
      WRITE(6,25)TAG,CHI_SQUARE(0),TAG,AVE_DEV(0)
25    FORMAT(' Chi-Square(',A1,')=',F10.4,'         Ave-Deviation(',
     *A1,')=',F11.4)
      TYPE *,'          '
	
      RETURN                
      END
*----------------------------------------------------------------------

***********************************************************************  
      SUBROUTINE WR_SF_DATC(N)
***********************************************************************
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_DAT.INC'
      INCLUDE  'SF_HKL.INC'

      INTEGER*4    I,N,DATC_TYPE
      CHARACTER    TAG*1,NAME*8

      WRITE(TAG,10)N
10    FORMAT(I1)
      NAME='SF.DATC'//TAG

      OPEN(UNIT=33,FILE=NAME,STATUS='NEW')
      DO I=JMIN,JMAX
        WRITE(33,*)XVAL(I),FIT_D(N,I)
      END DO
      CLOSE(UNIT=33)

      TYPE *,NAME,' have been saved'


C     DATC_TYPE=-10
C     DO WHILE(DATC_TYPE.NE.0 .AND. DATC_TYPE.NE.1 .AND. 
C    *         DATC_TYPE.NE.2)
C        TYPE *,'      '
C        TYPE *,'0 sf.datc,  1 sf.datc_1,  2 sf.datc_2'
C        READ (5,*)DATC_TYPE
C     END DO
C     N=DATC_TYPE
C     IF (N.EQ.0)THEN
C       NAME='SF.DATC'
C     ELSE IF(N.EQ.1)THEN
C       NAME='SF.DATC_1'
C     ELSE IF(N.EQ.2)THEN
C       NAME='SF.DATC_2'
C     END IF
C     OPEN(UNIT=1,NAME=NAME,STATUS='NEW')
C     DO I=JMIN,JMAX
C       IF (N.EQ.0)THEN
C         WRITE(1,11)XVAL(I),FIT_D(N,I)
C       ELSE
C         WRITE(1,11)XVAL(I),FIT_D(N,I)-BGD(I)
C       END IF
C     END DO
C11   FORMAT(F7.2, F10.2)
C     CLOSE(UNIT=1)
C     TYPE *, NAME,' has been saved'


      RETURN
      END
*----------------------------------------------------------------------


***********************************************************************
      SUBROUTINE AUTO_FIT(N)
***********************************************************************

      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_HKL.INC'


      INTEGER*4    N
      INTEGER*4    IRD,IWR,ITD,IFLAG
      CHARACTER    TAG*1,NAME*8,ANSWER*1
      PARAMETER    (IRD=91,IWR=92,ITD=93)

      WRITE(TAG,15)N
15     FORMAT(I1)
      NAME='FIT.DAT'//TAG

      SS_MIN=1.0E+34
      NTHPAR=N
      AUTO_FLAG=.TRUE.

      OPEN (UNIT=IRD,NAME=name,STATUS='OLD')
      OPEN (UNIT=IWR,NAME='FIT.RES',STATUS='NEW')
      OPEN (UNIT=ITD,NAME='FIT.COM',STATUS='NEW')

      CALL MINTIO(IRD,IWR,ITD)
      CALL MINNEW

      CLOSE (UNIT=IRD)
      CLOSE (UNIT=IWR)
      CLOSE (UNIT=ITD)
      RETURN
      END
*------------------------------------------------------------------

*******************************************************************
*     The subroutine is used by AUTO-FIT program
      SUBROUTINE FCN(NPAR,G,SS,XPM,IFLAG)
*******************************************************************
                   
      IMPLICIT NONE
      INCLUDE  'SF_CON.INC'
      INCLUDE  'SF_PAR.INC'
      INCLUDE  'SF_HKL.INC'

      INTEGER*4    NPAR,IFLAG,I,J
      REAL*8       XPM(NAP),G(NAP),OLD_XPM(NAP)
      REAL*8       SS  
      REAL*4       MIN_XPM(-NAP:NAP)
      LOGICAL*1    EXIT_LOOP/.FALSE./
      CHARACTER    ANSWER*1

      CALL KBOARD_INTERRUPT(EXIT_LOOP)
      IF (EXIT_LOOP.EQ..TRUE.)THEN
        DO J=1,NAP
          PARAM(NTHPAR,J)=MIN_XPM(J)
          PARAM(NTHPAR,-J)=-MIN_XPM(J)
        END DO
   	CALL WR_SF_PAR12(NTHPAR)    
        CALL WR_SF_DATC(0)
        CALL WR_RSF_INF()
        STOP
      END IF

      IF (IFLAG.LE.1)THEN
        RETURN

      ELSE IF(IFLAG.EQ.2)THEN
        RETURN

      ELSE IF(IFLAG.EQ.3)THEN
        AUTO_FLAG=.FALSE.

        TYPE *, 'FINAL CELL MODEL'
C 	TYPE *, 'DO YOU WISH TO UPDATE PARAM.DAT? Y/N(D)'
C 	READ(5,11) ANSWER
C11   	FORMAT(A1)
C 	IF (ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y') THEN
          IF (NTHPAR.EQ.0)THEN
            DO I=1,NP
              DO J=1,NAP
                PARAM(I,J)=MIN_XPM(J)
                PARAM(I,-J)=-MIN_XPM(J)
              END DO
              CALL WR_SF_PAR12(I)    
            END DO
          ELSE
            DO J=1,NAP
              PARAM(NTHPAR,J)=MIN_XPM(J)
              PARAM(NTHPAR,-J)=-MIN_XPM(J)
            END DO
   	    CALL WR_SF_PAR12(NTHPAR)    
          END IF
C        END IF
        RETURN

      ELSE IF(IFLAG.EQ.4)THEN
        IF (NTHPAR.EQ.0)THEN
          DO I=1,NP
            DO J=1,NAP
              PARAM(I,J)=sngl(XPM(J))
	      PARAM(I,-J)=sngl(-XPM(J))
            END DO
            CALL cal_sf_par12(I)
            CALL cal_atom_pos(I)
            CALL cal_k_vec(I)
            CALL cal_mu_rho(I)
            CALL cal_2_theta(I)
            CALL cal_peak_width(I)
            CALL cal_sf_int(I)
          END DO
          CALL cal_tot_prof()
        ELSE
          DO J=1,NAP
c           if (xpm(I).ne.old_xpm(I)) type *,'xpm=',i,xpm(i),old_xpm(i)
            PARAM(NTHPAR,J)=sngl(XPM(J))
	    PARAM(NTHPAR,-J)=sngl(-XPM(J))
          END DO
          CALL cal_sf_par12(NTHPAR)
          CALL cal_atom_pos(NTHPAR)
          CALL cal_k_vec(NTHPAR)
          CALL cal_mu_rho(NTHPAR)
          CALL cal_2_theta(NTHPAR)
          CALL cal_peak_width(NTHPAR)
          CALL cal_sf_int(NTHPAR)
          CALL cal_tot_prof()
        END IF
        SS=DBLE(S(0))          
        IF (SS_MIN-S(0).GE.0.0001)THEN
          SS_MIN=S(0)
          DO I=1,NAP
            MIN_XPM(I)=PARAM(NTHPAR,I)
            MIN_XPM(-I)=PARAM(NTHPAR,-I)
          END DO
        END IF
        RETURN

      ELSE IF(IFLAG.EQ.5)THEN
        TYPE *,'NOT USED IFLAG'
        CALL EXIT
        RETURN        
      END IF
      RETURN
      END
*----------------------------------------------------------------------

***********************************************************************
*  The program is going to accept a keyboard interruption
      SUBROUTINE KBOARD_INTERRUPT(EXIT_LOOP)
***********************************************************************

	include '($iodef)'
! For keyboard interrupt
	integer*4 sys$assign,sys$alloc,sys$dalloc,sys$qio
	integer*2 channel
 	integer*4 istat,code,msglen
	character*1 char, port*9,message*100
	logical*1 initialize/.false./
        logical*1 exit_loop

	STRUCTURE /IOSTAT_BLOCK/
        INTEGER*2 IOSTAT,TERM_OFFSET,TERMINATOR,TERM_SIZE
	END STRUCTURE

	RECORD /IOSTAT_BLOCK/ IOSB  

	data port/'sys$input'/


C	exit_loop=.false.  ! This needs to be passed
	if (.not.initialize) then
	code=io$_readvblk.or.io$m_timed
	ISTAT=sys$alloc(port,,,)  ! Allocate a I/O port
	  IF (.not.ISTAT) THEN
	    call sys$getmsg(%val(istat),msglen,message,%val(15),)
	    type *, message
	    END IF
	ISTAT=sys$assign(port,channel,,) ! Assign this port
	  IF (.not.ISTAT) THEN
	    call sys$getmsg(%val(istat),msglen,message,%val(15),)
	    type *, message
	    END IF
	  initialize=.true.
	  char='~'
	  end if
	ISTAT=sys$qio(,%val(channel),%val(code),iosb,   
	2 ,,%ref(char),%val(1),,,,) ! Check for keyboard input
	  IF (.not.ISTAT) THEN  ! If error get system message
          call sys$getmsg(%val(istat),msglen,message,%val(15),)
	  type *, message
	  end if

	  IF (char.ne.'~') THEN   ! Use ~ as a dummy test character
            Type *, 'Keyboard interrupt, use S to active interrupt'
            IF (char.EQ.'s' .or. char.EQ.'S')exit_loop=.true. 
C   use letter s or S as stop sign
	    char='~'
	  end if


      RETURN
      END
*----------------------------------------------------------------------
