   	integer*4 grid(-1:12,-1:12)  !grid map of 2d, nearest neighbor
   	integer*4 grid_map(2,144)    !grid map of 1d, nearest neighbor
   	integer*4 nn_grid(6,144)     !nearest neighbor 
   	integer*4 nnn_grid(6,144)    !next nearest neighbor 
   	integer*4 nnnn_grid(6,144)   !next next nearest neighbor
    	integer*4 grid_size          !length of side of grid
    	integer*4 grid_pts           !total grid points (no boundary)

   	real*8 grid_rot(144)         !angle of rotor at grid points
   	real*8 E(144)                !energy at each grid point
   	real*8 nn_E(144)             !energy at each grid point with nn
   	real*8 nnn_E(144)            !energy at each grid point with nnn
   	real*8 nnnn_E(144)           !energy at each grid point with nnnn
   	real*8 E_b(144),E_c(144)     !energy of dopant b&c 
	real*4 b_occup(144)          !occupancy of dopant b 
	real*4 c_occup(144)          !occupancy of dopant c

        logical*1 b_lock(144)/144*.false./,c_lock(144)/144*.false./

	real*4 grid_x(144),grid_y(144)
	real*4 grid_angle(6,144)
	real*4 grid_rad(6,144)
	real*4 grid_bx(144), grid_by(144)
	real*4 grid_cx(144), grid_cy(144)
	real*4 grid_r0(6,144)
	real*8 old_e(6,144),e_har(6,144)
	real*8 new_ord                   

        real*4 fold
        real*4 rad0,rad1

        real*4 phib1, phib2, phib3
        real*4 phic1, phic2, phic3

	real*4 anisot,angle
        real*4 phi, eta                       !eta=anisotropy
        real*4 phi1, phi2, phi3, phi4 
        real*4 phi5, phi6, phi7, phi8 

        real*4 th0
        real*4 th1, th2, th3, th4
        real*4 th5, th6, th7, th8

        real*4 r  !seperation between site 0 and sites 2
        real*4 alpha, alpha1, alpha2, alpha7 !alpha for different r
        real*4 beta,  beta1,  beta2,  beta7 !beta for different r
        real*4 gamma, delta,delta_2,Temperature,T
	real*8 rot_x(0:11,0:11), rot_y(0:11,0:11) !coordinate of triangle 
        real*8 kx(3), ky(3)  !recipecal lattice
C       real*8 r, x0, y0 !side of triangle, x0=y0 lattice constant
        real*8 varphi(3)  !phi angle between three direction

        real*8 PI

        data pi/3.141592653589793238/
	data grid_size,grid_pts/ 12,144/
        common pi
	common /main/grid,grid_map
	common /param/grid_rot,E,E_b,E_c,b_occup,c_occup,anisot,angle
	common /lock/ b_lock,c_lock
	common /xyvalues/grid_x,grid_y,grid_angle,grid_rad,grid_cx, 
     c    	grid_cy,grid_bx,grid_by,grid_r0
	common /energy/old_e,e_har
        common /n_neighbor/nn_grid,nnn_grid,nnnn_grid

        common /sf/ rot_x,rot_y,kx,ky,varphi
         
        common /th_set/th0,th1,th2,th3,th4,th5,th6,th7,th8
        common /phi_set/phi,phi1,phi2,phi3,phi4,phi5,phi6,phi7,
     c                  phi8,eta,
     c                  phib1,phib2,phib3,phic1,phic2,phic3

        common /par_set/alpha,alpha1,alpha2,alpha7,beta,beta1,
     c                   beta2,beta7,gamma,delta,delta_2,
     c                   Temperature,fold

        common /energy/e,nn_e,nnn_e,nnnn_e,e_b,e_c
        common /occupancy/b_occup,c_occup
        equivalent temperature,T
