***********************************************************************        
	SUBROUTINE SET_UP_ENERGY(de_total) 
***********************************************************************
	Implicit none
	Include 'model.inc'
C	integer*4 grid,grid_map,grid_size,grid_pts
C	real*8 grid_rot,E,E_b,E_c
C	real*4 b_occup,c_occup,anisot,angle
C	real*4 grid_x(100),grid_y(100),grid_angle(6,100),
C	2 grid_rad(6,100), grid_cx(100), grid_cy(100), grid_bx(100),
C	2 grid_by(100)
C	real*8 old_e(6,100)
C Array sizes and initialization values for above in 'model.inc'

	integer i,j,k,i_a1,i_a2,site,site_0,ii,
	2 site_1c,site_2c,site_3c,site_1b,site_2b,site_3b

	real*8 dab_energy,occup
	real*8 denergy_b,denergy_c,denergy0,denergy1
	real*8 dneighbor/0.0d0/
        real*8 Del_E,doccup,rad
	real*8 e_har1,e_har2,e_har3,e_har4,e_har5,e_har6,e_t(6)                
	real*8	de1a,de2a,de3a,de4a,de5a,de6a,
	2 	de1b,de2b,de3b,de4b,de5b,de6b,
	2	de1g,de2g,de3g,de4g,de5g,de6g
	real*8	de1d    ,de2d    ,de3d    ,de4d    ,de5d    ,de6d,
	2	de1d_new,de2d_new,de3d_new,de4d_new,de5d_new,de6d_new,
	2	de1d_old,de2d_old,de3d_old,de4d_old,de5d_old,de6d_old
	real*4  energy, e_total, theta, eb_total, ec_total, theta0
	real*4  size, ccos_ang,ssin_ang,rad0,rad_1,fold,radius
	real*4  energy_b, energy_c, e_temp
	real*4  x0,y0,x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,x,y
	real*4  cos_ang,sin_ang,m1,m2,b1,b2,xx,yy,e_test
	real*4  rad1,rad2,rad3,rad4,rad5,rad6
	integer*4 nn1,nn2,nn3,nn4,nn5,nn6
	logical*1 distort/.true./,b_logic,c_logic,init/.false./
	logical*1 check/.false./


	cos_ang=cosd(angle)
	sin_ang=sind(angle)
	dfold=dble(fold)
	fold=float(fold)



C-------------------------------------------------------------------
C Now for the x,y coordinates of a grid site
C-------------------------------------------------------------------
        do i=1,grid_pts
	i_a1=grid_map(1,i)
	i_a2=grid_map(2,i)	
	site_0 =grid(i_a1  ,i_a2)
	grid_x(site_0)=float(i_a1)+float(i_a2)*cos_ang*anisot
	grid_y(site_0)=float(i_a2)*sin_ang*anisot
	grid_r0(1,site_0)=rad0
	grid_r0(2,site_0)=rad0
	grid_r0(3,site_0)=rad0
	grid_r0(4,site_0)=rad0
	grid_r0(5,site_0)=rad0
	grid_r0(6,site_0)=rad0
	end do



C-------------------------------------------------------------------
C Now for the x,y coordinates of the B dopant sites
C-------------------------------------------------------------------

	size=float(grid_size)
	ccos_ang=cosd(angle)*size*anisot
	ssin_ang=sind(angle)*size*anisot

        do i=1,grid_pts
	i_a1=grid_map(1,i)
	i_a2=grid_map(2,i)
	site_0=grid(i_a1,i_a2)
 	nn1 =grid(i_a1+1,i_a2  )
 	nn2 =grid(i_a1  ,i_a2+1)
 	nn3 =grid(i_a1+1,i_a2+1)

	x0=grid_x(site_0)
	y0=grid_y(site_0)
	x1=grid_x(nn1)
	y1=grid_y(nn1)
	x2=grid_x(nn2)
	y2=grid_y(nn2)
	x3=grid_x(nn3)
	y3=grid_y(nn3)

	  if (i_a1+1.eq.grid_size) then
	  x1=x1+size
	  x3=x3+size
	  end if
	  if (i_a2+1.eq.grid_size) then
	  x2=x2+ccos_ang
	  y2=y2+ssin_ang
	  x3=x3+ccos_ang
	  y3=y3+ssin_ang
	  end if 
	call t_center(x0,y0,x3,y3,x2,y2,x,y)
	grid_bx(site_0)=x
	grid_by(site_0)=y
C C-positions
	call t_center(x0,y0,x3,y3,x1,y1,x,y)
	grid_cx(site_0)=x
	grid_cy(site_0)=y
	end do

C-------------------------------------------------------------------
C Now for the angles and distance between nearest neighbors
C-------------------------------------------------------------------

	do i=1,grid_pts
	  i_a1=grid_map(1,i)
	  i_a2=grid_map(2,i)	
	  site_0 =grid(i_a1  ,i_a2)
	  nn1=grid(i_a1+1,i_a2  )
	  nn2=grid(i_a1  ,i_a2+1)
	  nn3=grid(i_a1+1,i_a2+1)
	  nn4=grid(i_a1-1,i_a2  )
	  nn5=grid(i_a1  ,i_a2-1)
	  nn6=grid(i_a1-1,i_a2-1)
	  x0=grid_x(site_0)
	  y0=grid_y(site_0)
	  x1=grid_x(nn1)
	  y1=grid_y(nn1)
	  x2=grid_x(nn2)
	  y2=grid_y(nn2)
	  x3=grid_x(nn3)
	  y3=grid_y(nn3)
	  x4=grid_x(nn4)
	  y4=grid_y(nn4)
	  x5=grid_x(nn5)
	  y5=grid_y(nn5)
	  x6=grid_x(nn6)
	  y6=grid_y(nn6)
	    if (i_a1+1.eq.grid_size) then 
	      x1=x1+float(grid_size)
	      x3=x3+float(grid_size)
	      end if
	    if (i_a2+1.eq.grid_size) then
	      x2=x2+float(grid_size)*cos_ang*anisot
	      y2=y2+float(grid_size)*sin_ang*anisot
	      x3=x3+float(grid_size)*cos_ang*anisot
	      y3=y3+float(grid_size)*sin_ang*anisot
	      end if
	    if (i_a1 .eq. 0) then
	      x4=x4-float(grid_size)
	      x6=x6-float(grid_size)
	      end if
	    if (i_a2 .eq. 0) then
	      x5=x5-float(grid_size)*cos_ang*anisot
	      y5=y5-float(grid_size)*sin_ang*anisot
	      x6=x6-float(grid_size)*cos_ang*anisot
	      y6=y6-float(grid_size)*sin_ang*anisot
	      end if


C Now include two equilibrium distances

	  if (b_occup(site_0).ne.0.0) then
 	  grid_r0(2,site_0)=rad_1
 	  grid_r0(3,site_0)=rad_1
 	  grid_r0(1,   nn2)=rad_1
 	  grid_r0(5,   nn2)=rad_1
 	  grid_r0(4,   nn3)=rad_1
 	  grid_r0(6,   nn3)=rad_1
	  end if
	  if (c_occup(site_0).ne.0.0) then
 	  grid_r0(1,site_0)=rad_1
 	  grid_r0(3,site_0)=rad_1
 	  grid_r0(2,   nn1)=rad_1
 	  grid_r0(4,   nn1)=rad_1
 	  grid_r0(5,   nn3)=rad_1
 	  grid_r0(6,   nn3)=rad_1
	  end if

	  grid_angle(1,site_0)=atan2(y1-y0,x1-x0)
	  grid_angle(2,site_0)=atan2(y2-y0,x2-x0)
	  grid_angle(3,site_0)=atan2(y3-y0,x3-x0)
	  grid_angle(4,site_0)=atan2(y4-y0,x4-x0)
	  grid_angle(5,site_0)=atan2(y5-y0,x5-x0)
	  grid_angle(6,site_0)=atan2(y6-y0,x6-x0)

	  grid_rad(1,site_0)=((y1-y0)*(y1-y0)+(x1-x0)*(x1-x0))**0.5
	  grid_rad(2,site_0)=((y2-y0)*(y2-y0)+(x2-x0)*(x2-x0))**0.5
	  grid_rad(3,site_0)=((y3-y0)*(y3-y0)+(x3-x0)*(x3-x0))**0.5
	  grid_rad(4,site_0)=((y4-y0)*(y4-y0)+(x4-x0)*(x4-x0))**0.5
	  grid_rad(5,site_0)=((y5-y0)*(y5-y0)+(x5-x0)*(x5-x0))**0.5
	  grid_rad(6,site_0)=((y6-y0)*(y6-y0)+(x6-x0)*(x6-x0))**0.5

	end do

	de_total=0.d0

C
C Vij=a*cos(3*T_i-3*T_j)+b*cos(3T_i-3PHI_ij)*cos(3T_j-3PHI_ij)
C E  =g*cos(3*T_i-3*PHI_v)
C
        do i=1,grid_pts
	i_a1=grid_map(1,i)
	i_a2=grid_map(2,i)	
	site_0 =grid(i_a1  ,i_a2)
	nn1=grid(i_a1+1,i_a2  )
	nn2=grid(i_a1  ,i_a2+1)
	nn3=grid(i_a1+1,i_a2+1)
	nn4=grid(i_a1-1,i_a2  )
	nn5=grid(i_a1  ,i_a2-1)
	nn6=grid(i_a1-1,i_a2-1)
	dtheta0=grid_rot(site_0)
        denergy0=0.d0

C-------------------------------------------------------------------
C First V_ij term
C-------------------------------------------------------------------

	 th1 =grid_rot(grid(i_a1+1,i_a2  ))
	 th2 =grid_rot(grid(i_a1  ,i_a2+1))
	 th3 =grid_rot(grid(i_a1+1,i_a2+1))
	 th4 =grid_rot(grid(i_a1-1,i_a2  ))
	 th5 =grid_rot(grid(i_a1  ,i_a2-1))
	 th6 =grid_rot(grid(i_a1-1,i_a2-1))

	if (dalpha.ne. 0.d0) then
	de1a=dcos( dfold*(theta0-dth1) )
	de2a=dcos( dfold*(theta0-dth2) )
	de3a=dcos( dfold*(theta0-dth3) )
	de4a=dcos( dfold*(theta0-dth4) )
	de5a=dcos( dfold*(theta0-dth5) )
	de6a=dcos( dfold*(theta0-dth6) )
	denergy0=dalpha*(de1a+de2a+de3a+de4a+de5a+de6a)
	end if
C-------------------------------------------------------------------
C Second V_ij term
C-------------------------------------------------------------------
	if (distort.eq. .true.) then
	phi1=grid_angle(1,site_0)
	phi2=grid_angle(2,site_0)
	phi3=grid_angle(3,site_0)
	phi4=grid_angle(4,site_0)
	phi5=grid_angle(5,site_0)
	phi6=grid_angle(6,site_0)
	end if

	if (dbeta.ne. 0.0d0 ) then
	de1b=dcos(fold*(theta0-phi1))*dcos(fold*(th1-phi1))
	de2b=dcos(fold*(theta0-phi2))*dcos(fold*(th2-phi2))
	de3b=dcos(fold*(theta0-phi3))*dcos(fold*(th3-phi3))
	de4b=dcos(fold*(theta0-phi4))*dcos(fold*(th4-phi4))
	de5b=dcos(fold*(theta0-phi5))*dcos(fold*(th5-phi5))
	de6b=dcos(fold*(theta0-phi6))*dcos(fold*(th6-phi6))
	denergy0=denergy0+dbeta*(de1b+de2b+de3b+de4b+de5b+de6b)
	end if

C-------------------------------------------------------------------
C E_v term 
C-------------------------------------------------------------------
	site_1b=grid(i_a1  ,i_a2  )
  	site_2b=grid(i_a1-1,i_a2-1)
	site_3b=grid(i_a1  ,i_a2-1)
        
	site_1c=grid(i_a1  ,i_a2  ) 
	site_2c=grid(i_a1-1,i_a2  )
	site_3c=grid(i_a1-1,i_a2-1)

	if (distort.eq. .true.) then
	x0=grid_x(site_0)
	y0=grid_y(site_0)
	x1=grid_bx(site_1b)
	y1=grid_by(site_1b)
	x2=grid_bx(site_2b)
	y2=grid_by(site_2b)
	x3=grid_bx(site_3b)
	y3=grid_by(site_3b)
	x4=grid_cx(site_1c)
	y4=grid_cy(site_1c)
	x5=grid_cx(site_2c)
	y5=grid_cy(site_2c)
	x6=grid_cx(site_3c)
	y6=grid_cy(site_3c)
	  if (i_a1.eq.0) then
	    x2=x2-size
	    x5=x5-size
	    x6=x6-size
	    end if
	  if (i_a2.eq.0) then
	    x2=x2-ccos_ang
	    y2=y2-ssin_ang
	    x3=x3-ccos_ang
	    y3=y3-ssin_ang
	    x6=x6-ccos_ang
	    y6=y6-ssin_ang
	    end if
	phi_vb1=atan2(y1-y0,x1-x0)
	phi_vb2=atan2(y2-y0,x2-x0)
	phi_vb3=atan2(y3-y0,x3-x0)
	phi_vc1=atan2(y4-y0,x4-x0)
        phi_vc2=atan2(y5-y0,x5-x0)
	phi_vc3=atan2(y6-y0,x6-x0)
	end if

	if (dgamma .ne. 0.0d0 ) then
	de1g=dcos(fold*(theta0-phi_vb1))*dble(b_occup(site_1b))
	de2g=dcos(fold*(theta0-phi_vb2))*dble(b_occup(site_2b))
	de3g=dcos(fold*(theta0-phi_vb3))*dble(b_occup(site_3b))
	de4g=dcos(fold*(theta0-phi_vc1))*dble(c_occup(site_1c))
	de5g=dcos(fold*(theta0-phi_vc2))*dble(c_occup(site_2c))
	de6g=dcos(fold*(theta0-phi_vc3))*dble(c_occup(site_3c))
	denergy0=dnergy0+dgamma*(de1g+de2g+de3g+de4g+de5g+de6g)
	end if

C Note an additional nearest neighbor site repusion term is also
C included but this is done further on

	 rad1=grid_rad(1,site_0)-grid_r0(1,site_0)
	 rad2=grid_rad(2,site_0)-grid_r0(2,site_0)
	 rad3=grid_rad(3,site_0)-grid_r0(3,site_0)
	 rad4=grid_rad(4,site_0)-grid_r0(4,site_0)
	 rad5=grid_rad(5,site_0)-grid_r0(5,site_0)
	 rad6=grid_rad(6,site_0)-grid_r0(6,site_0)

	 if (grid_r0(1,site_0) .eq. rad0) then
	 e_t(1) =ddelta*dble(rad1)*dble(rad1)
	 else
	 e_t(1) =ddelta_2*dble(rad1)*dble(rad1)
	 end if

	 if (grid_r0(2,site_0) .eq. rad0) then
	 e_t(2) =ddelta*dble(rad2)*dble(rad2)
	 else
	 e_t(2) =ddelta_2*dble(rad2)*dble(rad2)
	 end if

	 if (grid_r0(3,site_0) .eq. rad0) then
	 e_t(3) =ddelta*dble(rad3)*dble(rad3)
	 else
	 e_t(3) =ddelta_2*dble(rad3)*dble(rad3)
	 end if

	 if (grid_r0(4,site_0) .eq. rad0) then
	 e_t(4) =ddelta*dble(rad4)*dble(rad4)
	 else
	 e_t(4) =ddelta_2*dble(rad4)*dble(rad4)
	 end if

	 if (grid_r0(5,site_0) .eq. rad0) then
	 e_t(5) =ddelta*dble(rad5)*dble(rad5)
	 else
	 e_t(5) =ddelta_2*dble(rad5)*dble(rad5)
	 end if

	 if (grid_r0(6,site_0) .eq. rad0) then
	 e_t(6) =ddelta*dble(rad6)*dble(rad6)
	 else
	 e_t(6) =ddelta_2*dble(rad6)*dble(rad6)
	 end if

	  do ii=1,6
	  if (check.eq..true. .and. init .eq. .true.) then
            if (dabs(e_har(ii,site_0)-e_t(ii)).gt.0.001d0) then
	    type *, ' site, ii',site_0,ii,e_har(ii,site_0),e_t(ii)
	    end if
	  end if
	  e_har(ii,site_0)=e_t(ii) 
          end do

	 denergy0=denergy0+e_har(1,site_0)+e_har(2,site_0)+
	2                  e_har(3,site_0)+e_har(4,site_0)+
	2                  e_har(5,site_0)+e_har(6,site_0)

 	e_t(1)=alpha*de1a+de1b*beta+e_har(1,site_0)
 	e_t(2)=alpha*de2a+de2b*beta+e_har(2,site_0)
 	e_t(3)=alpha*de3a+de3b*beta+e_har(3,site_0)
 	e_t(4)=alpha*de4a+de4b*beta+e_har(4,site_0)
 	e_t(5)=alpha*de5a+de5b*beta+e_har(5,site_0)
 	e_t(6)=alpha*de6a+de6b*beta+e_har(6,site_0)

	  do ii=1,6
	  if (check.eq..true. .and. init .eq. .true.) then
            if (dabs(old_e(ii,site_0)-e_t(ii)).gt.0.001d0) then
	    type *, ' site,ii,old_e',site_0,ii,old_e(ii,site_0),e_t(ii)
	    end if
	  end if
	  old_e(ii,site_0)=e_t(ii) 
          end do

	  if (check.eq..true. .and. init .eq. .true.) then
            if (dabs(e(site_0)-denergy0).gt.0.001d0) then
	    type *, ' site, e(site)',site_0,e(site_0),denergy0
	    end if
	  end if
	e(site_0)=denergy0
	de_total=de_total+denergy0
	end do
        
	deb_total=0.d0
	dec_total=0.d0
	do i=1,grid_pts
C------------------------------------------------------------------------
C Now to obtain dopant gallery energies
C------------------------------------------------------------------------	
C         phi_vb1    =     pi/2.   ! (0,0)
C         phi_vb2    = -5.*pi/6.   ! (-1,-1)
C         phi_vb3    =    -pi/6.   ! ( 0,-1)
C         phi_vc1    =     pi/6.   ! (0,0)
C         phi_vc2    =  5.*pi/6.   ! (-1, 0)
C         phi_vc3    = -1.*pi/2.   ! (-1,-1)

	  i_a1=grid_map(1,i)
	  i_a2=grid_map(2,i)	
	  site_0 =grid(i_a1  ,i_a2)
	  site_1b=grid(i_a1  ,i_a2  )
	  site_2b=grid(i_a1+1,i_a2+1)
	  site_3b=grid(i_a1  ,i_a2+1)

	if (distort.eq. .true.) then
	x0=grid_bx(site_0)
	y0=grid_by(site_0)
	x1=grid_x(site_1b)
	y1=grid_y(site_1b)
	x2=grid_x(site_2b)
	y2=grid_y(site_2b)
	x3=grid_x(site_3b)
	y3=grid_y(site_3b)
	  if (i_a1+1 .eq. grid_size) x2=x2+size
	    if (i_a2+1 .eq. grid_size) then
	    x2=x2+ccos_ang
	    y2=y2+ssin_ang
	    x3=x3+ccos_ang
	    y3=y3+ssin_ang
	    end if
	phi_vb1=atan2(y1-y0,x1-x0)
	phi_vb2=atan2(y2-y0,x2-x0)
	phi_vb3=atan2(y3-y0,x3-x0)
	end if

	e_temp=dgamma*( dcos(fold*(grid_rot(site_1b)-phi_vb1))+
	2 	 	dcos(fold*(grid_rot(site_2b)-phi_vb2))+	  
	2 		dcos(fold*(grid_rot(site_3b)-phi_vb3)))

	  if (dneighbor.ne. 0.0d0) then
          if (b_occup(site_1b).ne.0) 
	2	e_temp=e_temp+b_occup(site_1b)*dneighbor
          if (b_occup(site_2b).ne.0) 
	2	e_temp=e_temp+b_occup(site_2b)*dneighbor
          if (b_occup(site_3b).ne.0)
	2	e_temp=e_temp+b_occup(site_3b)*dneighbor
          end if

	  if (check.eq..true. .and. init .eq. .true.) then
            if (abs(e_b(site_0)-e_temp).gt.0.001) then
	    type *, ' site, e_b',site_0,e_b(site_0),e_temp
	    end if
	  end if 

	  site_1c=grid(i_a1  ,i_a2  ) 
	  site_2c=grid(i_a1+1,i_a2  )
	  site_3c=grid(i_a1+1,i_a2+1)

	if (distort.eq. .true.) then
	x0=grid_cx(site_0)
	y0=grid_cy(site_0)
	x1=grid_x(site_1c)
	y1=grid_y(site_1c)
	x2=grid_x(site_2c)
	y2=grid_y(site_2c)
	x3=grid_x(site_3c)
	y3=grid_y(site_3c)
	    if (i_a1+1.eq.grid_size) then
	    x2=x2+size
	    x3=x3+size
	    end if
	    if (i_a2+1.eq.grid_size) then
	    x3=x3+ccos_ang
	    y3=y3+ssin_ang
	    end if
	phi_vc1=atan2(y1-y0,x1-x0)
	phi_vc2=atan2(y2-y0,x2-x0)
	phi_vc3=atan2(y3-y0,x3-x0)
	end if

	e_temp=dgamma*(dcos(fold*(grid_rot(site_1c)-phi_vc1))+
	2 	    dcos(fold*(grid_rot(site_2c)-phi_vc2))+	  
	2 	    dcos(fold*(grid_rot(site_3c)-phi_vc3)))

	  if (dneighbor.ne. 0.0d0) then
          if (c_occup(site_1c).ne.0) 
	2	e_temp=e_temp+c_occup(site_1c)*dneighbor
          if (b_occup(site_2c).ne.0) 
	2	e_temp=e_temp+c_occup(site_2c)*dneighbor
          if (b_occup(site_3c).ne.0)
	2	e_temp=e_temp+c_occup(site_3c)*dneighbor
          end if

	  if (check.eq..true. .and. init .eq. .true.) then
            if (abs(e_c(site_0)-e_temp).gt.0.001) then
	    type *, ' site, e_c',site_0,e_c(site_0),e_temp
	    end if
	  end if 

        e_c(site_0)=e_temp
	deb_total=deb_total+e_b(site_0)*dble(b_occup(site_0))
	dec_total=dec_total+e_c(site_0)*dble(c_occup(site_0))
	end do
	
C	type *, de_total,deb_total,dec_total

	init=.true.
	RETURN


***************************single precision*****************************

      ENTRY CALC_SITE_ENERGY(site,denergy)
*
*     Vij=a*cos(2*T_i-2*T_j)+b*cos(2T_i-2PHI_ij)*cos(2T_j-2PHI_ij)
*     E  =g*cos(2*T_i-2*PHI_v)
*
************************************************************************ 
* First V_ij term
************************************************************************ 

        th0 = grid_rot(site)
	th1 = grid_rot( nn_grid(1, site))
	th2 = grid_rot( nn_grid(2, site))
	th3 = grid_rot( nn_grid(3, site))
	th4 = grid_rot( nn_grid(4, site))
	th5 = grid_rot( nn_grid(5, site))
	th6 = grid_rot( nn_grid(6, site))
	th7 = grid_rot(nnn_grid(2, site))
	th8 = grid_rot(nnn_grid(5, site))


 	if (dalpha.ne. 0.0d0 ) then
          de1a  =dble(cos(fold*(th0-th1)))
          de2a  =dble(cos(fold*(th0-th2)))
	  de3a  =dble(cos(fold*(th0-th3)))
    	  de4a  =dble(cos(fold*(th0-th4)))
	  de5a  =dble(cos(fold*(th0-th5)))
	  de6a  =dble(cos(fold*(th0-th6)))
	  de7a  =dble(cos(fold*(th0-th7)))
	  de8a  =dble(cos(fold*(th0-th8)))

	  denergy = alpha1*(de1a+de4a)
     2            + alpha2*(de2a+de3a+de5a+de6a)
     2            + alpha7*(de7a+de8a) +denergy
 	end if

************************************************************************
* Second V_ij term
************************************************************************
	if (distort.eq. .true.) then
	  phi1=grid_angle(1,site_0)
  	  phi2=grid_angle(2,site_0)
	  phi3=grid_angle(3,site_0)
	  phi4=grid_angle(4,site_0)
	  phi5=grid_angle(5,site_0)
	  phi6=grid_angle(6,site_0)
	end if
	if (dbeta.ne. 0.0d0 ) then
    	  de1b=dble(cos(fold*(th0-phi1))*cos(fold*(th1-phi1)))
	  de2b=dble(cos(fold*(th0-phi2))*cos(fold*(th2-phi2)))
	  de3b=dble(cos(fold*(th0-phi3))*cos(fold*(th3-phi3)))
	  de4b=dble(cos(fold*(th0-phi4))*cos(fold*(th4-phi4)))
	  de5b=dble(cos(fold*(th0-phi5))*cos(fold*(th5-phi5)))
	  de6b=dble(cos(fold*(th0-phi6))*cos(fold*(th6-phi6)))
	  de7b=dble(cos(fold*(th0-phi7))*cos(fold*(th6-phi7)))
	  de8b=dble(cos(fold*(th0-phi8))*cos(fold*(th6-phi8)))
	  denergy=denergy+beta1*(de1b+de4)
      2                  +beta2*(de2b+de3b+de5b+de6b)
      2                  +beta7*(de7b+de8b)
	end if

C-------------------------------------------------------------------
C E_v term 
C-------------------------------------------------------------------
c
	if (dgamma.ne. 0.d0) then
	  de1g=0.0d0
	  de2g=0.0d0
	  de3g=0.0d0
	  de4g=0.0d0
	  de5g=0.0d0
	  de6g=0.0d0
 	  site_1b=grid(i_a1  ,i_a2  )
	  site_2b=grid(i_a1-1,i_a2-1)
	  site_3b=grid(i_a1  ,i_a2-1)
	  site_1c=grid(i_a1  ,i_a2  ) 
	  site_2c=grid(i_a1-1,i_a2  )
	  site_3c=grid(i_a1-1,i_a2-1)
	  x0=grid_x(site_0)
	  y0=grid_y(site_0)
	    if (b_occup(site_1b).ne. 0.0) then
	    x1=grid_bx(site_1b)
	    y1=grid_by(site_1b)
	    phi_vb1=atan2(y1-y0,x1-x0)
	    de1g=dble(cos(fold*(theta-phi_vb1) )*b_occup(site_1b))
	    end if

	    if (b_occup(site_2b).ne. 0.0) then
	    x2=grid_bx(site_2b)
	    y2=grid_by(site_2b)
	      if (i_a1.eq.0) then
	      x2=x2-size
	      end if
	      if (i_a2.eq.0) then
	      x2=x2-ccos_ang
	      y2=y2-ssin_ang
	      end if
	    phi_vb2=atan2(y2-y0,x2-x0)
	    de2g=dble(cos(fold*(theta-phi_vb2) )*b_occup(site_2b))
            end if

	    if (b_occup(site_3b) .ne. 0.0) then
	    x3=grid_bx(site_3b)
	    y3=grid_by(site_3b)
	      if (i_a2.eq.0) then
	      x3=x3-ccos_ang
	      y3=y3-ssin_ang
	      end if
	    phi_vb3=atan2(y3-y0,x3-x0)
	    de3g=dble(cos(fold*(theta-phi_vb3) )*b_occup(site_3b))
	    end if

	    if (c_occup(site_1c) .ne. 0.0) then
	    x4=grid_cx(site_1c)
 	    y4=grid_cy(site_1c)
	    phi_vc1=atan2(y4-y0,x4-x0)
	    de4g=dble(cos(fold*(theta-phi_vc1) )*c_occup(site_1c))
	    end if
	   
	    if (c_occup(site_2c) .ne. 0.0) then
	    x5=grid_cx(site_2c)
	    y5=grid_cy(site_2c)
	      if (i_a1.eq.0) then
	      x5=x5-size
	      end if
	    phi_vc2=atan2(y5-y0,x5-x0)
	    de5g=dble(cos(fold*(theta-phi_vc2) )*c_occup(site_2c))
	    end if

	    if (c_occup(site_3c) .ne. 0.0) then
	    x6=grid_cx(site_3c)
	    y6=grid_cy(site_3c)
	      if (i_a1.eq.0) then
	        x6=x6-size
	        end if
	      if (i_a2.eq.0) then
	        x6=x6-ccos_ang
	        y6=y6-ssin_ang
	        end if
	    phi_vc3=atan2(y6-y0,x6-x0)
            de6g=dble(cos(fold*(theta-phi_vc3) )*c_occup(site_3c))
	    end if

	  denergy=denergy+dgamma*(de1g+de2g+de3g+de4g+de5g+de6g)

	  end if


C Lattice distortion does not change so it is not calculated

	RETURN

C**************************double precision*****************************

	ENTRY DCALC_SITE_ENERGY(dalpha,dbeta,dgamma,dtheta,site,denergy)
C
C Vij=a*cos(3*T_i-3*T_j)+b*cos(3T_i-3PHI_ij)*cos(3T_j-3PHI_ij)
C E  =g*cos(3*T_i-3*PHI_v)
C
         
	i_a1=grid_map(1,site)
	i_a2=grid_map(2,site)	
	site_0 =grid(i_a1  ,i_a2)
	denergy=e_har(1,site_0)+e_har(2,site_0)+e_har(3,site_0)+
	2	e_har(4,site_0)+e_har(5,site_0)+e_har(6,site_0)
C	dtheta=grid_rot(site_0)

C------------------------------------------------------------------------
C First V_ij term
C------------------------------------------------------------------------
	dth1 =grid_rot(grid(i_a1+1,i_a2  ))
	dth2 =grid_rot(grid(i_a1  ,i_a2+1))
	dth3 =grid_rot(grid(i_a1+1,i_a2+1))
	dth4 =grid_rot(grid(i_a1-1,i_a2  ))
	dth5 =grid_rot(grid(i_a1  ,i_a2-1))
	dth6 =grid_rot(grid(i_a1-1,i_a2-1))

	if (dalpha.ne. 0.d0) then
	de1a=dcos( dfold*(dtheta-dth1) )
	de2a=dcos( dfold*(dtheta-dth2) )
	de3a=dcos( dfold*(dtheta-dth3) )
	de4a=dcos( dfold*(dtheta-dth4) )
	de5a=dcos( dfold*(dtheta-dth5) )
	de6a=dcos( dfold*(dtheta-dth6) )
	denergy=dalpha*(de1a+de2a+de3a+de4a+de5a+de6a)+denergy
	end if
C-------------------------------------------------------------------
C Second V_ij term
C-------------------------------------------------------------------
	if (distort.eq. .true.) then
	dphi1=grid_angle(1,site_0)
	dphi2=grid_angle(2,site_0)
	dphi3=grid_angle(3,site_0)
	dphi4=grid_angle(4,site_0)
	dphi5=grid_angle(5,site_0)
	dphi6=grid_angle(6,site_0)
	end if

	if (dbeta.ne. 0.d0) then
	de1b=dcos(dfold*(dtheta-dphi1))*dcos( dfold*(dth1-dphi1))
	de2b=dcos(dfold*(dtheta-dphi2))*dcos( dfold*(dth2-dphi2))
	de3b=dcos(dfold*(dtheta-dphi3))*dcos( dfold*(dth3-dphi3))
	de4b=dcos(dfold*(dtheta-dphi4))*dcos( dfold*(dth4-dphi4))
	de5b=dcos(dfold*(dtheta-dphi5))*dcos( dfold*(dth5-dphi5))
	de6b=dcos(dfold*(dtheta-dphi6))*dcos( dfold*(dth6-dphi6))
	denergy=denergy+dbeta*(de1b+de2b+de3b+de4b+de5b+de6b)
	end if

C-------------------------------------------------------------------
C E_v term 
C-------------------------------------------------------------------
	if (dgamma.ne. 0.0d0) then
	site_1b=grid(i_a1  ,i_a2  )
	site_2b=grid(i_a1-1,i_a2-1)
	site_3b=grid(i_a1  ,i_a2-1)
	x1=grid_bx(site_1c)
	y1=grid_by(site_1c)
	x2=grid_bx(site_2c)
	y2=grid_by(site_2c)
	x3=grid_bx(site_3c)
	y3=grid_by(site_3c)
	dphi_vb1=dble(atan2(y1-y0,x1-x0))
	dphi_vb2=dble(atan2(y2-y0,x2-x0))
	dphi_vb3=dble(atan2(y3-y0,x3-x0))
	de1g=dcos( dfold*(dtheta-dphi_vb1) )*dble(b_occup(site_1b))
	de2g=dcos( dfold*(dtheta-dphi_vb2) )*dble(b_occup(site_2b))
	de3g=dcos( dfold*(dtheta-dphi_vb3) )*dble(b_occup(site_3b))

	site_1c=grid(i_a1  ,i_a2  ) 
	site_2c=grid(i_a1-1,i_a2  )
	site_3c=grid(i_a1-1,i_a2-1)
	x1=grid_cx(site_1c)
	y1=grid_cy(site_1c)
	x2=grid_cx(site_2c)
	y2=grid_cy(site_2c)
	x3=grid_cx(site_3c)
	y3=grid_cy(site_3c)
	dphi_vc1=dble(atan2(y1-y0,x1-x0))
	dphi_vc2=dble(atan2(y2-y0,x2-x0))
	dphi_vc3=dble(atan2(y3-y0,x3-x0))

	de4g=dcos( dfold*(dtheta-dphi_vc1) )*dble(c_occup(site_1c))
	de5g=dcos( dfold*(dtheta-dphi_vc2) )*dble(c_occup(site_2c))
        de6g=dcos( dfold*(dtheta-dphi_vc3) )*dble(c_occup(site_3c))
	denergy=denergy+dgamma*(de1g+de2g+de3g+de4g+de5g+de6g)
	end if

	RETURN
	
	ENTRY UPDATE_NEIGHBOR_SITES(dalpha,dbeta,dgamma,site,dab_energy)

	dab_energy=old_e(1,site)+old_e(2,site)+old_e(3,site)+
	2	   old_e(4,site)+old_e(5,site)+old_e(6,site)

	old_e(1,site)=dalpha*de1a+dbeta*de1b+e_har(1,site)
	old_e(2,site)=dalpha*de2a+dbeta*de2b+e_har(2,site)
	old_e(3,site)=dalpha*de3a+dbeta*de3b+e_har(3,site)
	old_e(4,site)=dalpha*de4a+dbeta*de4b+e_har(4,site)
	old_e(5,site)=dalpha*de5a+dbeta*de5b+e_har(5,site)
	old_e(6,site)=dalpha*de6a+dbeta*de6b+e_har(6,site)

	dab_energy=old_e(1,site)+old_e(2,site)+old_e(3,site)+
	2	 old_e(4,site)+old_e(5,site)+old_e(6,site)-dab_energy
	i_a1=grid_map(1,site)
	i_a2=grid_map(2,site)
	nn1=grid(i_a1+1,i_a2)
	nn2=grid(i_a1  ,i_a2+1)
	nn3=grid(i_a1+1,i_a2+1)
	nn4=grid(i_a1-1,i_a2  )
	nn5=grid(i_a1  ,i_a2-1)
	nn6=grid(i_a1-1,i_a2-1)
	e(nn1)=e(nn1)-old_e(4,nn1)+old_e(1,site)
	old_e(4,nn1)=old_e(1,site)
	e(nn2)=e(nn2)-old_e(5,nn2)+old_e(2,site)
	old_e(5,nn2)=old_e(2,site)
	e(nn3)=e(nn3)-old_e(6,nn3)+old_e(3,site)
	old_e(6,nn3)=old_e(3,site)
	e(nn4)=e(nn4)-old_e(1,nn4)+old_e(4,site)
	old_e(1,nn4)=old_e(4,site)
	e(nn5)=e(nn5)-old_e(2,nn5)+old_e(5,site)
	old_e(2,nn5)=old_e(5,site)
	e(nn6)=e(nn6)-old_e(3,nn6)+old_e(6,site)
	old_e(3,nn6)=old_e(6,site)

	return
 
	ENTRY CALC_SITE_ENERGY_B(dgamma,site,energy_b,ddelta,ddelta_2,rad_1)
C------------------------------------------------------------------------
C Now to obtain dopant gallery energies
C------------------------------------------------------------------------	
C         phi_vb1    =     pi/2.   ! (0,0)
C         phi_vb2    = -5.*pi/6.   ! (-1,-1)
C         phi_vb3    =    -pi/6.   ! ( 0,-1)
C         phi_vc1    =     pi/6.   ! (0,0)
C         phi_vc2    =  5.*pi/6.   ! (-1, 0)
C         phi_vc3    = -1.*pi/2.   ! (-1,-1)

	  i_a1=grid_map(1,site)
	  i_a2=grid_map(2,site)	
	  site_0=grid(i_a1,i_a2)
	  site_1b=grid(i_a1  ,i_a2  )
	  site_2b=grid(i_a1+1,i_a2+1)
	  site_3b=grid(i_a1  ,i_a2+1)

	  x0=grid_bx(site_0)
	  y0=grid_by(site_0)
	  x1=grid_x(site_1b)
	  y1=grid_y(site_1b)
	  x2=grid_x(site_2b)
	  y2=grid_y(site_2b)
	  x3=grid_x(site_3b)
	  y3=grid_y(site_3b)
	      if (i_a1+1 .eq. grid_size) then
	      x2=x2+size
	      end if
	      if (i_a2+1 .eq. grid_size) then
	      x2=x2+ccos_ang
	      y2=y2+ssin_ang
	      x3=x3+ccos_ang
	      y3=y3+ssin_ang
	      end if

	 phi_vb1=atan2(y0-y1,x0-x1)
	 phi_vb2=atan2(y0-y2,x0-x2)
	 phi_vb3=atan2(y0-y3,x0-x3)

	  de1g=dgamma*dcos(dfold*(grid_rot(site_1b)-phi_vb1))
	  de2g=dgamma*dcos(dfold*(grid_rot(site_2b)-phi_vb2))	  
	  de3g=dgamma*dcos(dfold*(grid_rot(site_3b)-phi_vb3))

	  energy_b=de1g+de2g+de3g

C Now for lattice relaxation energy changes

	  if (ddelta.ne. 0.d0) then

	  dddelta=ddelta
	  radius =grid_r0(2,site_1b)
	  if (radius .eq. rad_1) dddelta=ddelta_2
	   rad=grid_rad(2,site_1b)-radius
   	   de1d_old=dddelta*rad *rad
	   rad=dble(grid_rad(2,site_1b)-rad_1)
   	   de1d_new=ddelta_2*rad *rad
	   de1d=de1d_new-de1d_old

	  dddelta=ddelta
	  radius =grid_r0(3,site_1b)
	  if (radius .eq. rad_1) dddelta=ddelta_2
	   rad=grid_rad(3,site_1b)-radius
   	   de2d_old=dddelta*rad *rad
	   rad=dble(grid_rad(3,site_1b)-rad_1)
   	   de2d_new=ddelta_2*rad *rad
	   de2d=de2d_new-de2d_old

	  dddelta=ddelta
	  radius =grid_r0(1,site_3b)
	  if (radius .eq. rad_1) dddelta=ddelta_2
	   rad=grid_rad(1,site_3b)-radius
   	   de3d_old=dddelta*rad *rad
	   rad=dble(grid_rad(1,site_3b)-rad_1)
   	   de3d_new=ddelta_2*rad *rad
	   de3d=de3d_new-de3d_old

	   energy_b=energy_b+2.d0*(de1d+de2d+de3d)
	  end if    

	return

	ENTRY CALC_SITE_ENERGY_C(dgamma,site,energy_c,ddelta,ddelta_2,rad_1)

	  i_a1=grid_map(1,site)
	  i_a2=grid_map(2,site)	
	  site_0=grid(i_a1,i_a2)
	  site_1c=grid(i_a1  ,i_a2  ) 
	  site_2c=grid(i_a1+1,i_a2  )
	  site_3c=grid(i_a1+1,i_a2+1)

	  x0=grid_cx(site_0)
	  y0=grid_cy(site_0)
	  x1=grid_x(site_1c)
	  y1=grid_y(site_1c)
	  x2=grid_x(site_2c)
	  y2=grid_y(site_2c)
	  x3=grid_x(site_3c)
	  y3=grid_y(site_3c)

	      if (i_a1+1 .eq. grid_size) then
	      x2=x2+size
	      x3=x3+size
	      end if
	      if (i_a2+1 .eq. grid_size) then
	      x3=x3+ccos_ang
	      y3=y3+ssin_ang
	      end if

	 phi_vc1=atan2(y0-y1,x0-x1)
	 phi_vc2=atan2(y0-y2,x0-x2)
	 phi_vc3=atan2(y0-y3,x0-x3)

	  de4g=dgamma*dcos(dfold*(grid_rot(site_1c)-phi_vc1))
	  de5g=dgamma*dcos(dfold*(grid_rot(site_2c)-phi_vc2))
	  de6g=dgamma*dcos(dfold*(grid_rot(site_3c)-phi_vc3))

	  energy_c=de4g+de5g+de6g

C Now for lattice relaxation energy changes

	  if (ddelta.ne. 0.d0 ) then

	  dddelta=ddelta
	  radius =grid_r0(1,site_1c)
	  if (radius .eq. rad_1) dddelta=ddelta_2
	   rad=grid_rad(1,site_1c)-radius
   	   de4d_old=dddelta*rad *rad
	   rad=dble(grid_rad(1,site_1c)-rad_1)
   	   de4d_new=ddelta_2*rad *rad
	   de4d=de4d_new-de4d_old

	  dddelta=ddelta
	  radius =grid_r0(3,site_1c)
	  if (radius .eq. rad_1) dddelta=ddelta_2
	   rad=grid_rad(3,site_1c)-radius
   	   de5d_old=dddelta*rad *rad
	   rad=dble(grid_rad(3,site_1c)-rad_1)
   	   de5d_new=ddelta_2*rad *rad
	   de5d=de5d_new-de5d_old

	  dddelta=ddelta
	  radius =grid_r0(2,site_2c)
	  if (radius .eq. rad_1) dddelta=ddelta_2
	   rad=grid_rad(2,site_2c)-radius
   	   de6d_old=dddelta*rad *rad
	   rad=dble(grid_rad(2,site_2c)-rad_1)
   	   de6d_new=ddelta_2*rad *rad
	   de6d=de6d_new-de6d_old

	   energy_c=energy_c+2.d0*(de4d+de5d+de6d)
	  end if    

	return

C
C Dopant has shifted from a C site to a B site
C ********It is assumed that energy_c is the old energy**********
C

	ENTRY UPDATE_Dopant_CB(Del_E,doccup,rad0,rad_1,ddelta,ddelta_2)
	Del_E=0.d0
C Old c-site is deoccupied
C This energy must be subtracted
	e(site_1c)=e(site_1c)-de4g*doccup
	e(site_2c)=e(site_2c)-de5g*doccup
	e(site_3c)=e(site_3c)-de6g*doccup

C The new B site is occupied
C This energy must be added

	e(site_1b)=e(site_1b)+de1g*doccup
	e(site_2b)=e(site_2b)+de2g*doccup
	e(site_3b)=e(site_3b)+de3g*doccup
  	Del_e=(de1g+de2g+de3g-de4g-de5g-de6g )*doccup
C  
C Now for actual lattice relaxation energy changes
C
	if (rad_1.ne.rad0 .and. ddelta.ne. 0.0) then
C
C B neighbors are all "expanded"
C

c	de1d=de1d_new-de1d_old
c	de2d=de2d_new-de2d_old
c	de3d=de3d_new-de3d_old
	grid_r0(2,site_1b)=rad_1
	grid_r0(5,site_3b)=rad_1
	grid_r0(3,site_1b)=rad_1
	grid_r0(6,site_2b)=rad_1
	grid_r0(1,site_3b)=rad_1
	grid_r0(4,site_2b)=rad_1
	e_har(2,site_1b)=de1d_new
	e_har(5,site_3b)=de1d_new
	e_har(3,site_1b)=de2d_new
	e_har(6,site_2b)=de2d_new
	e_har(1,site_3b)=de3d_new
	e_har(4,site_2b)=de3d_new
	e(site_1b)=e(site_1b)+de1d+de2d
	e(site_2b)=e(site_2b)+de2d+de3d
	e(site_3b)=e(site_3b)+de1d+de3d

	old_e(2,site_1b)=old_e(2,site_1b)+de1d
	old_e(5,site_3b)=old_e(5,site_3b)+de1d
	old_e(3,site_1b)=old_e(3,site_1b)+de2d
	old_e(6,site_2b)=old_e(6,site_2b)+de2d
	old_e(1,site_3b)=old_e(1,site_3b)+de3d
	old_e(4,site_2b)=old_e(4,site_2b)+de3d
C
	Del_e=Del_e+2.d0*(de1d+de2d+de3d)
C
C Unfortunately, not all c site lattice ties will shrink
C
	i_a1=grid_map(1,site_1c)
	i_a2=grid_map(2,site_1c)	
	nn1 =grid(i_a1+1,i_a2  )	  
	nn2 =grid(i_a1  ,i_a2-1)	  

	  if (b_occup(nn2) .eq. 0.)  then
	  grid_r0(1,site_1c)=rad0
	  grid_r0(4,site_2c)=rad0
	  rad=dble(grid_rad(1,site_1c)-rad0)
   	  de4d_new=ddelta*rad *rad
	  de4d=de4d_new-de4d_old
	  end if

	  if ( b_occup(site_1c) .eq. 0.)  then
	  grid_r0(3,site_1c)=rad0
	  grid_r0(6,site_3c)=rad0
	  rad=dble(grid_rad(3,site_1c)-rad0)
   	  de5d_new=ddelta*rad *rad
	  de5d=de5d_new-de5d_old
          end if

	  if (b_occup(nn1) .eq. 0.)  then
	  grid_r0(2,site_2c)=rad0
	  grid_r0(5,site_3c)=rad0
	  rad=dble(grid_rad(2,site_2c)-rad0)
   	  de6d_new=ddelta*rad *rad
	  de6d=de6d_new-de6d_old
	  end if

	e(site_1c)=e(site_1c)+de4d+de5d
	e(site_2c)=e(site_2c)+de4d+de6d
	e(site_3c)=e(site_3c)+de5d+de6d
C 
	e_har(1,site_1c)=de4d_new
	e_har(4,site_2c)=de4d_new
	e_har(3,site_1c)=de5d_new
	e_har(6,site_3c)=de5d_new
	e_har(2,site_2c)=de6d_new
	e_har(5,site_3c)=de6d_new

	old_e(1,site_1c)=old_e(1,site_1c)+de4d
	old_e(4,site_2c)=old_e(4,site_2c)+de4d
	old_e(3,site_1c)=old_e(3,site_1c)+de5d
	old_e(6,site_3c)=old_e(6,site_3c)+de5d
	old_e(2,site_2c)=old_e(2,site_2c)+de6d
	old_e(5,site_3c)=old_e(5,site_3c)+de6d
C
	Del_e=Del_e+2.d0*(de4d+de5d+de6d)
	end if

	return

C Dopant has shifted from a B site to a C site

	ENTRY UPDATE_Dopant_BC(Del_E,doccup,rad0,rad_1,ddelta,ddelta_2)
	Del_E=0.d0

C The old B site was occupied
C This energy must be subtracted

	e(site_1b)=e(site_1b)-de1g*doccup
	e(site_2b)=e(site_2b)-de2g*doccup
	e(site_3b)=e(site_3b)-de3g*doccup

C The old C site is now occupied 
C This energy must be added

	e(site_1c)=e(site_1c)+de4g*doccup
	e(site_2c)=e(site_2c)+de5g*doccup
	e(site_3c)=e(site_3c)+de6g*doccup

	Del_e=(de4g+de5g+de6g-de1g-de2g-de3g)*doccup
C  
C Now for actual lattice relaxation energy changes
C
	if (rad_1.ne.rad0 .and. ddelta.ne. 0) then
C
C C neighbors are all "expanded"
C
c	de4d=de4d_new-de4d_old
c	de5d=de5d_new-de5d_old
c	de6d=de6d_new-de6d_old
	grid_r0(1,site_1c)=rad_1
	grid_r0(3,site_1c)=rad_1
	grid_r0(5,site_3c)=rad_1
	grid_r0(6,site_3c)=rad_1
	grid_r0(2,site_2c)=rad_1
	grid_r0(4,site_2c)=rad_1
	e(site_1c)=e(site_1c)+de4d+de5d
	e(site_2c)=e(site_2c)+de4d+de6d
  	e(site_3c)=e(site_3c)+de5d+de6d
C 
	e_har(3,site_1c)=de5d_new
	e_har(6,site_3c)=de5d_new
	e_har(1,site_1c)=de4d_new
	e_har(4,site_2c)=de4d_new
	e_har(5,site_3c)=de6d_new
	e_har(2,site_2c)=de6d_new

	old_e(3,site_1c)=old_e(3,site_1c)+de5d
	old_e(6,site_3c)=old_e(6,site_3c)+de5d
	old_e(1,site_1c)=old_e(1,site_1c)+de4d
	old_e(4,site_2c)=old_e(4,site_2c)+de4d
	old_e(5,site_3c)=old_e(5,site_3c)+de6d
	old_e(2,site_2c)=old_e(2,site_2c)+de6d
C
	Del_e=Del_e+2.d0*(de4d+de5d+de6d)
C
C Unfortunately, not all B site lattice ties will shrink
C
	i_a1=grid_map(1,site_1b)
	i_a2=grid_map(2,site_1b)	
	nn1 =grid(i_a1  ,i_a2+1)	  
	nn2 =grid(i_a1-1,i_a2  )
	  
	  if (c_occup(nn2) .eq. 0.)  then
	  grid_r0(5,site_3b)=rad0
	  grid_r0(2,site_1b)=rad0
	  rad=dble(grid_rad(5,site_3b)-rad0)
   	  de1d_new=ddelta*rad *rad
	  de1d=de1d_new-de1d_old
	  end if

	  if ( c_occup(site_1b) .eq. 0.)  then
	  grid_r0(3,site_1b)=rad0
	  grid_r0(6,site_2b)=rad0
	  rad=dble(grid_rad(3,site_1b)-rad0)
   	  de2d_new=ddelta*rad *rad
	  de2d=de2d_new-de2d_old
	  end if

	  if (c_occup(nn1) .eq. 0.)  then
	  grid_r0(1,site_3b)=rad0
	  grid_r0(4,site_2b)=rad0
	  rad=dble(grid_rad(1,site_3b)-rad0)
   	  de3d_new=ddelta*rad *rad
	  de3d=de3d_new-de3d_old
	  end if
	e(site_1b)=e(site_1b)+de1d+de2d
	e(site_2b)=e(site_2b)+de2d+de3d
	e(site_3b)=e(site_3b)+de3d+de1d
C 
	old_e(2,site_1b)=old_e(2,site_1b)+de1d
	old_e(5,site_3b)=old_e(5,site_3b)+de1d
	old_e(3,site_1b)=old_e(3,site_1b)+de2d
	old_e(6,site_2b)=old_e(6,site_2b)+de2d
	old_e(4,site_2b)=old_e(4,site_2b)+de3d
	old_e(1,site_3b)=old_e(1,site_3b)+de3d

	e_har(2,site_1b)=de1d_new
	e_har(5,site_3b)=de1d_new
	e_har(3,site_1b)=de2d_new
	e_har(6,site_2b)=de2d_new
	e_har(4,site_2b)=de3d_new
	e_har(1,site_3b)=de3d_new
C
	Del_e=Del_e+2.d0*(de1d+de2d+de3d)
	end if
	return
	end

C
C This subroutine is useful only if angle=120 degrees
C

