      SUBROUTINE SET_UP_INIT
      Call set_up_phi
      Call set_up_alpha_beta
      Call set_up_nn_grid
      Call set_up_nnn_grid
      Call set_up_nnnn_grid
      Return
      END

      SUBROUTINE set_up_phi
      IMPLICIT NONE
      INCLUDE 'MODEL.INC'
    
      phi1 =  0.0
      phi2 =  phi
      phi3 =  pi-phi
      phi4 =  pi
      phi5 = -pi+phi
      phi6 = -phi

      phib1 =  pi/2.      ! (0,0)
      phib2 = -5.*pi/6.   ! (-1,-1)
      phib3 = -pi/6.      ! ( 0,-1)
      phic1 =  pi/6.      ! (0,0)
      phic2 =  5.*pi/6.   ! (-1, 0)
      phic3 = -1.*pi/2.   ! (-1,-1)
      Return
      END                          



      SUBROUTINE set_up_alpha_beta
      IMPLICIT NONE
      INCLUDE 'MODEL.INC'
      
      REAL*4 r1,r2,r7

      r1 = 2.0*eta*cos(phi)
      r2 = 1.0               
      r7 = 2.0*sin(phi)

      alpha1 = alpha/r1**6
      alpha2 = alpha
      alpha7 = alpha/r7**6
      
      beta1 = beta/r1**6
      beta2 = beta         
      beta7 = beta/r7**6

      Return
      END


      SUBROUTINE SETUP_NN_GRID           
      IMPLICIT NONE
      Include 'model.inc'
      Integer site,i_s(6),i_t(6)
      Integer i,j,k

      Do i=0,grid_size-1
	Do j=0,grid_size-1
	  site=grid(i,j)	

	  i_s(1)=i+1
	  i_t(1)=j+0

	  i_s(2)=i+1
	  i_t(2)=j+1

	  i_s(3)=i+0
	  i_t(3)=j+1

	  i_s(4)=i-1
	  i_t(4)=j-0

	  i_s(5)=i-1
	  i_t(5)=j-1

	  i_s(6)=i-0
	  i_t(6)=j-1 

	    do k=1,6
	    if (i_s(k).lt.0          ) i_s(k)=i_s(k)+grid_size
	    if (i_s(k).gt.grid_size-1) i_s(k)=i_s(k)-grid_size
	    if (i_t(k).lt.0          ) i_t(k)=i_t(k)+grid_size
	    if (i_t(k).gt.grid_size-1) i_t(k)=i_t(k)-grid_size
	    nn_grid(k,site)=grid(i_s(k),i_t(k))
	    end do
	  end do
	end do
        RETURN
        END


      SUBROUTINE SET_UP_NNN_GRID           
      IMPLICIT NONE
      Include 'model.inc'
      Integer site,i_s(6),i_t(6)
      Integer i,j,k

      Do i=0,grid_size-1
	Do j=0,grid_size-1
	  site=grid(i,j)	

	  i_s(1)=i+2
	  i_t(1)=j+1

	  i_s(2)=i+1
	  i_t(2)=j+2

	  i_s(3)=i-1
	  i_t(3)=j+1

	  i_s(4)=i-2
	  i_t(4)=j-1

	  i_s(5)=i-1
	  i_t(5)=j-2

	  i_s(6)=i+1
	  i_t(6)=j-1 

	    do k=1,6
	    if (i_s(k).lt.0          ) i_s(k)=i_s(k)+grid_size
	    if (i_s(k).gt.grid_size-1) i_s(k)=i_s(k)-grid_size
	    if (i_t(k).lt.0          ) i_t(k)=i_t(k)+grid_size
	    if (i_t(k).gt.grid_size-1) i_t(k)=i_t(k)-grid_size
	    nnn_grid(k,site)=grid(i_s(k),i_t(k))
	    end do
	  end do
	end do
        RETURN
        END

	SUBROUTINE SET_UP_NNNN_GRID           
        integer site,i_s(6),i_t(6)
	include 'model.inc'
        Integer i,j,k

	do i=0,grid_size-1
	  do j=0,grid_size-1
	  site=grid(i,j)	

	  i_s(1)=i+2
	  i_t(1)=j+0

	  i_s(2)=i+2
	  i_t(2)=j+2

	  i_s(3)=i+0
	  i_t(3)=j+2

	  i_s(4)=i-2
	  i_t(4)=j-0

	  i_s(5)=i-2
	  i_t(5)=j-2

	  i_s(6)=i-0
	  i_t(6)=j-2 

	    do k=1,6
	    if (i_s(k).lt.0          ) i_s(k)=i_s(k)+grid_size
	    if (i_s(k).gt.grid_size-1) i_s(k)=i_s(k)-grid_size
	    if (i_t(k).lt.0          ) i_t(k)=i_t(k)+grid_size
	    if (i_t(k).gt.grid_size-1) i_t(k)=i_t(k)-grid_size
	    nnnn_grid(k,site)=grid(i_s(k),i_t(k))
	    end do
	  end do
	end do
        RETURN
        END
